IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[IIS_qLookup]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[IIS_qLookup]
GO
-- =======================================================================================================================================
-- Author:		Philip Brassington
-- Create date: 10/11/2015
-- Description:	Gets a standard dynamic list for a drop down / combo or Lookup
-- Called By:	eQuipCloud Training Project but will be universal / used by many
-- Notes:
--		Based on the e-Quip proc of the same name with the restrictions code removed
-- =======================================================================================================================================
-- History:
-- v1.00	10/11/2015	Philip Brassington		Created
-- =======================================================================================================================================


CREATE PROC [dbo].[IIS_qLookup] 
	@UserId VARCHAR(50),
	@LookupId INT,
	@SearchText VARCHAR(1000),
	@RestrictionName1 VARCHAR(100),
	@RestrictionValue1 VARCHAR(1000),
	@RestrictionName2 VARCHAR(100),
	@RestrictionValue2 VARCHAR(1000),
	@RestrictionName3 VARCHAR(100),
	@RestrictionValue3 VARCHAR(1000),
	@RestrictionName4 VARCHAR(100),
	@RestrictionValue4 VARCHAR(1000),
	@RestrictionName5 VARCHAR(100),
	@RestrictionValue5 VARCHAR(1000),
	@RestrictionName6 VARCHAR(100),
	@RestrictionValue6 VARCHAR(1000),
	@RestrictionName7 VARCHAR(100),
	@RestrictionValue7 VARCHAR(1000),
	@RestrictionName8 VARCHAR(100),
	@RestrictionValue8 VARCHAR(1000),
	@RestrictionName9 VARCHAR(100),
	@RestrictionValue9 VARCHAR(1000),
	@RestrictionName10 VARCHAR(100),
	@RestrictionValue10 VARCHAR(1000)
AS
BEGIN
	
	--get the sql for this lookup
	DECLARE @Sql VARCHAR(8000)
	SELECT @Sql = CONVERT(VARCHAR(8000), [SQL])
	FROM IIS_ExplorerLookup
	WHERE [Id] = @LookupId


	--
	-- Build the restrictions Sql
	DECLARE @Restrictions VARCHAR(8000)
	DECLARE @Tmp VARCHAR(1000)
	SELECT @Restrictions = ''

	IF ISNULL(@RestrictionName1, '') != ''
	BEGIN
		SELECT TOP 1 @Tmp = Sql 
		FROM ExplorerLookupRestriction
		WHERE LookupId = @LookupId AND [Name] = @RestrictionName1

		IF ISNULL(@Tmp, '') != '' AND ISNULL(@RestrictionValue1, '') != ''
			SELECT @Tmp = REPLACE( @Tmp, '||PLACEHOLDER||', @RestrictionValue1)

		IF ISNULL(@Tmp, '') != ''
			SELECT @Restrictions = '(' + @Tmp + ')'
	END

	IF ISNULL(@RestrictionName2, '') != ''
	BEGIN
		SELECT TOP 1 @Tmp = Sql 
		FROM ExplorerLookupRestriction
		WHERE LookupId = @LookupId AND [Name] = @RestrictionName2

		IF ISNULL(@Tmp, '') != '' AND ISNULL(@RestrictionValue2, '') != ''
			SELECT @Tmp = REPLACE( @Tmp, '||PLACEHOLDER||', @RestrictionValue2)

		IF ISNULL(@Tmp, '') != ''
		BEGIN
			IF ISNULL(@Restrictions, '') = '' 
				SELECT @Restrictions = '(' + @Tmp + ')'
			ELSE
				SELECT @Restrictions = @Restrictions + ' AND (' + @Tmp + ')'
		END
	END

	IF ISNULL(@RestrictionName3, '') != ''
	BEGIN
		SELECT TOP 1 @Tmp = Sql 
		FROM ExplorerLookupRestriction
		WHERE LookupId = @LookupId AND [Name] = @RestrictionName3

		IF ISNULL(@Tmp, '') != '' AND ISNULL(@RestrictionValue3, '') != ''
			SELECT @Tmp = REPLACE( @Tmp, '||PLACEHOLDER||', @RestrictionValue3)

		IF ISNULL(@Tmp, '') != ''
		BEGIN
			IF ISNULL(@Restrictions, '') = '' 
				SELECT @Restrictions = '(' + @Tmp + ')'
			ELSE
				SELECT @Restrictions = @Restrictions + ' AND (' + @Tmp + ')'
		END
	END

	IF ISNULL(@RestrictionName4, '') != ''
	BEGIN
		SELECT TOP 1 @Tmp = Sql 
		FROM ExplorerLookupRestriction
		WHERE LookupId = @LookupId AND [Name] = @RestrictionName4

		IF ISNULL(@Tmp, '') != '' AND ISNULL(@RestrictionValue4, '') != ''
			SELECT @Tmp = REPLACE( @Tmp, '||PLACEHOLDER||', @RestrictionValue4)

		IF ISNULL(@Tmp, '') != ''
		BEGIN
			IF ISNULL(@Restrictions, '') = '' 
				SELECT @Restrictions = '(' + @Tmp + ')'
			ELSE
				SELECT @Restrictions = @Restrictions + ' AND (' + @Tmp + ')'
		END
	END

	IF ISNULL(@RestrictionName5, '') != ''
	BEGIN
		SELECT TOP 1 @Tmp = Sql 
		FROM ExplorerLookupRestriction
		WHERE LookupId = @LookupId AND [Name] = @RestrictionName5

		IF ISNULL(@Tmp, '') != '' AND ISNULL(@RestrictionValue5, '') != ''
			SELECT @Tmp = REPLACE( @Tmp, '||PLACEHOLDER||', @RestrictionValue5)

		IF ISNULL(@Tmp, '') != ''
		BEGIN
			IF ISNULL(@Restrictions, '') = '' 
				SELECT @Restrictions = '(' + @Tmp + ')'
			ELSE
				SELECT @Restrictions = @Restrictions + ' AND (' + @Tmp + ')'
		END
	END

	IF ISNULL(@RestrictionName6, '') != ''
	BEGIN
		SELECT TOP 1 @Tmp = Sql 
		FROM ExplorerLookupRestriction
		WHERE LookupId = @LookupId AND [Name] = @RestrictionName6

		IF ISNULL(@Tmp, '') != '' AND ISNULL(@RestrictionValue6, '') != ''
			SELECT @Tmp = REPLACE( @Tmp, '||PLACEHOLDER||', @RestrictionValue6)

		IF ISNULL(@Tmp, '') != ''
		BEGIN
			IF ISNULL(@Restrictions, '') = '' 
				SELECT @Restrictions = '(' + @Tmp + ')'
			ELSE
				SELECT @Restrictions = @Restrictions + ' AND (' + @Tmp + ')'
		END
	END

	IF ISNULL(@RestrictionName7, '') != ''
	BEGIN
		SELECT TOP 1 @Tmp = Sql 
		FROM ExplorerLookupRestriction
		WHERE LookupId = @LookupId AND [Name] = @RestrictionName7

		IF ISNULL(@Tmp, '') != '' AND ISNULL(@RestrictionValue7, '') != ''
			SELECT @Tmp = REPLACE( @Tmp, '||PLACEHOLDER||', @RestrictionValue7)

		IF ISNULL(@Tmp, '') != ''
		BEGIN
			IF ISNULL(@Restrictions, '') = '' 
				SELECT @Restrictions = '(' + @Tmp + ')'
			ELSE
				SELECT @Restrictions = @Restrictions + ' AND (' + @Tmp + ')'
		END
	END

	IF ISNULL(@RestrictionName8, '') != ''
	BEGIN
		SELECT TOP 1 @Tmp = Sql 
		FROM ExplorerLookupRestriction
		WHERE LookupId = @LookupId AND [Name] = @RestrictionName8

		IF ISNULL(@Tmp, '') != '' AND ISNULL(@RestrictionValue8, '') != ''
			SELECT @Tmp = REPLACE( @Tmp, '||PLACEHOLDER||', @RestrictionValue8)

		IF ISNULL(@Tmp, '') != ''
		BEGIN
			IF ISNULL(@Restrictions, '') = '' 
				SELECT @Restrictions = '(' + @Tmp + ')'
			ELSE
				SELECT @Restrictions = @Restrictions + ' AND (' + @Tmp + ')'
		END
	END

	IF ISNULL(@RestrictionName9, '') != ''
	BEGIN
		SELECT TOP 1 @Tmp = Sql 
		FROM ExplorerLookupRestriction
		WHERE LookupId = @LookupId AND [Name] = @RestrictionName9

		IF ISNULL(@Tmp, '') != '' AND ISNULL(@RestrictionValue9, '') != ''
			SELECT @Tmp = REPLACE( @Tmp, '||PLACEHOLDER||', @RestrictionValue9)

		IF ISNULL(@Tmp, '') != ''
		BEGIN
			IF ISNULL(@Restrictions, '') = '' 
				SELECT @Restrictions = '(' + @Tmp + ')'
			ELSE
				SELECT @Restrictions = @Restrictions + ' AND (' + @Tmp + ')'
		END
	END

	IF ISNULL(@RestrictionName10, '') != ''
	BEGIN
		SELECT TOP 1 @Tmp = Sql 
		FROM ExplorerLookupRestriction
		WHERE LookupId = @LookupId AND [Name] = @RestrictionName10

		IF ISNULL(@Tmp, '') != '' AND ISNULL(@RestrictionValue10, '') != ''
			SELECT @Tmp = REPLACE( @Tmp, '||PLACEHOLDER||', @RestrictionValue10)

		IF ISNULL(@Tmp, '') != ''
		BEGIN
			IF ISNULL(@Restrictions, '') = '' 
				SELECT @Restrictions = '(' + @Tmp + ')'
			ELSE
				SELECT @Restrictions = @Restrictions + ' AND (' + @Tmp + ')'
		END
	END

	IF ISNULL(@Restrictions, '') != ''
	BEGIN
		SET @Sql = @Sql + ' WHERE ' + @Restrictions
	END

	--
	-- Replace Sql placeholder with the search text
	SELECT @Sql = REPLACE( @Sql, '||PLACEHOLDER||', @SearchText )

	--
	-- Execute the Sql
	EXEC(@Sql)
END




GO


