IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[qIISUpdateMicrositeSetting]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[qIISUpdateMicrositeSetting]
GO

/* 
===========================================================
 Author:		Peter Bush
 Create date:	26th February 2018
 Description:	Updates the specfic microstite settings with the given value.
 Called By:		e-Quip Training / Ward Users Microsite
 =========================================================
 History:
 v1.00	26th February 2018	Peter Bush Created
 =========================================================
*/
CREATE PROC [dbo].[qIISUpdateMicrositeSetting]  
	@MicrositeId int,
	@SettingName VARCHAR(50),
	@SettingValue VARCHAR(MAX)
AS
BEGIN
	
	IF @MicrositeId IS NOT NULL AND @SettingName IS NOT NULL AND @SettingValue IS NOT NULL
	BEGIN
		IF NOT EXISTS (SELECT * FROM IIS_MicrositeSettings WHERE MicrositeId = @MicrositeId AND SettingName = @SettingName)
		BEGIN
			INSERT INTO IIS_MicrositeSettings
			(MicrositeId, SettingName, SettingValue)
			VALUES
			(@MicrositeId, @SettingName, @SettingValue)
		END		
		ELSE
		BEGIN
			UPDATE IIS_MicrositeSettings SET SettingValue = @SettingValue WHERE MicrositeId = @MicrositeId AND SettingName = @SettingName
		END
	END
END
GO


