IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[qIIS_GetBaseFiltersByUserId]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[qIIS_GetBaseFiltersByUserId]
GO
-- =======================================================================================================================================
-- Author:		Philip Brassington
-- Create date: 21/09/2015
-- Description:	Returns base filters for a given user and view
-- Called By:	eQuipCloud TBS Project but will be universal
-- Notes:
-- =======================================================================================================================================
-- History:
-- v1.00	21/09/2015	Philip Brassington		Created
-- =======================================================================================================================================
CREATE PROCEDURE [dbo].[qIIS_GetBaseFiltersByUserId]
	@UserId VARCHAR(50), 
	@ViewId INT
AS
BEGIN
	SET NOCOUNT ON;
	
	DECLARE @GroupId VARCHAR(50), @RoleId VARCHAR(50)

	SELECT TOP 1 @GroupId = ug.GroupId, @RoleId = gr.RoleId
	FROM [user] u
	INNER JOIN UserGrouplk ug ON ug.UserId = u.UserId
	INNER JOIN GroupRole gr ON ug.GroupId = gr.GroupId 
	WHERE u.UserId = @UserId
	

	SELECT CONVERT(VARCHAR(8000), ExplorerFilter.Filter) AS Filter, ExplorerFilter.FilterType
	FROM DefaultFilter
	INNER JOIN ExplorerFilter ON ExplorerFilter.ExplorerFilterId = DefaultFilter.FilterId
	WHERE DefaultFilter.ViewId = @ViewId AND ((ApplyToId = @UserId AND Mode ='U') OR (ApplyToId = @GroupId AND Mode = 'G') OR (ApplyToId = @RoleId AND Mode = 'R'))
	UNION
	SELECT CONVERT(VARCHAR(8000), ExplorerFilter.Filter) AS Filter, ExplorerFilter.FilterType 
	FROM ExplorerFilter 
	WHERE ViewId = @ViewId AND UserId = @UserId AND [Default] = 1

END

GO


