IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[qIIS_UpdateCompetenceGroupTNATrainerAssessor]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[qIIS_UpdateCompetenceGroupTNATrainerAssessor]
GO
/* 
===========================================================
 Author:		Philip Brassington
 Create date:	12th April 2014
 Description:	Updates the trainer / assessor only		
 Called By:		Equip.EquipmentTraining, AssesmentTrainer.aspx
 =========================================================
 History:
 v1.00	12th April 2014	Philip Brassington Created
 =========================================================
*/

create PROC [dbo].[qIIS_UpdateCompetenceGroupTNATrainerAssessor]
	@CompetenceGroupTNAId NVARCHAR(50),
	@TrainerId NVARCHAR(50),
	@AssessorID NVARCHAR(50)
AS
BEGIN
	--
	-- Return Values:
	--	0  - Success
	--	1  - No Pk
	--	2  - Record not found

	SET NOCOUNT ON

	IF ISNULL( @CompetenceGroupTNAId, '') = ''
	   RETURN 1

	IF NOT EXISTS (SELECT * FROM dbo.CompetenceGroupTNA WHERE CompetenceGroupTNAId = @CompetenceGroupTNAId)
	   RETURN 2

	UPDATE dbo.CompetenceGroupTNA
	SET TrainerId = @TrainerId,
        AssessorId = @AssessorId
	WHERE CompetenceGroupTNAId = @CompetenceGroupTNAId

	RETURN 0
END
GO


