-- =======================================================================================================================================
-- Author:		Peter Bush
-- Create date: 26/02/2018
-- Description:	Table to store all managers of a competence group user via the e-Quip Microsite
-- Called By:	eQuipCloud Training Only
-- =======================================================================================================================================
-- History:
-- v1.00	26/02/2018	Peter Bush		Created 
-- =======================================================================================================================================
IF OBJECT_ID(N'dbo.IISCompetenceGroupManagers', N'U') IS NULL 
BEGIN   
	CREATE TABLE [dbo].[IISCompetenceGroupManagers](
	[CompetenceGroupManagerId] [nvarchar](50) NOT NULL,
	[CompetenceGroupId] [nvarchar](50) NOT NULL,
	[PersonnelId] [nvarchar](50) NOT NULL,
	[Inactive] [bit] NULL,
	 CONSTRAINT [PK_CompetenceGroupManagers] PRIMARY KEY CLUSTERED 
	(
		[CompetenceGroupManagerId] ASC
	)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, FILLFACTOR = 90) ON [PRIMARY]
	) ON [PRIMARY]
END
GO
