IF NOT EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[dbo].[IIS_CompGroupSummaryForSimple]'))
    exec('CREATE VIEW [dbo].[IIS_CompGroupSummaryForSimple] AS SELECT '''' AS Col1 ')
GO
-- =======================================================================================================================================
-- Author:		Philip Brassington
-- Create date: 24/11/2017
-- Description:	Get the summary grid data for the competence group
-- Called By:	eQuipCloud Training Simple Interface Only
-- Notes:
--		http://192.168.0.3:8090/display/DATACONV/Query+Information+For+IIS_GetCompGroupSummaryForSimple
-- =======================================================================================================================================
-- History:
-- v1.00	24/11/2017	Philip Brassington		Created
-- v1.01	24/11/2017	Philip Brassington		Changed to left join onto personnel, added competencegroupid
-- v1.02	20/08/2020	Jack Foulkes			View has been updated to simplify data that is returned
-- =======================================================================================================================================
ALTER VIEW [dbo].[IIS_CompGroupSummaryForSimple]
AS
SELECT 
	CompetenceGroupId, CompetenceGroupShortName, LocationShortName,

	(
		SELECT COUNT(*) FROM CompetenceGroupPersonnel CGP
		WHERE CGP.CompetenceGroupId = CG.CompetenceGroupId
	) AS StaffCount

FROM CompetenceGroup CG
LEFT JOIN [Location] 
	ON CG.LocationId = [Location].LocationId