IF NOT EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[dbo].[IIS_ModelKeyTrainers]'))
    exec('CREATE VIEW [dbo].[IIS_ModelKeyTrainers] AS SELECT '''' AS Col1 ')
GO
-- =======================================================================================================================================
-- Author:		Jack Foulkes
-- Create date: 13/11/2020
-- Description:	Gets a list of all staff that are trainers or higher
-- Called By:	eQuipCloud Training Project Only
-- Notes:
-- =======================================================================================================================================
-- History:
-- v1.00	13/11/2020 - Jack Foulkes
--				Created
-- =======================================================================================================================================

ALTER VIEW [dbo].[IIS_ModelKeyTrainers]
AS
	SELECT DISTINCT ModelShortName, P.PersonnelShortName, Tel1 AS Telephone, Email
	FROM vsCompetenceGroupTNA TNA
	LEFT JOIN Personnel P
		ON P.PersonnelId = TNA.PersonnelId
	WHERE ISNULL(TNA.AttainedCompetenceTypeClassId, 0) >= 10