IF NOT EXISTS (SELECT * FROM sys.objects WHERE type = 'P' AND OBJECT_ID = OBJECT_ID('[dbo].[IISGetTNAReportData]'))
   EXEC('CREATE PROCEDURE [dbo].[IISGetTNAReportData] AS BEGIN SET NOCOUNT ON; END')
GO

--
--===========================================================
-- Author:		Philip Brassington
-- Create date:	26th February 2018
-- Description:	Gets all Training TNA's for this personnel in this group
-- Called By:		e-Quip Training Microsite
-- =========================================================
-- History:
-- v1.00	26th February 2018	Philip Brassington Created
-- =========================================================
--
ALTER PROC [dbo].[IISGetTNAReportData]  
	@PersonnelId VARCHAR(MAX),
	@CompetenceGroupId VARCHAR(MAX) = null
AS
BEGIN
	
	IF @PersonnelId IS NOT NULL AND @CompetenceGroupId IS NOT NULL
	BEGIN
		SELECT COUNT(CompetenceGroupId)
		FROM vsCompetenceGroupTNA
		WHERE CompetenceGroupId = @CompetenceGroupId;
	END
END

GO


