IF NOT EXISTS (SELECT * FROM sys.objects WHERE type = 'P' AND OBJECT_ID = OBJECT_ID('[dbo].[IIS_ActivateTrainingPersonnel]'))
   EXEC('CREATE PROCEDURE [dbo].[IIS_ActivateTrainingPersonnel] AS BEGIN SET NOCOUNT ON; END')
GO
-- =======================================================================================================================================
-- Author:		Jack Foulkes
-- Create date: 26/08/2020
-- Description:	Bulk activate training users.
-- Called By:	eQuipCloud Training Only
-- Notes:
-- =======================================================================================================================================
-- History:
--	26/08/2020 - Jack Foulkes
--		Created
-- =======================================================================================================================================
ALTER PROC [dbo].[IIS_ActivateTrainingPersonnel]
AS
BEGIN

	SET NOCOUNT ON

	INSERT INTO IIS_TrainingUser
	SELECT NEWID(), P.PersonnelId, 'TdILezw8UUcU0vGu5/kz8A==', 'rzKCZptJHnE8Y+O36UjuZ1u6835x/1XsscX8TiKIvzM=' , NULL, 0
	FROM (SELECT DISTINCT PersonnelId, EMail, Payroll, Inactive FROM Personnel) P
	INNER JOIN CompetenceGroupPersonnel CGP
		ON CGP.PersonnelId = P.PersonnelId
	WHERE 
	P.PersonnelId NOT IN
	(
		SELECT PersonnelId FROM IIS_TrainingUser
	) AND
	P.EMail IS NOT NULL AND
	P.Payroll IS NOT NULL AND
	ISNULL(P.Inactive, 0) != 1

	RETURN 0

END
GO