IF NOT EXISTS (SELECT * FROM sys.objects WHERE type = 'P' AND OBJECT_ID = OBJECT_ID('[dbo].[IIS_qTNAGridExportCrossTab]'))
   EXEC('CREATE PROCEDURE [dbo].[IIS_qTNAGridExportCrossTab] AS BEGIN SET NOCOUNT ON; END')
GO
--
-- =======================================================================================================================================
-- Author:		Philip Brassington
-- Create date: 24th May 2017
-- Description:	Returns Data for Export from TNA Grid to Cross Tab Report
-- Called By:	eQuipCloud Training
-- Notes:
--		Based on the e-Quip 3.6 proc qTNACrossTab
-- =======================================================================================================================================
-- History:
-- v1.00	24th May 2017	Philip Brassington		Created
-- =======================================================================================================================================
ALTER PROC [dbo].[IIS_qTNAGridExportCrossTab]
		@ModelIds VARCHAR(MAX), 
		@PersonnelIds VARCHAR(MAX)
AS
BEGIN
	--
	-- Create the results table
	CREATE TABLE #RetVal 
	(
	PersonnelId VARCHAR(50) COLLATE database_default NOT NULL,
	ModelId1 VARCHAR(50) COLLATE database_default NULL,
	ModelName1 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel1 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel1 INT,
	AchievedLevel1 INT,
	Ok1 BIT,
	ModelId2 VARCHAR(50) COLLATE database_default NULL,
	ModelName2 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel2 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel2 INT,
	AchievedLevel2 INT,
	Ok2 BIT,
	ModelId3 VARCHAR(50) COLLATE database_default NULL,
	ModelName3 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel3 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel3 INT,
	AchievedLevel3 INT,
	Ok3 BIT,
	ModelId4 VARCHAR(50) COLLATE database_default NULL,
	ModelName4 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel4 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel4 INT,
	AchievedLevel4 INT,
	Ok4 BIT,
	ModelId5 VARCHAR(50) COLLATE database_default NULL,
	ModelName5 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel5 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel5 INT,
	AchievedLevel5 INT,
	Ok5 BIT,
	ModelId6 VARCHAR(50) COLLATE database_default NULL,
	ModelName6 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel6 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel6 INT,
	AchievedLevel6 INT,
	Ok6 BIT,
	ModelId7 VARCHAR(50) COLLATE database_default NULL,
	ModelName7 VARCHAR(255) NULL,
--	RiskLevel7 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel7 INT,
	AchievedLevel7 INT,
	Ok7 BIT,
	ModelId8 VARCHAR(50) COLLATE database_default NULL,
	ModelName8 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel8 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel8 INT,
	AchievedLevel8 INT,
	Ok8 BIT,
	ModelId9 VARCHAR(50) COLLATE database_default NULL,
	ModelName9 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel9 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel9 INT,
	AchievedLevel9 INT,
	Ok9 BIT,
	ModelId10 VARCHAR(50) COLLATE database_default NULL,
	ModelName10 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel10 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel10 INT,
	AchievedLevel10 INT,
	Ok10 BIT,

	ModelId11 VARCHAR(50) COLLATE database_default NULL,
	ModelName11 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel11 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel11 INT,
	AchievedLevel11 INT,
	Ok11 BIT,
	ModelId12 VARCHAR(50) COLLATE database_default NULL,
	ModelName12 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel12 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel12 INT,
	AchievedLevel12 INT,
	Ok12 BIT,
	ModelId13 VARCHAR(50) COLLATE database_default NULL,
	ModelName13 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel13 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel13 INT,
	AchievedLevel13 INT,
	Ok13 BIT,
	ModelId14 VARCHAR(50) COLLATE database_default NULL,
	ModelName14 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel14 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel14 INT,
	AchievedLevel14 INT,
	Ok14 BIT,
	ModelId15 VARCHAR(50) COLLATE database_default NULL,
	ModelName15 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel15 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel15 INT,
	AchievedLevel15 INT,
	Ok15 BIT,
	ModelId16 VARCHAR(50) COLLATE database_default NULL,
	ModelName16 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel16 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel16 INT,
	AchievedLevel16 INT,
	Ok16 BIT,
	ModelId17 VARCHAR(50) COLLATE database_default NULL,
	ModelName17 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel17 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel17 INT,
	AchievedLevel17 INT,
	Ok17 BIT,
	ModelId18 VARCHAR(50) COLLATE database_default NULL,
	ModelName18 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel18 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel18 INT,
	AchievedLevel18 INT,
	Ok18 BIT,
	ModelId19 VARCHAR(50) COLLATE database_default NULL,
	ModelName19 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel19 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel19 INT,
	AchievedLevel19 INT,
	Ok19 BIT,
	ModelId20 VARCHAR(50) COLLATE database_default NULL,
	ModelName20 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel20 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel20 INT,
	AchievedLevel20 INT,
	Ok20 BIT,

	ModelId21 VARCHAR(50) COLLATE database_default NULL,
	ModelName21 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel21 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel21 INT,
	AchievedLevel21 INT,
	Ok21 BIT,
	ModelId22 VARCHAR(50) COLLATE database_default NULL,
	ModelName22 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel22 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel22 INT,
	AchievedLevel22 INT,
	Ok22 BIT,
	ModelId23 VARCHAR(50) COLLATE database_default NULL,
	ModelName23 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel23 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel23 INT,
	AchievedLevel23 INT,
	Ok23 BIT,
	ModelId24 VARCHAR(50) COLLATE database_default NULL,
	ModelName24 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel24 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel24 INT,
	AchievedLevel24 INT,
	Ok24 BIT,
	ModelId25 VARCHAR(50) COLLATE database_default NULL,
	ModelName25 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel25 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel25 INT,
	AchievedLevel25 INT,
	Ok25 BIT,
	ModelId26 VARCHAR(50) COLLATE database_default NULL,
	ModelName26 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel26 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel26 INT,
	AchievedLevel26 INT,
	Ok26 BIT,
	ModelId27 VARCHAR(50) COLLATE database_default NULL,
	ModelName27 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel27 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel27 INT,
	AchievedLevel27 INT,
	Ok27 BIT,
	ModelId28 VARCHAR(50) COLLATE database_default NULL,
	ModelName28 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel28 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel28 INT,
	AchievedLevel28 INT,
	Ok28 BIT,
	ModelId29 VARCHAR(50) COLLATE database_default NULL,
	ModelName29 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel29 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel29 INT,
	AchievedLevel29 INT,
	Ok29 BIT,
	ModelId30 VARCHAR(50) COLLATE database_default NULL,
	ModelName30 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel30 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel30 INT,
	AchievedLevel30 INT,
	Ok30 BIT,

	ModelId31 VARCHAR(50) COLLATE database_default NULL,
	ModelName31 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel31 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel31 INT,
	AchievedLevel31 INT,
	Ok31 BIT,
	ModelId32 VARCHAR(50) COLLATE database_default NULL,
	ModelName32 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel32 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel32 INT,
	AchievedLevel32 INT,
	Ok32 BIT,
	ModelId33 VARCHAR(50) COLLATE database_default NULL,
	ModelName33 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel33 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel33 INT,
	AchievedLevel33 INT,
	Ok33 BIT,
	ModelId34 VARCHAR(50) COLLATE database_default NULL,
	ModelName34 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel34 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel34 INT,
	AchievedLevel34 INT,
	Ok34 BIT,
	ModelId35 VARCHAR(50) COLLATE database_default NULL,
	ModelName35 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel35 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel35 INT,
	AchievedLevel35 INT,
	Ok35 BIT,
	ModelId36 VARCHAR(50) COLLATE database_default NULL,
	ModelName36 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel36 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel36 INT,
	AchievedLevel36 INT,
	Ok36 BIT,
	ModelId37 VARCHAR(50) COLLATE database_default NULL,
	ModelName37 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel37 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel37 INT,
	AchievedLevel37 INT,
	Ok37 BIT,
	ModelId38 VARCHAR(50) COLLATE database_default NULL,
	ModelName38 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel38 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel38 INT,
	AchievedLevel38 INT,
	Ok38 BIT,
	ModelId39 VARCHAR(50) COLLATE database_default NULL,
	ModelName39 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel39 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel39 INT,
	AchievedLevel39 INT,
	Ok39 BIT,
	ModelId40 VARCHAR(50) COLLATE database_default NULL,
	ModelName40 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel40 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel40 INT,
	AchievedLevel40 INT,
	Ok40 BIT,

	ModelId41 VARCHAR(50) COLLATE database_default NULL,
	ModelName41 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel41 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel41 INT,
	AchievedLevel41 INT,
	Ok41 BIT,
	ModelId42 VARCHAR(50) COLLATE database_default NULL,
	ModelName42 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel42 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel42 INT,
	AchievedLevel42 INT,
	Ok42 BIT,
	ModelId43 VARCHAR(50) COLLATE database_default NULL,
	ModelName43 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel43 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel43 INT,
	AchievedLevel43 INT,
	Ok43 BIT,
	ModelId44 VARCHAR(50) COLLATE database_default NULL,
	ModelName44 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel44 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel44 INT,
	AchievedLevel44 INT,
	Ok44 BIT,
	ModelId45 VARCHAR(50) COLLATE database_default NULL,
	ModelName45 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel45 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel45 INT,
	AchievedLevel45 INT,
	Ok45 BIT,
	ModelId46 VARCHAR(50) COLLATE database_default NULL,
	ModelName46 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel46 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel46 INT,
	AchievedLevel46 INT,
	Ok46 BIT,
	ModelId47 VARCHAR(50) COLLATE database_default NULL,
	ModelName47 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel47 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel47 INT,
	AchievedLevel47 INT,
	Ok47 BIT,
	ModelId48 VARCHAR(50) COLLATE database_default NULL,
	ModelName48 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel48 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel48 INT,
	AchievedLevel48 INT,
	Ok48 BIT,
	ModelId49 VARCHAR(50) COLLATE database_default NULL,
	ModelName49 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel49 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel49 INT,
	AchievedLevel49 INT,
	Ok49 BIT,
	ModelId50 VARCHAR(50) COLLATE database_default NULL,
	ModelName50 VARCHAR(255) COLLATE database_default NULL,
--	RiskLevel50 VARCHAR(50) COLLATE database_default NULL,
	RequiredLevel50 INT,
	AchievedLevel50 INT,
	Ok50 BIT,

	RequiredCount INT,
	AchievedCount INT )
	
	DECLARE @Sql NVARCHAR(4000)

---------------------------------------------------------------------------------------------------------
--	1. GET A LIST OF MODELS
---------------------------------------------------------------------------------------------------------
	DECLARE CsrModel CURSOR SCROLL READ_ONLY FOR
	SELECT DISTINCT TOP 50 Model.ModelId, ModelShortName, CategoryShortName,
		ISNULL(RL2.RiskLevelShortName, ISNULL(RL1.RiskLevelShortName, '')) AS RiskLevel,
		CASE 
			WHEN RL2.RiskLevelClassId = 'HIGH'
				THEN 0
			WHEN RL2.RiskLevelClassId = 'MEDIUM'
				THEN 1
			WHEN RL2.RiskLevelClassId = 'LOW'
				THEN 2
			WHEN RL2.RiskLevelClassId IS NULL AND RL1.RiskLevelClassId = 'HIGH'
				THEN 0
			WHEN RL2.RiskLevelClassId IS NULL AND RL1.RiskLevelClassId = 'MEDIUM'
				THEN 1
			WHEN RL2.RiskLevelClassId IS NULL AND RL1.RiskLevelClassId = 'LOW'
				THEN 2
			ELSE 3
		END AS RiskLevelVal
	FROM PersonnelCompetence AS PC
		INNER JOIN Personnel AS P1
			ON PC.PersonnelId = P1.PersonnelId
		INNER JOIN Model
			ON PC.ModelId = Model.ModelId
		LEFT JOIN RiskLevel AS RL1
			ON Model.RiskLevelId = RL1.RiskLevelId
		LEFT JOIN RiskLevel AS RL2
			ON Model.TrainingRiskId = RL2.RiskLevelId
		LEFT JOIN Category
			ON Model.CategoryId = Category.CategoryId
	WHERE ISNULL(PC.Inactive, 0) != 1 AND
		ISNULL(P1.Inactive, 0) != 1 AND
		ISNULL(Model.Inactive, 0) != 1 AND
		ISNULL(LongTermLeave, 0) = 0 AND
		ISNULL(MaternityLeave, 0) = 0 AND
		Model.ModelId IN (SELECT value FROM StringListToTable(@ModelIds))
	ORDER BY  RiskLevelVal, RiskLevel, ModelShortName

	OPEN CsrModel

---------------------------------------------------------------------------------------------------------
--	2. GET A LIST OF PEOPLE
---------------------------------------------------------------------------------------------------------

	--
	-- FOREACH Person in the report ...
	DECLARE CsrPerson CURSOR READ_ONLY FOR
	SELECT DISTINCT PersonnelId, PersonnelShortName
	FROM vsCompetenceGroupTNA
		LEFT JOIN Branch
			ON vsCompetenceGroupTNA.BranchId = Branch.BranchId
		LEFT JOIN Organisation
			ON Branch.OrganisationId = Organisation.OrganisationId
		LEFT JOIN Location
			ON vsCompetenceGroupTNA.LocationId = Location.LocationId
		LEFT JOIN [Site]
			ON Location.SiteId = [Site].SiteId
	WHERE ISNULL(PersonnelShortName, '') != '' AND
		ISNULL(vsCompetenceGroupTNA.Inactive, 0) != 1 AND 
		vsCompetenceGroupTNA.PersonnelId IN (SELECT value FROM StringListToTable(@PersonnelIds))
	ORDER BY PersonnelShortName

	OPEN CsrPerson

	DECLARE @PersonnelId VARCHAR(50)
	DECLARE @PersonnelShortName VARCHAR(255)
	DECLARE @PersonReqdCount INT
	DECLARE @PersonAttndCount INT
	
	FETCH NEXT FROM CsrPerson 
	INTO @PersonnelId, @PersonnelShortName

	--
	-- FOREACH Person ...
	DECLARE @PersonnelNo INT
	SET @PersonnelNo  = 1

	WHILE @@FETCH_STATUS = 0
	BEGIN
		--
		-- Add the person to the output table
		INSERT INTO #RetVal
			(PersonnelId) 
		VALUES
			(@PersonnelId)

		--
		-- Zero counters
		SET @PersonReqdCount = 0
		SET @PersonAttndCount = 0

		--
		-- Add each model for this person to the output table
		DECLARE @ModelId VARCHAR(50)
		DECLARE @ModelShortName VARCHAR(255)
		DECLARE @CategoryShortName VARCHAR(255)
		DECLARE @RiskLevelVal INT
		DECLARE @RiskLevel VARCHAR(255)

		FETCH FIRST FROM CsrModel 
		INTO @ModelId, @ModelShortName, @CategoryShortName, @RiskLevel, @RiskLevelVal

		--
		-- FOREACH Model ..
		DECLARE @ModelNo INT
		SET @ModelNo = 1

		WHILE @@FETCH_STATUS = 0
		BEGIN
			--
			-- Find requirements/achievements for this person/model
			DECLARE @Reqd VARCHAR(50)
			DECLARE @Attnd VARCHAR(50)
			DECLARE @iReqd INT
			DECLARE @iAttnd INT
			DECLARE @Ok BIT
	
			SET @Reqd = NULL
			SET @Attnd = NULL
			SET @Ok = 0

			SELECT @Reqd = CT1.CompetenceTypeClassId, @Attnd = CT2.CompetenceTypeClassId 
			FROM PersonnelCompetence AS PC
				LEFT JOIN CompetenceType AS CT1
					ON PC.RequiredCompetenceTypeId = CT1.CompetenceTypeId
				LEFT JOIN CompetenceType AS CT2
					ON PC.AttainedCompetenceTypeId = CT2.CompetenceTypeId
			WHERE PersonnelId = @PersonnelId AND
				ModelId = @ModelId

			--
			-- Get requirements/achievements as INTs
			IF @Reqd IS NOT NULL
				SET @iReqd = CAST(@Reqd AS INT)
			ELSE
				SET @iReqd = 0

			IF @Attnd IS NOT NULL
				SET @iAttnd = CAST(@Attnd AS INT)
			ELSE
				SET @iAttnd = 0

			IF @iReqd > 0
			BEGIN
				--
				-- Some level of competence is required
				SET @PersonReqdCount = @PersonReqdCount + 1

				IF @iAttnd >= @iReqd
				BEGIN
					--
					-- Required competence has been achieved
					SET @Ok = 1
					SET @PersonAttndCount = @PersonAttndCount + 1
				END
			END
			ELSE
			BEGIN
				SET @Ok = 1
			END

			SET @Sql = N'UPDATE #RetVal
				SET RequiredLevel' + LTRIM(RTRIM(CONVERT(VARCHAR(3), @ModelNo))) + ' = @iReqd,
					AchievedLevel' + LTRIM(RTRIM(CONVERT(VARCHAR(3), @ModelNo))) + ' = @iAttnd,
					Ok' + LTRIM(RTRIM(CONVERT(VARCHAR(3), @ModelNo))) + ' = @Ok
				WHERE PersonnelId = @PersonnelId'

			EXEC SP_EXECUTESQL @Sql,
				N'@iReqd INT, @iAttnd INT,  @Ok BIT, @PersonnelId VARCHAR(50)',
				@iReqd, @iAttnd, @Ok, @PersonnelId

--			IF @PersonnelNo = 1
			BEGIN
				DECLARE @ModelDesc NVARCHAR(255)
				SET @ModelDesc = @ModelShortName +  ' ' + ISNULL(@CategoryShortName, '')
				
				IF @RiskLevelVal IS NOT NULL
					SET @ModelDesc = @ModelDesc + '[RiskLevel=' + CONVERT(CHAR(1), @RiskLevelVal) + ']'

				SET @Sql = N'UPDATE #RetVal
					SET ModelId' + LTRIM(RTRIM(CONVERT(VARCHAR(3), @ModelNo))) + ' = @ModelId,
						ModelName' + LTRIM(RTRIM(CONVERT(VARCHAR(3), @ModelNo))) + ' = @ModelName
					WHERE PersonnelId = @PersonnelId'

				EXEC SP_EXECUTESQL @Sql,
					N'@ModelId VARCHAR(50), @ModelName VARCHAR(255), @PersonnelId VARCHAR(50)',
					@ModelId, @ModelDesc, @PersonnelId
			END

			--
			-- Next model
			SET @ModelNo = @ModelNo + 1

			FETCH NEXT FROM CsrModel 
			INTO @ModelId, @ModelShortName, @CategoryShortName, @RiskLevel, @RiskLevelVal
		END

		--
		-- Next Person
		UPDATE #RetVal
		SET RequiredCount = ISNULL(@PersonReqdCount, 0), 
			AchievedCount = ISNULL(@PersonAttndCount, 0)
		WHERE PersonnelId = @PersonnelId

		SET @PersonnelNo = @PersonnelNo + 1

		FETCH NEXT FROM CsrPerson 
		INTO @PersonnelId, @PersonnelShortName
	END


	CLOSE CsrPerson
	DEALLOCATE CsrPerson

	CLOSE CsrModel
	DEALLOCATE CsrModel

	--
	-- Return the data
	SELECT LastName, FirstName,
		OrganisationShortName AS Provider,
		BranchShortName AS [Service],
		SiteShortName AS [Site],
		LocationShortName AS Location,
		RequiredCount, AchievedCount,	
		CASE ISNULL(RequiredCount, 0)
		WHEN 0 THEN 1
		ELSE CAST((ISNULL(AchievedCount, 0) / CAST(RequiredCount AS FLOAT)) AS DECIMAL(10,2))
		END AS PCCompliant,
		ModelName1,
		--RiskLevel1,
		CASE WHEN RequiredLevel1 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel1,
		CASE WHEN RequiredLevel1 > 0 THEN
			CASE WHEN AchievedLevel1 >= RequiredLevel1 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel1 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel1,
		CASE WHEN Ok1 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok1,
		ModelName2,
		--RiskLevel2,
		CASE WHEN RequiredLevel2 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel2,
		CASE WHEN RequiredLevel2 > 0 THEN
			CASE WHEN AchievedLevel2 >= RequiredLevel2 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel2 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel2,
		CASE WHEN Ok2 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok2,
		ModelName3,
		--RiskLevel3,
		CASE WHEN RequiredLevel3 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel3,
		CASE WHEN RequiredLevel3 > 0 THEN
			CASE WHEN AchievedLevel3 >= RequiredLevel3 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel3 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel3,
		CASE WHEN Ok3 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok3,
		ModelName4,
		--RiskLevel4,
		CASE WHEN RequiredLevel4 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel4,
		CASE WHEN RequiredLevel4 > 0 THEN
			CASE WHEN AchievedLevel4 >= RequiredLevel4 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel4 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel4,
		CASE WHEN Ok4 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok4,
		ModelName5,
		--RiskLevel5,
		CASE WHEN RequiredLevel5 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel5,
		CASE WHEN RequiredLevel5 > 0 THEN
			CASE WHEN AchievedLevel5 >= RequiredLevel5 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel5 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel5,
		CASE WHEN Ok5 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok5,
		ModelName6,
		--RiskLevel6,
		CASE WHEN RequiredLevel6 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel6,
		CASE WHEN RequiredLevel6 > 0 THEN
			CASE WHEN AchievedLevel6 >= RequiredLevel6 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel6 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel6,
		CASE WHEN Ok6 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok6,
		ModelName7,
		--RiskLevel7,
		CASE WHEN RequiredLevel7 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel7,
		CASE WHEN RequiredLevel7 > 0 THEN
			CASE WHEN AchievedLevel7 >= RequiredLevel7 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel7 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel7,
		CASE WHEN Ok7 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok7,
		ModelName8,
		--RiskLevel8,
		CASE WHEN RequiredLevel8 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel8,
		CASE WHEN RequiredLevel8 > 0 THEN
			CASE WHEN AchievedLevel8 >= RequiredLevel8 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel8 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel8,
		CASE WHEN Ok8 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok8,
		ModelName9,
		--RiskLevel9,
		CASE WHEN RequiredLevel9 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel9,
		CASE WHEN RequiredLevel9 > 0 THEN
			CASE WHEN AchievedLevel9 >= RequiredLevel9 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel9 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel9,
		CASE WHEN Ok9 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok9,
		ModelName10,
		--RiskLevel10,
		CASE WHEN RequiredLevel10 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel10,
		CASE WHEN RequiredLevel10 > 0 THEN
			CASE WHEN AchievedLevel10 >= RequiredLevel10 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel10 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel10,
		CASE WHEN Ok10 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok10,

		ModelName11,
		--RiskLevel11,
		CASE WHEN RequiredLevel11 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel11,
		CASE WHEN RequiredLevel11 > 0 THEN
			CASE WHEN AchievedLevel11 >= RequiredLevel11 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel11 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel11,
		CASE WHEN Ok11 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok11,
		ModelName12,		
		--RiskLevel12,
		CASE WHEN RequiredLevel12 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel12,
		CASE WHEN RequiredLevel12 > 0 THEN
			CASE WHEN AchievedLevel12 >= RequiredLevel12 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel12 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel12,
		CASE WHEN Ok12 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok12,
		ModelName13,
		--RiskLevel13,
		CASE WHEN RequiredLevel13 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel13,
		CASE WHEN RequiredLevel13 > 0 THEN
			CASE WHEN AchievedLevel13 >= RequiredLevel13 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel13 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel13,
		CASE WHEN Ok13 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok13,
		ModelName14,
		--RiskLevel14,
		CASE WHEN RequiredLevel14 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel14,
		CASE WHEN RequiredLevel14 > 0 THEN
			CASE WHEN AchievedLevel14 >= RequiredLevel14 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel14 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel14,
		CASE WHEN Ok14 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok14,
		ModelName15,
		--RiskLevel15,
		CASE WHEN RequiredLevel15 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel15,
		CASE WHEN RequiredLevel15 > 0 THEN
			CASE WHEN AchievedLevel15 >= RequiredLevel15 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel15 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel15,
		CASE WHEN Ok15 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok15,
		ModelName16,
		--RiskLevel16,
		CASE WHEN RequiredLevel16 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel16,
		CASE WHEN RequiredLevel16 > 0 THEN
			CASE WHEN AchievedLevel16 >= RequiredLevel16 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel16 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel16,
		CASE WHEN Ok16 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok16,
		ModelName17,
		--RiskLevel17,
		CASE WHEN RequiredLevel17 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel17,
		CASE WHEN RequiredLevel17 > 0 THEN
			CASE WHEN AchievedLevel17 >= RequiredLevel17 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel17 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel17,
		CASE WHEN Ok17 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok17,
		ModelName18,
		--RiskLevel18,
		CASE WHEN RequiredLevel18 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel18,
		CASE WHEN RequiredLevel18 > 0 THEN
			CASE WHEN AchievedLevel18 >= RequiredLevel18 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel18 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel18,
		CASE WHEN Ok18 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok18,
		ModelName19,
		--RiskLevel19,
		CASE WHEN RequiredLevel19 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel19,
		CASE WHEN RequiredLevel19 > 0 THEN
			CASE WHEN AchievedLevel19 >= RequiredLevel19 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel19 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel19,
		CASE WHEN Ok19 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok19,
		ModelName20,
		--RiskLevel20,
		CASE WHEN RequiredLevel20 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel20,
		CASE WHEN RequiredLevel20 > 0 THEN
			CASE WHEN AchievedLevel20 >= RequiredLevel20 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel20 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel20,
		CASE WHEN Ok20 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok20,

		ModelName21,
		--RiskLevel21,
		CASE WHEN RequiredLevel21 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel21,
		CASE WHEN RequiredLevel21 > 0 THEN
			CASE WHEN AchievedLevel21 >= RequiredLevel21 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel21 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel21,
		CASE WHEN Ok21 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok21,
		ModelName22,
		--RiskLevel22,
		CASE WHEN RequiredLevel22 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel22,
		CASE WHEN RequiredLevel22 > 0 THEN
			CASE WHEN AchievedLevel22 >= RequiredLevel22 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel22 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel22,
		CASE WHEN Ok22 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok22,
		ModelName23,
		--RiskLevel23,
		CASE WHEN RequiredLevel23 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel23,
		CASE WHEN RequiredLevel23 > 0 THEN
			CASE WHEN AchievedLevel23 >= RequiredLevel23 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel23 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel23,
		CASE WHEN Ok23 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok23,
		ModelName24,
		--RiskLevel24,
		CASE WHEN RequiredLevel24 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel24,
		CASE WHEN RequiredLevel24 > 0 THEN
			CASE WHEN AchievedLevel24 >= RequiredLevel24 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel24 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel24,
		CASE WHEN Ok24 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok24,
		ModelName25,
		--RiskLevel25,
		CASE WHEN RequiredLevel25 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel25,
		CASE WHEN RequiredLevel25 > 0 THEN
			CASE WHEN AchievedLevel25 >= RequiredLevel25 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel25 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel25,
		CASE WHEN Ok25 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok25,
		ModelName26,
		--RiskLevel26,
		CASE WHEN RequiredLevel26 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel26,
		CASE WHEN RequiredLevel26 > 0 THEN
			CASE WHEN AchievedLevel26 >= RequiredLevel26 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel26 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel26,
		CASE WHEN Ok26 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok26,
		ModelName27,
		--RiskLevel27,
		CASE WHEN RequiredLevel27 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel27,
		CASE WHEN RequiredLevel27 > 0 THEN
			CASE WHEN AchievedLevel27 >= RequiredLevel27 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel27 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel27,
		CASE WHEN Ok27 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok27,
		ModelName28,
		--RiskLevel28,
		CASE WHEN RequiredLevel28 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel28,
		CASE WHEN RequiredLevel28 > 0 THEN
			CASE WHEN AchievedLevel28 >= RequiredLevel28 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel28 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel28,
		CASE WHEN Ok28 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok28,
		ModelName29,
		--RiskLevel29,
		CASE WHEN RequiredLevel29 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel29,
		CASE WHEN RequiredLevel29 > 0 THEN
			CASE WHEN AchievedLevel29 >= RequiredLevel29 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel29 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel29,
		CASE WHEN Ok29 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok29,
		ModelName30,
		--RiskLevel30,
		CASE WHEN RequiredLevel30 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel30,
		CASE WHEN RequiredLevel30 > 0 THEN
			CASE WHEN AchievedLevel30 >= RequiredLevel30 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel30 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel30,
		CASE WHEN Ok30 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok30,

		ModelName31,
		--RiskLevel31,
		CASE WHEN RequiredLevel31 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel31,
		CASE WHEN RequiredLevel31 > 0 THEN
			CASE WHEN AchievedLevel31 >= RequiredLevel31 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel31 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel31,
		CASE WHEN Ok31 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok31,
		ModelName32,
		--RiskLevel32,
		CASE WHEN RequiredLevel32 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel32,
		CASE WHEN RequiredLevel32 > 0 THEN
			CASE WHEN AchievedLevel32 >= RequiredLevel32 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel32 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel32,
		CASE WHEN Ok32 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok32,
		ModelName33,
		--RiskLevel33,
		CASE WHEN RequiredLevel33 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel33,
		CASE WHEN RequiredLevel33 > 0 THEN
			CASE WHEN AchievedLevel33 >= RequiredLevel33 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel33 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel33,
		CASE WHEN Ok33 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok33,
		ModelName34,
		--RiskLevel34,
		CASE WHEN RequiredLevel34 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel34,
		CASE WHEN RequiredLevel34 > 0 THEN
			CASE WHEN AchievedLevel34 >= RequiredLevel34 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel34 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel34,
		CASE WHEN Ok34 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok34,
		ModelName35,
		--RiskLevel35,
		CASE WHEN RequiredLevel35 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel35,
		CASE WHEN RequiredLevel35 > 0 THEN
			CASE WHEN AchievedLevel35 >= RequiredLevel35 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel35 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel35,
		CASE WHEN Ok35 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok35,
		ModelName36,
		--RiskLevel36,
		CASE WHEN RequiredLevel36 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel36,
		CASE WHEN RequiredLevel36 > 0 THEN
			CASE WHEN AchievedLevel36 >= RequiredLevel36 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel36 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel36,
		CASE WHEN Ok36 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok36,
		ModelName37,
		--RiskLevel37,
		CASE WHEN RequiredLevel37 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel37,
		CASE WHEN RequiredLevel37 > 0 THEN
			CASE WHEN AchievedLevel37 >= RequiredLevel37 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel37 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel37,
		CASE WHEN Ok37 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok37,
		ModelName38,
		--RiskLevel38,
		CASE WHEN RequiredLevel38 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel38,
		CASE WHEN RequiredLevel38 > 0 THEN
			CASE WHEN AchievedLevel38 >= RequiredLevel38 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel38 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel38,
		CASE WHEN Ok38 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok38,
		ModelName39,
		--RiskLevel39,
		CASE WHEN RequiredLevel39 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel39,
		CASE WHEN RequiredLevel39 > 0 THEN
			CASE WHEN AchievedLevel39 >= RequiredLevel39 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel39 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel39,
		CASE WHEN Ok39 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok39,
		ModelName40,		
		--RiskLevel40,
		CASE WHEN RequiredLevel40 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel40,
		CASE WHEN RequiredLevel40 > 0 THEN
			CASE WHEN AchievedLevel40 >= RequiredLevel40 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel40 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel40,
		CASE WHEN Ok40 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok40,

		ModelName41,
		--RiskLevel41,
		CASE WHEN RequiredLevel41 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel41,
		CASE WHEN RequiredLevel41 > 0 THEN
			CASE WHEN AchievedLevel41 >= RequiredLevel41 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel41 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel41,
		CASE WHEN Ok41 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok41,
		ModelName42,
		--RiskLevel42,
		CASE WHEN RequiredLevel42 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel42,
		CASE WHEN RequiredLevel42 > 0 THEN
			CASE WHEN AchievedLevel42 >= RequiredLevel42 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel42 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel42,
		CASE WHEN Ok42 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok42,
		ModelName43,
		--RiskLevel43,
		CASE WHEN RequiredLevel43 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel43,
		CASE WHEN RequiredLevel43 > 0 THEN
			CASE WHEN AchievedLevel43 >= RequiredLevel43 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel43 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel43,
		CASE WHEN Ok43 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok43,
		ModelName44,
		--RiskLevel44,
		CASE WHEN RequiredLevel44 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel44,
		CASE WHEN RequiredLevel44 > 0 THEN
			CASE WHEN AchievedLevel44 >= RequiredLevel44 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel44 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel44,
		CASE WHEN Ok44 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok44,
		ModelName45,
		--RiskLevel45,
		CASE WHEN RequiredLevel45 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel45,
		CASE WHEN RequiredLevel45 > 0 THEN
			CASE WHEN AchievedLevel45 >= RequiredLevel45 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel45 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel45,
		CASE WHEN Ok45 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok45,
		ModelName46,
		--RiskLevel46,
		CASE WHEN RequiredLevel46 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel46,
		CASE WHEN RequiredLevel46 > 0 THEN
			CASE WHEN AchievedLevel46 >= RequiredLevel46 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel46 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel46,
		CASE WHEN Ok46 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok46,
		ModelName47,
		--RiskLevel47,
		CASE WHEN RequiredLevel47 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel47,
		CASE WHEN RequiredLevel47 > 0 THEN
			CASE WHEN AchievedLevel47 >= RequiredLevel47 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel47 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel47,
		CASE WHEN Ok47 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok47,
		ModelName48,
		--RiskLevel48,
		CASE WHEN RequiredLevel48 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel48,
		CASE WHEN RequiredLevel48 > 0 THEN
			CASE WHEN AchievedLevel48 >= RequiredLevel48 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel48 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel48,
		CASE WHEN Ok48 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok48,
		ModelName49,
		--RiskLevel49,
		CASE WHEN RequiredLevel49 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel49,
		CASE WHEN RequiredLevel49 > 0 THEN
			CASE WHEN AchievedLevel49 >= RequiredLevel49 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel49 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel49,
		CASE WHEN Ok49 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok49,
		ModelName50,		
		--RiskLevel50,
		CASE WHEN RequiredLevel50 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel50,
		CASE WHEN RequiredLevel50 > 0 THEN
			CASE WHEN AchievedLevel50 >= RequiredLevel50 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel50 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel50,
		CASE WHEN Ok50 = 1 THEN NCHAR(8730) ELSE 'x' END AS Ok50
	INTO #RetVal2
	FROM #RetVal
		INNER JOIN Personnel AS P1
			ON #RetVal.PersonnelId = P1.PersonnelId
		LEFT JOIN Organisation
			ON P1.OrganisationId = Organisation.OrganisationId
		LEFT JOIN Branch
			ON P1.BranchId = Branch.BranchId
		LEFT JOIN [Site]
			ON P1.SiteId = [Site].SiteId
		LEFT JOIN Location
			ON P1.LocationId = Location.LocationId

	--
	-- Sort depending on parameters
	DECLARE @SortOrder NVARCHAR(500)
	SET @SortOrder = 'Location, LastName, FirstName'

	SET @Sql = N'SELECT * FROM #RetVal2 ORDER BY ' + @SortOrder
	EXEC SP_EXECUTESQL @Sql

	SELECT ISNULL(Location, '<Unknown>') AS Location, SUM(ISNULL(RequiredCount, 0)), SUM(ISNULL(AchievedCount,0))
	FROM #RetVal2
	GROUP BY Location
	ORDER BY Location

	SELECT ISNULL([Service], '<Unknown>') AS [Service], SUM(ISNULL(RequiredCount, 0)), SUM(ISNULL(AchievedCount,0))
	FROM #RetVal2
	GROUP BY [Service]
	ORDER BY [Service]

	DROP TABLE #RetVal
END