IF NOT EXISTS (SELECT * FROM sys.objects WHERE type = 'P' AND OBJECT_ID = OBJECT_ID('[dbo].[qIISUpdateTrainingManagers]'))
   EXEC('CREATE PROCEDURE [dbo].[qIISUpdateTrainingManagers] AS BEGIN SET NOCOUNT ON; END')
GO

--
--===========================================================
-- Author:		
-- Create date:
-- Description:		Updates training user managers
-- Called By:		
-- =========================================================
-- History:
-- =========================================================
--

ALTER PROC [dbo].[qIISUpdateTrainingManagers]  
	@ManagerId VARCHAR(MAX),
	@PersonnelId VARCHAR(MAX),
	@ESRNo VARCHAR(50),
	@LocationId VARCHAR(MAX),
	@ManagerEmail VARCHAR(50),
	@ManagerPassword VARCHAR(50),
	@PasswordSalt VARCHAR(50),
	@PasswordValidUntil DATETIME
AS
BEGIN
	
	IF @ManagerId IS NOT NULL AND @PersonnelId IS NOT NULL AND @ESRNo IS NOT NULL
	BEGIN
		IF NOT EXISTS (SELECT * FROM IIS_TrainingManager WHERE ManagerId = @ManagerId AND PersonnelId = @PersonnelId)
		BEGIN
			INSERT INTO IIS_TrainingManager
			(ManagerId, PersonnelId, ESRNo, LocationId, ManagerEmail, ManagerPassword, PasswordSalt, PasswordValidUntil)
			VALUES
			(@ManagerId, @PersonnelId, @ESRNo, @LocationId, @ManagerEmail, @ManagerPassword, @PasswordSalt, @PasswordValidUntil)
		END		
		ELSE
		BEGIN
			UPDATE IIS_TrainingManager SET ManagerEmail = @ManagerEmail, ManagerPassword = @ManagerPassword, PasswordSalt = @PasswordSalt, PasswordValidUntil = @PasswordValidUntil WHERE ManagerId = @ManagerId AND PersonnelId = @PersonnelId
		END
	END
END













