IF NOT EXISTS (SELECT * FROM sys.objects WHERE type = 'P' AND OBJECT_ID = OBJECT_ID('[dbo].[qIISUpdateTrainingUser]'))
   EXEC('CREATE PROCEDURE [dbo].[qIISUpdateTrainingUser] AS BEGIN SET NOCOUNT ON; END')
GO

--
--===========================================================
-- Author:		
-- Create date:	
-- Description:		Updated or Creates training users.
-- Called By:		Equip.EquipmentTraining, AssesmentTrainer.aspx
-- =========================================================
-- History:
-- =========================================================
--

ALTER PROC [dbo].[qIISUpdateTrainingUser]  
	@TrainingUserId VARCHAR(MAX),
	@PersonnelId VARCHAR(MAX),
	@Password VARCHAR(50),
	@PasswordSalt VARCHAR(50),
	@PasswordValidUntil DATETIME,
	@UpdatePassword BIT,
	@Inactive BIT
AS
BEGIN
	
	IF @TrainingUserId IS NOT NULL AND @PersonnelId IS NOT NULL
	BEGIN
		IF NOT EXISTS (SELECT * FROM IIS_TrainingUser WHERE PersonnelId = @PersonnelId)
		BEGIN
			INSERT INTO IIS_TrainingUser
			(TrainingUserId, PersonnelId, UserPassword, PasswordSalt, PasswordValidUntil, InActive)
			VALUES
			(@TrainingUserId, @PersonnelId, @Password, @PasswordSalt, @PasswordValidUntil, @Inactive)
		END		
		ELSE
		BEGIN
			IF (@UpdatePassword = 1)
			BEGIN
				UPDATE IIS_TrainingUser SET InActive = @Inactive, UserPassword = @Password, PasswordSalt = @PasswordSalt, PasswordValidUntil = @PasswordValidUntil WHERE PersonnelId = @PersonnelId
			END
			ELSE
			BEGIN
				UPDATE IIS_TrainingUser SET PasswordValidUntil = @PasswordValidUntil, InActive = @Inactive WHERE PersonnelId = @PersonnelId
			END
		END
	END
END
GO


