IF NOT EXISTS (SELECT * FROM sys.objects WHERE type = 'P' AND OBJECT_ID = OBJECT_ID('[dbo].[qIIS_CreateCompetenceGroupTNA]'))
   EXEC('CREATE PROCEDURE [dbo].[qIIS_CreateCompetenceGroupTNA] AS BEGIN SET NOCOUNT ON; END')
GO
--
--===========================================================
-- Author:		Philip Brassington
-- Create date:	12th April 2014
-- Description:	Insert new row from the grid
-- Called By:		Equip.EquipmentTraining, default.aspx, grd
-- =========================================================
-- History:
-- v1.00	12th April 2014	Philip Brassington Created
-- =========================================================
--

ALTER PROC [dbo].[qIIS_CreateCompetenceGroupTNA]
	@CompetenceGroupTNAId NVARCHAR(50),
	@CompetenceGroupId NVARCHAR(50),
	@PersonnelId NVARCHAR(50),
	@ModelId NVARCHAR(50),
	@AuthorisedUser BIT = 0, 
	@EffectiveDate DATETIME = NULL, 
	@Competent BIT = 0, 
	@SelfCertified BIT = 0, 
	@Trained BIT = 0, 
	@TrainingDate DATETIME = NULL, 
	@TrainerId NVARCHAR(50) = NULL,
	@RefresherTrainingDate DATETIME = NULL, 
	@CertificationDate DATETIME = NULL, 
	@AssessmentDate DATETIME = NULL, 
	@AssessorID NVARCHAR(50) = NULL,
	@Inactive BIT = 0,
	@RequiredCompetenceTypeId NVARCHAR(50) = NULL,
	@AttainedCompetenceTypeId NVARCHAR(50) = NULL
AS
BEGIN
	--
	-- Return Values:
	--	0  - Success
	--	1  - No Pk
	--  2  - xxx
	--  3  - Record Exists

	SET NOCOUNT ON

	IF ISNULL(@CompetenceGroupTNAId, '') = '' 
		RETURN 1

	IF EXISTS (SELECT * FROM CompetenceGroupTNA WHERE CompetenceGroupTNAId = @CompetenceGroupTNAId)
	   RETURN 3

	INSERT INTO dbo.CompetenceGroupTNA  
		(CompetenceGroupTNAId, 
		 CompetenceGroupId, 
		 PersonnelId, 
		 ModelId, 
		 AuthorisedUser, 
		 EffectiveDate, 
		 Competent, 
		 SelfCertified, 
		 Trained, 
		 TrainingDate, 
		 TrainerId, 
		 RefresherTrainingDate, 
		 CertificationDate, 
		 AssessmentDate, 
		 AssessorId, 
		 RequiredCompetenceTypeId, 
		 AttainedCompetenceTypeId, 
		 Inactive)
	VALUES 
		(@CompetenceGroupTNAId, 
		 @CompetenceGroupId, 
		 @PersonnelId, 
		 @ModelId, 
		 @AuthorisedUser, 
		 @EffectiveDate, 
		 @Competent, 
		 @SelfCertified, 
		 @Trained, 
		 @TrainingDate, 
		 @TrainerId, 
		 @RefresherTrainingDate, 
		 @CertificationDate, 
		 @AssessmentDate, 
		 @AssessorId, 
		 @RequiredCompetenceTypeId, 
		 @AttainedCompetenceTypeId, 
		 @Inactive) 
	
	RETURN 0
END





GO


