IF NOT EXISTS (SELECT * FROM sys.objects WHERE type = 'P' AND OBJECT_ID = OBJECT_ID('[dbo].[qIIS_CreateCompetenceGroupTNATrainerAssessor]'))
   EXEC('CREATE PROCEDURE [dbo].[qIIS_CreateCompetenceGroupTNATrainerAssessor] AS BEGIN SET NOCOUNT ON; END')
GO

--
--===========================================================
-- Author:		Philip Brassington
-- Create date:	12th April 2014
-- Description:	Inserts TNA from the Trainer / Assessor page	
-- Called By:		Equip.EquipmentTraining, AssesmentTrainer.aspx
-- =========================================================
-- History:
-- v1.00	12th April 2014	Philip Brassington Created
-- =========================================================
--

ALTER PROC [dbo].[qIIS_CreateCompetenceGroupTNATrainerAssessor]
	@CompetenceGroupTNAId NVARCHAR(50),
	@CompetenceGroupId NVARCHAR(50),
	@PersonnelId NVARCHAR(50),
	@ModelId NVARCHAR(50),
	@TrainerId NVARCHAR(50), 
	@AssessorID NVARCHAR(50)
AS
BEGIN
	--
	-- Return Values:
	--	0  - Success
	--	1  - No Pk
	--  2  - xxx
	--  3  - Record Exists

	SET NOCOUNT ON

	IF ISNULL(@CompetenceGroupTNAId, '') = '' 
		RETURN 1

	IF EXISTS (SELECT * FROM CompetenceGroupTNA WHERE CompetenceGroupTNAId = @CompetenceGroupTNAId)
	   RETURN 3

	INSERT INTO dbo.CompetenceGroupTNA  
		(CompetenceGroupTNAId,
		 CompetenceGroupId, 
		 PersonnelId, 
		 ModelId, 
		 TrainerId, 
		 AssessorId)
	VALUES 
		(@CompetenceGroupTNAId, 
		 @CompetenceGroupId, 
		 @PersonnelId, 
		 @ModelId, 
		 @TrainerId, 
		 @AssessorId)
	
	RETURN 0
END





GO


