IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'[dbo].[StringListToTable]')
    AND xtype IN (N'FN', N'IF', N'TF'))
    exec('CREATE FUNCTION [dbo].[StringListToTable]() RETURNS @tbl TABLE (value VARCHAR(50) NOT NULL) AS BEGIN RETURN END')
GO
-- =======================================================================================================================================
-- Author:		Philip Brassington
-- Create date: 24th May 2017
-- Description:	Converts a list of int values into a table variable
-- Called By:	eQuipCloud Training Project Only
-- Notes:
--		Taken From http://www.sommarskog.se/arrays-in-sql.html#tablecol
--		We need to pass in a list of primary keys for the TNA Cross Tab Report
--
-- =======================================================================================================================================
-- History:
-- v1.00	25th September 2015	Philip Brassington	Created
--
-- =======================================================================================================================================
ALTER FUNCTION StringListToTable (@list nvarchar(MAX))
   RETURNS @tbl TABLE (value VARCHAR(50) NOT NULL) AS
BEGIN
   DECLARE @pos        int,
           @nextpos    int,
           @valuelen   int

   SELECT @pos = 0, @nextpos = 1

   WHILE @nextpos > 0
   BEGIN
      SELECT @nextpos = charindex(',', @list, @pos + 1)
      SELECT @valuelen = CASE WHEN @nextpos > 0
                              THEN @nextpos
                              ELSE len(@list) + 1
                         END - @pos - 1
      INSERT @tbl (value)
         VALUES (convert(VARCHAR(50), substring(@list, @pos + 1, @valuelen)))
      SELECT @pos = @nextpos
   END
   RETURN
END