/* 
===========================================================
 Author:		Peter Bush
 Create date:	26th February 2018
 Description:	Adds the base setup of IIS_CustomControl items to the table
 Called By:		e-Quip Training Microsite
 =========================================================
 History:
 v1.00	26th February 2018	Peter Bush Created
 =========================================================
*/

SELECT * FROM IIS_CustomControl

DELETE FROM IIS_CustomControl

--ASSET CONTROLS
INSERT INTO IIS_CustomControl VALUES (98, null,15, 'SiteShortName', 'Site', 'SiteId', 'SiteShortName', 'SiteId')
INSERT INTO IIS_CustomControl VALUES (98, null, 16, 'LocationShortName', 'Location', 'LocationId', 'LocationShortName', 'LocationId')
INSERT INTO IIS_CustomControl VALUES (98, null, 26, 'OrganisationShortName', 'Organisation', 'OrganisationId', 'OrganisationShortName', 'OrganisationId')
INSERT INTO IIS_CustomControl VALUES (98, null, 17, 'BranchShortName', 'Branch', 'BranchId', 'BranchShortName', 'BranchId')
INSERT INTO IIS_CustomControl VALUES (98, null, 4, 'ModelShortName', 'Model', 'ModelId', 'ModelShortName', 'ModelId')
INSERT INTO IIS_CustomControl VALUES (98, null, 6, 'CategoryShortName', 'Category', 'CategoryId', 'CategoryShortName', 'CategoryId')
INSERT INTO IIS_CustomControl VALUES (98, null, 14, 'BrandShortName', 'Brand', 'BrandId', 'BrandShortName', 'BrandId')
INSERT INTO IIS_CustomControl VALUES (98, null, 77, 'Contact', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'ContactId')
INSERT INTO IIS_CustomControl VALUES (98, 3, null, 'TeamShortName', 'Team', 'TeamId', 'TeamShortName', 'TeamId')
INSERT INTO IIS_CustomControl VALUES (98, null, 85, 'LeaseCode', 'Lease', 'LeaseId', 'LeaseCode', 'LeaseId')
INSERT INTO IIS_CustomControl VALUES (98, null, 18, 'BudgetShortName', 'Budget', 'BudgetId', 'BudgetShortName', 'BudgetId')
INSERT INTO IIS_CustomControl VALUES (98, null, 47, 'DefaultSparePartLocationShortName', 'Location', 'LocationId', 'LocationShortName', 'DefaultSparePartLocationId')
INSERT INTO IIS_CustomControl VALUES (98, null, 18, 'OwnerBudgetShortName', 'Budget', 'BudgetId', 'BudgetShortName', 'OwnerBudgetId')
INSERT INTO IIS_CustomControl VALUES (98, null, 18, 'Budget2ShortName', 'Budget', 'BudgetId', 'BudgetShortName', 'Budget2Id')
INSERT INTO IIS_CustomControl VALUES (98, null, 18, 'PurchaseBudgetShortName', 'Budget', 'BudgetId', 'BudgetShortName', 'PurchaseBudgetId')
INSERT INTO IIS_CustomControl VALUES (98, null, 80, 'CustomerShortName', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'CustomerId')
INSERT INTO IIS_CustomControl VALUES (98, null, 5, 'OPSupplier', 'Supplier', 'SupplierId', 'SupplierShortName', 'OriginalPurchaseSupplierId')
INSERT INTO IIS_CustomControl VALUES (98, null, 5, 'NPSupplier', 'Supplier', 'SupplierId', 'SupplierShortName', 'NewPurchaseSupplierId')
INSERT INTO IIS_CustomControl VALUES (98, null, 5, 'PSupplier', 'Supplier', 'SupplierId', 'SupplierShortName', 'PartsSupplierId')
INSERT INTO IIS_CustomControl VALUES (98, null, 5, 'MSupplier', 'Supplier', 'SupplierId', 'SupplierShortName', 'MaintenanceSupplierId')
INSERT INTO IIS_CustomControl VALUES (98, null, 5, 'CSupplier', 'Supplier', 'SupplierId', 'SupplierShortName', 'CalloutSupplierId')
INSERT INTO IIS_CustomControl VALUES (98, null, 5, 'TrgSupplier', 'Supplier', 'SupplierId', 'SupplierShortName', 'TrainingSupplierId')
INSERT INTO IIS_CustomControl VALUES (98, null, 5, 'LoanSupplier', 'Supplier', 'SupplierId', 'SupplierShortName', 'LoanSupplierId')
INSERT INTO IIS_CustomControl VALUES (98, null, 77, 'LastDecontaminatedBy', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'LastDecontamPersonnelId')
INSERT INTO IIS_CustomControl VALUES (98, null, 43, 'Contact1Name', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'Contact1Id')
INSERT INTO IIS_CustomControl VALUES (98, null, 43, 'Contact2Name', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'Contact2Id')
INSERT INTO IIS_CustomControl VALUES (98, null, 43, 'Contact3Name', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'Contact3Id')
INSERT INTO IIS_CustomControl VALUES (98, null, 43, 'Contact4Name', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'Contact4Id')
INSERT INTO IIS_CustomControl VALUES (98, null, 43, 'Contact5Name', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'Contact5Id')
INSERT INTO IIS_CustomControl VALUES (98, null, 43, 'TechnicianName', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'TechnicianId')
INSERT INTO IIS_CustomControl VALUES (98, 1, null, 'EquipmentStatusClassShortName', 'EquipmentStatus', 'EquipmentStatusId', 'EquipmentStatusClassShortName', 'EquipmentStatusId')
INSERT INTO IIS_CustomControl VALUES (98, 4, null, 'SupportLevelShortName', 'SupportLevel', 'SupportLevelId', 'SupportLevelShortName', 'SupportLevelId')
INSERT INTO IIS_CustomControl VALUES (98, 29, null, 'EquipmentConditionShortName', 'EquipmentCondition', 'EquipmentConditionId', 'EquipmentConditionShortName', 'ConditionId')
INSERT INTO IIS_CustomControl VALUES (98, 5, null, 'RiskLevelShortName', 'EquipmentRiskLevel', 'EquipmentRiskLevelId', 'EquipmentRiskLevelShortName', 'RiskLevelId')
INSERT INTO IIS_CustomControl VALUES (98, 8, null, 'ContamRiskShortName', 'ContaminationRisk', 'ContamRiskId', 'ContamRiskShortName', 'ContaminationRiskId')
INSERT INTO IIS_CustomControl VALUES (98, 9, null, 'ProjectShortName', 'Project', 'ProjectId', 'ProjectShortName', 'ProjectId')
INSERT INTO IIS_CustomControl VALUES (98, 6, null, 'ClassificationShortName', 'Classification', 'ClassificationId', 'ClassificationShortName', 'ClassificationId')
INSERT INTO IIS_CustomControl VALUES (98, 90, null, 'ReplacementPriorityShortName', 'ReplacementPriority', 'ReplacementPriorityId', 'ReplacementPriorityShortName', 'ReplacementPriorityId')
INSERT INTO IIS_CustomControl VALUES (98, 80, null, 'ReplacementReasonShortName', 'ReplacementReason', 'ReplacementReasonId', 'ReplacementReasonShortName', 'ReplacementReasonId')
INSERT INTO IIS_CustomControl VALUES (98, 2, null, 'EquipmentLibraryStatusShortName', 'EquipmentLibraryStatus', 'EquipmentLibraryStatusId', 'EquipmentLibraryStatusShortName', 'EquipmentLibraryStatusId')
INSERT INTO IIS_CustomControl VALUES (98, 20, null, 'JobPriorityShortName', 'JobPriority', 'JobPriorityId', 'JobPriorityShortName', 'JobPriorityId')
INSERT INTO IIS_CustomControl VALUES (98, 15, null, 'LastDecontamActionShortName', 'DecontamAction', 'DecontamActionId', 'DecontamActionShortName', 'DecontamActionId')
INSERT INTO IIS_CustomControl VALUES (98, 15, null, 'NextDecontamActionShortName', 'DecontamAction', 'DecontamActionId', 'DecontamActionShortName', 'DecontamActionId')
INSERT INTO IIS_CustomControl VALUES (98, null, 17, 'DataSecurityDataUserService', 'Branch', 'BranchId', 'BranchShortName', 'DataSecurityDataUserId')

----JOB CONTROLS
INSERT INTO IIS_CustomControl VALUES (111, null, 36, 'EquipmentCode', 'Equipment', 'EquipmentId', 'EquipmentCode', 'EquipmentId')
INSERT INTO IIS_CustomControl VALUES (111, null, 103, 'JobGroupShortName', 'JobGroup', 'JobGroupId', 'JobGroupShortName', 'JobGroupId')
INSERT INTO IIS_CustomControl VALUES (111, null, 116, 'PatientName', 'Patient', 'PatientId', 'DisplayName', 'PatientId')
INSERT INTO IIS_CustomControl VALUES (111, null, 43, 'Technician', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'TechnicianId')
INSERT INTO IIS_CustomControl VALUES (111, null, 43, 'Assistant', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'AssistantId')
INSERT INTO IIS_CustomControl VALUES (111, null, 43, 'Supervisor', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'SupervisorId')
INSERT INTO IIS_CustomControl VALUES (111, null, 43, 'PPMScheduleShortName', 'PPMSchedule', 'PPMScheduleId', 'PPMScheduleShortName', 'PPMScheduleId')
INSERT INTO IIS_CustomControl VALUES (111, null, 15, 'AssetSiteShortName', 'Site', 'SiteId', 'SiteShortName', 'AssetSiteId')
INSERT INTO IIS_CustomControl VALUES (111, null, 16, 'AssetLocationShortName', 'Location', 'LocationId', 'LocationShortName', 'AssetLocationId')
INSERT INTO IIS_CustomControl VALUES (111, null, 26, 'AssetOrganisationShortName', 'Organisation', 'OrganisationId', 'OrganisationShortName', 'AssetOrganisationId')
INSERT INTO IIS_CustomControl VALUES (111, null, 15, 'CallerSite', 'Site', 'SiteId', 'SiteShortName', 'CallerSiteId')
INSERT INTO IIS_CustomControl VALUES (111, null, 16, 'CallerLocation', 'Location', 'LocationId', 'LocationShortName', 'CallerLocationId')
INSERT INTO IIS_CustomControl VALUES (111, null, 26, 'CallerProvider', 'Organisation', 'OrganisationId', 'OrganisationShortName', 'CallerOrganisationId')
INSERT INTO IIS_CustomControl VALUES (111, null, 17, 'CallerBranch', 'Branch', 'BranchId', 'BranchShortName', 'CallerBranchId')
INSERT INTO IIS_CustomControl VALUES (111, null, 21, 'CallerContact', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'CallerContactId')
INSERT INTO IIS_CustomControl VALUES (111, null, 21, 'CheckedBy', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'CheckedById')
INSERT INTO IIS_CustomControl VALUES (111, null, 5, 'Contractor', 'Supplier', 'SupplierId', 'SupplierShortName', 'ContractorId')
INSERT INTO IIS_CustomControl VALUES (111, null, 21, 'ApprovedBy', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'ApprovedBy1Id')
INSERT INTO IIS_CustomControl VALUES (111, null, 21, 'AcceptedBy', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'AcceptanceById')
INSERT INTO IIS_CustomControl VALUES (111, null, 5, 'Contractor2', 'Supplier', 'SupplierId', 'SupplierShortName', 'Contractor2Id')
INSERT INTO IIS_CustomControl VALUES (111, null, 21, 'ApprovedBy2', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'ApprovedBy2Id')
INSERT INTO IIS_CustomControl VALUES (111, null, 21, 'AcceptedBy2', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'AcceptanceBy2Id')
INSERT INTO IIS_CustomControl VALUES (111, null, 5, 'Contractor3', 'Supplier', 'SupplierId', 'SupplierShortName', 'Contractor3Id')
INSERT INTO IIS_CustomControl VALUES (111, null, 21, 'ApprovedBy3', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'ApprovedBy3Id')
INSERT INTO IIS_CustomControl VALUES (111, null, 21, 'AcceptedBy3', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'AcceptanceBy3Id')
INSERT INTO IIS_CustomControl VALUES (111, null, 5, 'Courier1', 'Supplier', 'SupplierId', 'SupplierShortName', 'Courier1Id')
INSERT INTO IIS_CustomControl VALUES (111, null, 5, 'Courier2', 'Supplier', 'SupplierId', 'SupplierShortName', 'Courier2Id')
INSERT INTO IIS_CustomControl VALUES (111, null, 43, 'PPMScheduleShortName', 'PPMSchedule', 'PPMScheduleId', 'PPMScheduleShortName', 'PPMScheduleId')
INSERT INTO IIS_CustomControl VALUES (111, 19, null, 'JobStatusShortName', 'JobStatus', 'JobStatusId', 'JobStatusShortName', 'JobStatusId')
INSERT INTO IIS_CustomControl VALUES (111, 18, null, 'JobTypeShortName', 'JobType', 'JobTypeId', 'JobTypeShortName', 'JobTypeId')
INSERT INTO IIS_CustomControl VALUES (111, 20, null, 'JobPriorityShortName', 'JobPriority', 'JobPriorityId', 'JobPriorityShortName', 'JobPriorityId')
INSERT INTO IIS_CustomControl VALUES (111, 3, null, 'TeamShortName', 'Team', 'TeamId', 'TeamShortName', 'TeamId')
INSERT INTO IIS_CustomControl VALUES (111, 21, null, 'FaultTypeShortName', 'FaultType', 'FaultTypeId', 'FaultTypeShortName', 'FaultTypeId')
INSERT INTO IIS_CustomControl VALUES (111, 22, null, 'FaultCauseShortName', 'FaultCause', 'FaultCauseId', 'FaultCauseShortName', 'FaultCauseId')
INSERT INTO IIS_CustomControl VALUES (111, null, 72, 'HazardCode', 'Hazard', 'HazardId', 'HazardCode', 'HazardId')
INSERT INTO IIS_CustomControl VALUES (111, null, 126, 'DispatchCode', 'Dispatch', 'DispatchId', 'DispatchCode', 'DispatchId')
INSERT INTO IIS_CustomControl VALUES (111, null, 18, 'BudgetShortName', 'Budget', 'BudgetId', 'BudgetShortName', 'BudgetId')
INSERT INTO IIS_CustomControl VALUES (111, null, 18, 'Budget2ShortName', 'Budget', 'BudgetId', 'BudgetShortName', 'Budget2Id')
INSERT INTO IIS_CustomControl VALUES (111, null, 24, 'ContractCode', 'Contract', 'ContractId', 'ContractShortName', 'ContractId')
INSERT INTO IIS_CustomControl VALUES (111, null, 84, 'CustomerContractCode', 'Contract', 'ContractId', 'ContractShortName', 'CustomerContractId')
INSERT INTO IIS_CustomControl VALUES (111, null, 80, 'CustomerShortName', 'Personnel', 'PersonnelId', 'PersonnelShortName', 'CustomerId')

INSERT INTO IIS_CustomControl VALUES (120, null, 126, 'DispatchCode', 'Dispatch', 'DispatchId', 'DispatchCode', 'DispatchId')

