IF NOT EXISTS (SELECT * FROM sys.objects WHERE type = 'P' AND OBJECT_ID = OBJECT_ID('[dbo].[qTNACrossTabFlexible]'))
   EXEC('CREATE PROCEDURE [dbo].[qTNACrossTabFlexible] AS BEGIN SET NOCOUNT ON; END')
GO
--
-- STORED PROCEDURE
--	qTNACrossTabFlexible
--
-- DESCRIPTION
--	Fetches the data for the TNA crosstab report for the flexible framework
--
-- PROGRAMMING NOTES
--
-- CHANGE HISTORY
--
--	10/11/2020 - Jack Foulkes
--		Created
ALTER PROC [dbo].[qTNACrossTabFlexible]
	@RiskLevelClassId VARCHAR(50),
	@SiteId VARCHAR(50),
	@LocationId VARCHAR(50),
	@OrganisationId VARCHAR(50),
	@BranchId VARCHAR(50),
	@PersonId VARCHAR(50),
	@CompetenceGroupId NVARCHAR(MAX),
	@IncludeLocationChildren BIT,
	@IncludeBranchChildren BIT
AS
BEGIN
	--
	-- Create the results table
	CREATE TABLE #RetVal 
	(
	PersonnelId VARCHAR(50) COLLATE database_default NOT NULL,
	ModelId1 VARCHAR(50) COLLATE database_default NULL,
	ModelName1 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel1 SMALLINT,
	AchievedLevel1 SMALLINT,
	Ok1 BIT,	
	TrainingDate1 SMALLDATETIME NULL,
	
	ModelId2 VARCHAR(50) COLLATE database_default NULL,
	ModelName2 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel2 SMALLINT,
	AchievedLevel2 SMALLINT,
	Ok2 BIT,
	TrainingDate2 SMALLDATETIME NULL,
	
	ModelId3 VARCHAR(50) COLLATE database_default NULL,
	ModelName3 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel3 SMALLINT,
	AchievedLevel3 SMALLINT,
	Ok3 BIT,
	TrainingDate3 SMALLDATETIME NULL,
	
	ModelId4 VARCHAR(50) COLLATE database_default NULL,
	ModelName4 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel4 SMALLINT,
	AchievedLevel4 SMALLINT,
	Ok4 BIT,
	TrainingDate4 SMALLDATETIME NULL,
	
	ModelId5 VARCHAR(50) COLLATE database_default NULL,
	ModelName5 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel5 SMALLINT,
	AchievedLevel5 SMALLINT,
	Ok5 BIT,
	TrainingDate5 SMALLDATETIME NULL,
	
	ModelId6 VARCHAR(50) COLLATE database_default NULL,
	ModelName6 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel6 SMALLINT,
	AchievedLevel6 SMALLINT,
	Ok6 BIT,
	TrainingDate6 SMALLDATETIME NULL,
	
	ModelId7 VARCHAR(50) COLLATE database_default NULL,
	ModelName7 VARCHAR(255) NULL,
	RequiredLevel7 SMALLINT,
	AchievedLevel7 SMALLINT,
	Ok7 BIT,
	TrainingDate7 SMALLDATETIME NULL,
	
	ModelId8 VARCHAR(50) COLLATE database_default NULL,
	ModelName8 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel8 SMALLINT,
	AchievedLevel8 SMALLINT,
	Ok8 BIT,
	TrainingDate8 SMALLDATETIME NULL,
	
	ModelId9 VARCHAR(50) COLLATE database_default NULL,
	ModelName9 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel9 SMALLINT,
	AchievedLevel9 SMALLINT,
	Ok9 BIT,
	TrainingDate9 SMALLDATETIME NULL,
	
	ModelId10 VARCHAR(50) COLLATE database_default NULL,
	ModelName10 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel10 SMALLINT,
	AchievedLevel10 SMALLINT,
	Ok10 BIT,
	TrainingDate10 SMALLDATETIME NULL,

	ModelId11 VARCHAR(50) COLLATE database_default NULL,
	ModelName11 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel11 SMALLINT,
	AchievedLevel11 SMALLINT,
	Ok11 BIT,
	TrainingDate11 SMALLDATETIME NULL,
	
	ModelId12 VARCHAR(50) COLLATE database_default NULL,
	ModelName12 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel12 SMALLINT,
	AchievedLevel12 SMALLINT,
	Ok12 BIT,
	TrainingDate12 SMALLDATETIME NULL,
	
	ModelId13 VARCHAR(50) COLLATE database_default NULL,
	ModelName13 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel13 SMALLINT,
	AchievedLevel13 SMALLINT,
	Ok13 BIT,
	TrainingDate13 SMALLDATETIME NULL,
	
	ModelId14 VARCHAR(50) COLLATE database_default NULL,
	ModelName14 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel14 SMALLINT,
	AchievedLevel14 SMALLINT,
	Ok14 BIT,
	TrainingDate14 SMALLDATETIME NULL,
	
	ModelId15 VARCHAR(50) COLLATE database_default NULL,
	ModelName15 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel15 SMALLINT,
	AchievedLevel15 SMALLINT,
	Ok15 BIT,
	TrainingDate15 SMALLDATETIME NULL,
	
	ModelId16 VARCHAR(50) COLLATE database_default NULL,
	ModelName16 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel16 SMALLINT,
	AchievedLevel16 SMALLINT,
	Ok16 BIT,
	TrainingDate16 SMALLDATETIME NULL,
	
	ModelId17 VARCHAR(50) COLLATE database_default NULL,
	ModelName17 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel17 SMALLINT,
	AchievedLevel17 SMALLINT,
	Ok17 BIT,
	TrainingDate17 SMALLDATETIME NULL,
	
	ModelId18 VARCHAR(50) COLLATE database_default NULL,
	ModelName18 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel18 SMALLINT,
	AchievedLevel18 SMALLINT,
	Ok18 BIT,
	TrainingDate18 SMALLDATETIME NULL,
	
	ModelId19 VARCHAR(50) COLLATE database_default NULL,
	ModelName19 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel19 SMALLINT,
	AchievedLevel19 SMALLINT,
	Ok19 BIT,
	TrainingDate19 SMALLDATETIME NULL,
	
	ModelId20 VARCHAR(50) COLLATE database_default NULL,
	ModelName20 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel20 SMALLINT,
	AchievedLevel20 SMALLINT,
	Ok20 BIT,
	TrainingDate20 SMALLDATETIME NULL,

	ModelId21 VARCHAR(50) COLLATE database_default NULL,
	ModelName21 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel21 SMALLINT,
	AchievedLevel21 SMALLINT,
	Ok21 BIT,
	TrainingDate21 SMALLDATETIME NULL,
	
	ModelId22 VARCHAR(50) COLLATE database_default NULL,
	ModelName22 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel22 SMALLINT,
	AchievedLevel22 SMALLINT,
	Ok22 BIT,
	TrainingDate22 SMALLDATETIME NULL,
	
	ModelId23 VARCHAR(50) COLLATE database_default NULL,
	ModelName23 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel23 SMALLINT,
	AchievedLevel23 SMALLINT,
	Ok23 BIT,
	TrainingDate23 SMALLDATETIME NULL,
	
	ModelId24 VARCHAR(50) COLLATE database_default NULL,
	ModelName24 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel24 SMALLINT,
	AchievedLevel24 SMALLINT,
	Ok24 BIT,
	TrainingDate24 SMALLDATETIME NULL,
	
	ModelId25 VARCHAR(50) COLLATE database_default NULL,
	ModelName25 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel25 SMALLINT,
	AchievedLevel25 SMALLINT,
	Ok25 BIT,
	TrainingDate25 SMALLDATETIME NULL,
	
	ModelId26 VARCHAR(50) COLLATE database_default NULL,
	ModelName26 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel26 SMALLINT,
	AchievedLevel26 SMALLINT,
	Ok26 BIT,
	TrainingDate26 SMALLDATETIME NULL,
	
	ModelId27 VARCHAR(50) COLLATE database_default NULL,
	ModelName27 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel27 SMALLINT,
	AchievedLevel27 SMALLINT,
	Ok27 BIT,
	TrainingDate27 SMALLDATETIME NULL,
	
	ModelId28 VARCHAR(50) COLLATE database_default NULL,
	ModelName28 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel28 SMALLINT,
	AchievedLevel28 SMALLINT,
	Ok28 BIT,
	TrainingDate28 SMALLDATETIME NULL,
	
	ModelId29 VARCHAR(50) COLLATE database_default NULL,
	ModelName29 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel29 SMALLINT,
	AchievedLevel29 SMALLINT,
	Ok29 BIT,
	TrainingDate29 SMALLDATETIME NULL,
	
	ModelId30 VARCHAR(50) COLLATE database_default NULL,
	ModelName30 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel30 SMALLINT,
	AchievedLevel30 SMALLINT,
	Ok30 BIT,
	TrainingDate30 SMALLDATETIME NULL,

	ModelId31 VARCHAR(50) COLLATE database_default NULL,
	ModelName31 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel31 SMALLINT,
	AchievedLevel31 SMALLINT,
	Ok31 BIT,
	TrainingDate31 SMALLDATETIME NULL,
	
	ModelId32 VARCHAR(50) COLLATE database_default NULL,
	ModelName32 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel32 SMALLINT,
	AchievedLevel32 SMALLINT,
	Ok32 BIT,
	TrainingDate32 SMALLDATETIME NULL,
	
	ModelId33 VARCHAR(50) COLLATE database_default NULL,
	ModelName33 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel33 SMALLINT,
	AchievedLevel33 SMALLINT,
	Ok33 BIT,
	TrainingDate33 SMALLDATETIME NULL,
	
	ModelId34 VARCHAR(50) COLLATE database_default NULL,
	ModelName34 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel34 SMALLINT,
	AchievedLevel34 SMALLINT,
	Ok34 BIT,
	TrainingDate34 SMALLDATETIME NULL,
	
	ModelId35 VARCHAR(50) COLLATE database_default NULL,
	ModelName35 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel35 SMALLINT,
	AchievedLevel35 SMALLINT,
	Ok35 BIT,
	TrainingDate35 SMALLDATETIME NULL,
	
	ModelId36 VARCHAR(50) COLLATE database_default NULL,
	ModelName36 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel36 SMALLINT,
	AchievedLevel36 SMALLINT,
	Ok36 BIT,
	TrainingDate36 SMALLDATETIME NULL,
	
	ModelId37 VARCHAR(50) COLLATE database_default NULL,
	ModelName37 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel37 SMALLINT,
	AchievedLevel37 SMALLINT,
	Ok37 BIT,
	TrainingDate37 SMALLDATETIME NULL,
	
	ModelId38 VARCHAR(50) COLLATE database_default NULL,
	ModelName38 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel38 SMALLINT,
	AchievedLevel38 SMALLINT,
	Ok38 BIT,
	TrainingDate38 SMALLDATETIME NULL,
	
	ModelId39 VARCHAR(50) COLLATE database_default NULL,
	ModelName39 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel39 SMALLINT,
	AchievedLevel39 SMALLINT,
	Ok39 BIT,
	TrainingDate39 SMALLDATETIME NULL,
	
	ModelId40 VARCHAR(50) COLLATE database_default NULL,
	ModelName40 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel40 SMALLINT,
	AchievedLevel40 SMALLINT,
	Ok40 BIT,
	TrainingDate40 SMALLDATETIME NULL,

	ModelId41 VARCHAR(50) COLLATE database_default NULL,
	ModelName41 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel41 SMALLINT,
	AchievedLevel41 SMALLINT,
	Ok41 BIT,
	TrainingDate41 SMALLDATETIME NULL,
	
	ModelId42 VARCHAR(50) COLLATE database_default NULL,
	ModelName42 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel42 SMALLINT,
	AchievedLevel42 SMALLINT,
	Ok42 BIT,
	TrainingDate42 SMALLDATETIME NULL,
	
	ModelId43 VARCHAR(50) COLLATE database_default NULL,
	ModelName43 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel43 SMALLINT,
	AchievedLevel43 SMALLINT,
	Ok43 BIT,
	TrainingDate43 SMALLDATETIME NULL,
	
	ModelId44 VARCHAR(50) COLLATE database_default NULL,
	ModelName44 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel44 SMALLINT,
	AchievedLevel44 SMALLINT,
	Ok44 BIT,
	TrainingDate44 SMALLDATETIME NULL,
	
	ModelId45 VARCHAR(50) COLLATE database_default NULL,
	ModelName45 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel45 SMALLINT,
	AchievedLevel45 SMALLINT,
	Ok45 BIT,
	TrainingDate45 SMALLDATETIME NULL,
	
	ModelId46 VARCHAR(50) COLLATE database_default NULL,
	ModelName46 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel46 SMALLINT,
	AchievedLevel46 SMALLINT,
	Ok46 BIT,
	TrainingDate46 SMALLDATETIME NULL,
	
	ModelId47 VARCHAR(50) COLLATE database_default NULL,
	ModelName47 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel47 SMALLINT,
	AchievedLevel47 SMALLINT,
	Ok47 BIT,
	TrainingDate47 SMALLDATETIME NULL,
	
	ModelId48 VARCHAR(50) COLLATE database_default NULL,
	ModelName48 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel48 SMALLINT,
	AchievedLevel48 SMALLINT,
	Ok48 BIT,
	TrainingDate48 SMALLDATETIME NULL,
	
	ModelId49 VARCHAR(50) COLLATE database_default NULL,
	ModelName49 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel49 SMALLINT,
	AchievedLevel49 SMALLINT,
	Ok49 BIT,
	TrainingDate49 SMALLDATETIME NULL,
	
	ModelId50 VARCHAR(50) COLLATE database_default NULL,
	ModelName50 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel50 SMALLINT,
	AchievedLevel50 SMALLINT,
	Ok50 BIT,
	TrainingDate50 SMALLDATETIME NULL,

	ModelId51 VARCHAR(50) COLLATE database_default NULL,
	ModelName51 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel51 SMALLINT,
	AchievedLevel51 SMALLINT,
	Ok51 BIT,
	TrainingDate51 SMALLDATETIME NULL,
	
	ModelId52 VARCHAR(50) COLLATE database_default NULL,
	ModelName52 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel52 SMALLINT,
	AchievedLevel52 SMALLINT,
	Ok52 BIT,
	TrainingDate52 SMALLDATETIME NULL,
	
	ModelId53 VARCHAR(50) COLLATE database_default NULL,
	ModelName53 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel53 SMALLINT,
	AchievedLevel53 SMALLINT,
	Ok53 BIT,
	TrainingDate53 SMALLDATETIME NULL,
	
	ModelId54 VARCHAR(50) COLLATE database_default NULL,
	ModelName54 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel54 SMALLINT,
	AchievedLevel54 SMALLINT,
	Ok54 BIT,
	TrainingDate54 SMALLDATETIME NULL,
	
	ModelId55 VARCHAR(50) COLLATE database_default NULL,
	ModelName55 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel55 SMALLINT,
	AchievedLevel55 SMALLINT,
	Ok55 BIT,
	TrainingDate55 SMALLDATETIME NULL,
	
	ModelId56 VARCHAR(50) COLLATE database_default NULL,
	ModelName56 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel56 SMALLINT,
	AchievedLevel56 SMALLINT,
	Ok56 BIT,
	TrainingDate56 SMALLDATETIME NULL,
	
	ModelId57 VARCHAR(50) COLLATE database_default NULL,
	ModelName57 VARCHAR(255) NULL,
	RequiredLevel57 SMALLINT,
	AchievedLevel57 SMALLINT,
	Ok57 BIT,
	TrainingDate57 SMALLDATETIME NULL,
	
	ModelId58 VARCHAR(50) COLLATE database_default NULL,
	ModelName58 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel58 SMALLINT,
	AchievedLevel58 SMALLINT,
	Ok58 BIT,
	TrainingDate58 SMALLDATETIME NULL,
	
	ModelId59 VARCHAR(50) COLLATE database_default NULL,
	ModelName59 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel59 SMALLINT,
	AchievedLevel59 SMALLINT,
	Ok59 BIT,
	TrainingDate59 SMALLDATETIME NULL,
	
	ModelId60 VARCHAR(50) COLLATE database_default NULL,
	ModelName60 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel60 SMALLINT,
	AchievedLevel60 SMALLINT,
	Ok60 BIT,
	TrainingDate60 SMALLDATETIME NULL,

	ModelId61 VARCHAR(50) COLLATE database_default NULL,
	ModelName61 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel61 SMALLINT,
	AchievedLevel61 SMALLINT,
	Ok61 BIT,
	TrainingDate61 SMALLDATETIME NULL,
	
	ModelId62 VARCHAR(50) COLLATE database_default NULL,
	ModelName62 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel62 SMALLINT,
	AchievedLevel62 SMALLINT,
	Ok62 BIT,
	TrainingDate62 SMALLDATETIME NULL,
	
	ModelId63 VARCHAR(50) COLLATE database_default NULL,
	ModelName63 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel63 SMALLINT,
	AchievedLevel63 SMALLINT,
	Ok63 BIT,
	TrainingDate63 SMALLDATETIME NULL,
	
	ModelId64 VARCHAR(50) COLLATE database_default NULL,
	ModelName64 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel64 SMALLINT,
	AchievedLevel64 SMALLINT,
	Ok64 BIT,
	TrainingDate64 SMALLDATETIME NULL,
	
	ModelId65 VARCHAR(50) COLLATE database_default NULL,
	ModelName65 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel65 SMALLINT,
	AchievedLevel65 SMALLINT,
	Ok65 BIT,
	TrainingDate65 SMALLDATETIME NULL,
	
	ModelId66 VARCHAR(50) COLLATE database_default NULL,
	ModelName66 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel66 SMALLINT,
	AchievedLevel66 SMALLINT,
	Ok66 BIT,
	TrainingDate66 SMALLDATETIME NULL,
	
	ModelId67 VARCHAR(50) COLLATE database_default NULL,
	ModelName67 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel67 SMALLINT,
	AchievedLevel67 SMALLINT,
	Ok67 BIT,
	TrainingDate67 SMALLDATETIME NULL,
	
	ModelId68 VARCHAR(50) COLLATE database_default NULL,
	ModelName68 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel68 SMALLINT,
	AchievedLevel68 SMALLINT,
	Ok68 BIT,
	TrainingDate68 SMALLDATETIME NULL,
	
	ModelId69 VARCHAR(50) COLLATE database_default NULL,
	ModelName69 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel69 SMALLINT,
	AchievedLevel69 SMALLINT,
	Ok69 BIT,
	TrainingDate69 SMALLDATETIME NULL,
	
	ModelId70 VARCHAR(50) COLLATE database_default NULL,
	ModelName70 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel70 SMALLINT,
	AchievedLevel70 SMALLINT,
	Ok70 BIT,
	TrainingDate70 SMALLDATETIME NULL,

	ModelId71 VARCHAR(50) COLLATE database_default NULL,
	ModelName71 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel71 SMALLINT,
	AchievedLevel71 SMALLINT,
	Ok71 BIT,
	TrainingDate71 SMALLDATETIME NULL,
	
	ModelId72 VARCHAR(50) COLLATE database_default NULL,
	ModelName72 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel72 SMALLINT,
	AchievedLevel72 SMALLINT,
	Ok72 BIT,
	TrainingDate72 SMALLDATETIME NULL,
	
	ModelId73 VARCHAR(50) COLLATE database_default NULL,
	ModelName73 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel73 SMALLINT,
	AchievedLevel73 SMALLINT,
	Ok73 BIT,
	TrainingDate73 SMALLDATETIME NULL,
	
	ModelId74 VARCHAR(50) COLLATE database_default NULL,
	ModelName74 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel74 SMALLINT,
	AchievedLevel74 SMALLINT,
	Ok74 BIT,
	TrainingDate74 SMALLDATETIME NULL,
	
	ModelId75 VARCHAR(50) COLLATE database_default NULL,
	ModelName75 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel75 SMALLINT,
	AchievedLevel75 SMALLINT,
	Ok75 BIT,
	TrainingDate75 SMALLDATETIME NULL,
	
	ModelId76 VARCHAR(50) COLLATE database_default NULL,
	ModelName76 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel76 SMALLINT,
	AchievedLevel76 SMALLINT,
	Ok76 BIT,
	TrainingDate76 SMALLDATETIME NULL,
	
	ModelId77 VARCHAR(50) COLLATE database_default NULL,
	ModelName77 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel77 SMALLINT,
	AchievedLevel77 SMALLINT,
	Ok77 BIT,
	TrainingDate77 SMALLDATETIME NULL,
	
	ModelId78 VARCHAR(50) COLLATE database_default NULL,
	ModelName78 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel78 SMALLINT,
	AchievedLevel78 SMALLINT,
	Ok78 BIT,
	TrainingDate78 SMALLDATETIME NULL,
	
	ModelId79 VARCHAR(50) COLLATE database_default NULL,
	ModelName79 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel79 SMALLINT,
	AchievedLevel79 SMALLINT,
	Ok79 BIT,
	TrainingDate79 SMALLDATETIME NULL,
	
	ModelId80 VARCHAR(50) COLLATE database_default NULL,
	ModelName80 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel80 SMALLINT,
	AchievedLevel80 SMALLINT,
	Ok80 BIT,
	TrainingDate80 SMALLDATETIME NULL,

	ModelId81 VARCHAR(50) COLLATE database_default NULL,
	ModelName81 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel81 SMALLINT,
	AchievedLevel81 SMALLINT,
	Ok81 BIT,
	TrainingDate81 SMALLDATETIME NULL,
	
	ModelId82 VARCHAR(50) COLLATE database_default NULL,
	ModelName82 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel82 SMALLINT,
	AchievedLevel82 SMALLINT,
	Ok82 BIT,
	TrainingDate82 SMALLDATETIME NULL,
	
	ModelId83 VARCHAR(50) COLLATE database_default NULL,
	ModelName83 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel83 SMALLINT,
	AchievedLevel83 SMALLINT,
	Ok83 BIT,
	TrainingDate83 SMALLDATETIME NULL,
	
	ModelId84 VARCHAR(50) COLLATE database_default NULL,
	ModelName84 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel84 SMALLINT,
	AchievedLevel84 SMALLINT,
	Ok84 BIT,
	TrainingDate84 SMALLDATETIME NULL,
	
	ModelId85 VARCHAR(50) COLLATE database_default NULL,
	ModelName85 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel85 SMALLINT,
	AchievedLevel85 SMALLINT,
	Ok85 BIT,
	TrainingDate85 SMALLDATETIME NULL,
	
	ModelId86 VARCHAR(50) COLLATE database_default NULL,
	ModelName86 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel86 SMALLINT,
	AchievedLevel86 SMALLINT,
	Ok86 BIT,
	TrainingDate86 SMALLDATETIME NULL,
	
	ModelId87 VARCHAR(50) COLLATE database_default NULL,
	ModelName87 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel87 SMALLINT,
	AchievedLevel87 SMALLINT,
	Ok87 BIT,
	TrainingDate87 SMALLDATETIME NULL,
	
	ModelId88 VARCHAR(50) COLLATE database_default NULL,
	ModelName88 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel88 SMALLINT,
	AchievedLevel88 SMALLINT,
	Ok88 BIT,
	TrainingDate88 SMALLDATETIME NULL,
	
	ModelId89 VARCHAR(50) COLLATE database_default NULL,
	ModelName89 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel89 SMALLINT,
	AchievedLevel89 SMALLINT,
	Ok89 BIT,
	TrainingDate89 SMALLDATETIME NULL,
	
	ModelId90 VARCHAR(50) COLLATE database_default NULL,
	ModelName90 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel90 SMALLINT,
	AchievedLevel90 SMALLINT,
	Ok90 BIT,
	TrainingDate90 SMALLDATETIME NULL,

	ModelId91 VARCHAR(50) COLLATE database_default NULL,
	ModelName91 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel91 SMALLINT,
	AchievedLevel91 SMALLINT,
	Ok91 BIT,
	TrainingDate91 SMALLDATETIME NULL,
	
	ModelId92 VARCHAR(50) COLLATE database_default NULL,
	ModelName92 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel92 SMALLINT,
	AchievedLevel92 SMALLINT,
	Ok92 BIT,
	TrainingDate92 SMALLDATETIME NULL,
	
	ModelId93 VARCHAR(50) COLLATE database_default NULL,
	ModelName93 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel93 SMALLINT,
	AchievedLevel93 SMALLINT,
	Ok93 BIT,
	TrainingDate93 SMALLDATETIME NULL,
	
	ModelId94 VARCHAR(50) COLLATE database_default NULL,
	ModelName94 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel94 SMALLINT,
	AchievedLevel94 SMALLINT,
	Ok94 BIT,
	TrainingDate94 SMALLDATETIME NULL,
	
	ModelId95 VARCHAR(50) COLLATE database_default NULL,
	ModelName95 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel95 SMALLINT,
	AchievedLevel95 SMALLINT,
	Ok95 BIT,
	TrainingDate95 SMALLDATETIME NULL,
	
	ModelId96 VARCHAR(50) COLLATE database_default NULL,
	ModelName96 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel96 SMALLINT,
	AchievedLevel96 SMALLINT,
	Ok96 BIT,
	TrainingDate96 SMALLDATETIME NULL,
	
	ModelId97 VARCHAR(50) COLLATE database_default NULL,
	ModelName97 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel97 SMALLINT,
	AchievedLevel97 SMALLINT,
	Ok97 BIT,
	TrainingDate97 SMALLDATETIME NULL,
	
	ModelId98 VARCHAR(50) COLLATE database_default NULL,
	ModelName98 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel98 SMALLINT,
	AchievedLevel98 SMALLINT,
	Ok98 BIT,
	TrainingDate98 SMALLDATETIME NULL,
	
	ModelId99 VARCHAR(50) COLLATE database_default NULL,
	ModelName99 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel99 SMALLINT,
	AchievedLevel99 SMALLINT,
	Ok99 BIT,
	TrainingDate99 SMALLDATETIME NULL,
	
	ModelId100 VARCHAR(50) COLLATE database_default NULL,
	ModelName100 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel100 SMALLINT,
	AchievedLevel100 SMALLINT,
	Ok100 BIT,
	TrainingDate100 SMALLDATETIME NULL,

	ModelId101 VARCHAR(50) COLLATE database_default NULL,
	ModelName101 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel101 SMALLINT,
	AchievedLevel101 SMALLINT,
	Ok101 BIT,	
	TrainingDate101 SMALLDATETIME NULL,
	
	ModelId102 VARCHAR(50) COLLATE database_default NULL,
	ModelName102 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel102 SMALLINT,
	AchievedLevel102 SMALLINT,
	Ok102 BIT,
	TrainingDate102 SMALLDATETIME NULL,
	
	ModelId103 VARCHAR(50) COLLATE database_default NULL,
	ModelName103 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel103 SMALLINT,
	AchievedLevel103 SMALLINT,
	Ok103 BIT,
	TrainingDate103 SMALLDATETIME NULL,
	
	ModelId104 VARCHAR(50) COLLATE database_default NULL,
	ModelName104 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel104 SMALLINT,
	AchievedLevel104 SMALLINT,
	Ok104 BIT,
	TrainingDate104 SMALLDATETIME NULL,
	
	ModelId105 VARCHAR(50) COLLATE database_default NULL,
	ModelName105 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel105 SMALLINT,
	AchievedLevel105 SMALLINT,
	Ok105 BIT,
	TrainingDate105 SMALLDATETIME NULL,
	
	ModelId106 VARCHAR(50) COLLATE database_default NULL,
	ModelName106 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel106 SMALLINT,
	AchievedLevel106 SMALLINT,
	Ok106 BIT,
	TrainingDate106 SMALLDATETIME NULL,
	
	ModelId107 VARCHAR(50) COLLATE database_default NULL,
	ModelName107 VARCHAR(255) NULL,
	RequiredLevel107 SMALLINT,
	AchievedLevel107 SMALLINT,
	Ok107 BIT,
	TrainingDate107 SMALLDATETIME NULL,
	
	ModelId108 VARCHAR(50) COLLATE database_default NULL,
	ModelName108 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel108 SMALLINT,
	AchievedLevel108 SMALLINT,
	Ok108 BIT,
	TrainingDate108 SMALLDATETIME NULL,
	
	ModelId109 VARCHAR(50) COLLATE database_default NULL,
	ModelName109 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel109 SMALLINT,
	AchievedLevel109 SMALLINT,
	Ok109 BIT,
	TrainingDate109 SMALLDATETIME NULL,
	
	ModelId110 VARCHAR(50) COLLATE database_default NULL,
	ModelName110 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel110 SMALLINT,
	AchievedLevel110 SMALLINT,
	Ok110 BIT,
	TrainingDate110 SMALLDATETIME NULL,

	ModelId111 VARCHAR(50) COLLATE database_default NULL,
	ModelName111 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel111 SMALLINT,
	AchievedLevel111 SMALLINT,
	Ok111 BIT,
	TrainingDate111 SMALLDATETIME NULL,
	
	ModelId112 VARCHAR(50) COLLATE database_default NULL,
	ModelName112 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel112 SMALLINT,
	AchievedLevel112 SMALLINT,
	Ok112 BIT,
	TrainingDate112 SMALLDATETIME NULL,
	
	ModelId113 VARCHAR(50) COLLATE database_default NULL,
	ModelName113 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel113 SMALLINT,
	AchievedLevel113 SMALLINT,
	Ok113 BIT,
	TrainingDate113 SMALLDATETIME NULL,
	
	ModelId114 VARCHAR(50) COLLATE database_default NULL,
	ModelName114 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel114 SMALLINT,
	AchievedLevel114 SMALLINT,
	Ok114 BIT,
	TrainingDate114 SMALLDATETIME NULL,
	
	ModelId115 VARCHAR(50) COLLATE database_default NULL,
	ModelName115 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel115 SMALLINT,
	AchievedLevel115 SMALLINT,
	Ok115 BIT,
	TrainingDate115 SMALLDATETIME NULL,
	
	ModelId116 VARCHAR(50) COLLATE database_default NULL,
	ModelName116 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel116 SMALLINT,
	AchievedLevel116 SMALLINT,
	Ok116 BIT,
	TrainingDate116 SMALLDATETIME NULL,
	
	ModelId117 VARCHAR(50) COLLATE database_default NULL,
	ModelName117 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel117 SMALLINT,
	AchievedLevel117 SMALLINT,
	Ok117 BIT,
	TrainingDate117 SMALLDATETIME NULL,
	
	ModelId118 VARCHAR(50) COLLATE database_default NULL,
	ModelName118 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel118 SMALLINT,
	AchievedLevel118 SMALLINT,
	Ok118 BIT,
	TrainingDate118 SMALLDATETIME NULL,
	
	ModelId119 VARCHAR(50) COLLATE database_default NULL,
	ModelName119 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel119 SMALLINT,
	AchievedLevel119 SMALLINT,
	Ok119 BIT,
	TrainingDate119 SMALLDATETIME NULL,
	
	ModelId120 VARCHAR(50) COLLATE database_default NULL,
	ModelName120 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel120 SMALLINT,
	AchievedLevel120 SMALLINT,
	Ok120 BIT,
	TrainingDate120 SMALLDATETIME NULL,

	ModelId121 VARCHAR(50) COLLATE database_default NULL,
	ModelName121 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel121 SMALLINT,
	AchievedLevel121 SMALLINT,
	Ok121 BIT,
	TrainingDate121 SMALLDATETIME NULL,
	
	ModelId122 VARCHAR(50) COLLATE database_default NULL,
	ModelName122 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel122 SMALLINT,
	AchievedLevel122 SMALLINT,
	Ok122 BIT,
	TrainingDate122 SMALLDATETIME NULL,
	
	ModelId123 VARCHAR(50) COLLATE database_default NULL,
	ModelName123 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel123 SMALLINT,
	AchievedLevel123 SMALLINT,
	Ok123 BIT,
	TrainingDate123 SMALLDATETIME NULL,
	
	ModelId124 VARCHAR(50) COLLATE database_default NULL,
	ModelName124 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel124 SMALLINT,
	AchievedLevel124 SMALLINT,
	Ok124 BIT,
	TrainingDate124 SMALLDATETIME NULL,
	
	ModelId125 VARCHAR(50) COLLATE database_default NULL,
	ModelName125 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel125 SMALLINT,
	AchievedLevel125 SMALLINT,
	Ok125 BIT,
	TrainingDate125 SMALLDATETIME NULL,
	
	ModelId126 VARCHAR(50) COLLATE database_default NULL,
	ModelName126 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel126 SMALLINT,
	AchievedLevel126 SMALLINT,
	Ok126 BIT,
	TrainingDate126 SMALLDATETIME NULL,
	
	ModelId127 VARCHAR(50) COLLATE database_default NULL,
	ModelName127 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel127 SMALLINT,
	AchievedLevel127 SMALLINT,
	Ok127 BIT,
	TrainingDate127 SMALLDATETIME NULL,
	
	ModelId128 VARCHAR(50) COLLATE database_default NULL,
	ModelName128 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel128 SMALLINT,
	AchievedLevel128 SMALLINT,
	Ok128 BIT,
	TrainingDate128 SMALLDATETIME NULL,
	
	ModelId129 VARCHAR(50) COLLATE database_default NULL,
	ModelName129 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel129 SMALLINT,
	AchievedLevel129 SMALLINT,
	Ok129 BIT,
	TrainingDate129 SMALLDATETIME NULL,
	
	ModelId130 VARCHAR(50) COLLATE database_default NULL,
	ModelName130 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel130 SMALLINT,
	AchievedLevel130 SMALLINT,
	Ok130 BIT,
	TrainingDate130 SMALLDATETIME NULL,

	ModelId131 VARCHAR(50) COLLATE database_default NULL,
	ModelName131 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel131 SMALLINT,
	AchievedLevel131 SMALLINT,
	Ok131 BIT,
	TrainingDate131 SMALLDATETIME NULL,
	
	ModelId132 VARCHAR(50) COLLATE database_default NULL,
	ModelName132 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel132 SMALLINT,
	AchievedLevel132 SMALLINT,
	Ok132 BIT,
	TrainingDate132 SMALLDATETIME NULL,
	
	ModelId133 VARCHAR(50) COLLATE database_default NULL,
	ModelName133 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel133 SMALLINT,
	AchievedLevel133 SMALLINT,
	Ok133 BIT,
	TrainingDate133 SMALLDATETIME NULL,
	
	ModelId134 VARCHAR(50) COLLATE database_default NULL,
	ModelName134 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel134 SMALLINT,
	AchievedLevel134 SMALLINT,
	Ok134 BIT,
	TrainingDate134 SMALLDATETIME NULL,
	
	ModelId135 VARCHAR(50) COLLATE database_default NULL,
	ModelName135 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel135 SMALLINT,
	AchievedLevel135 SMALLINT,
	Ok135 BIT,
	TrainingDate135 SMALLDATETIME NULL,
	
	ModelId136 VARCHAR(50) COLLATE database_default NULL,
	ModelName136 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel136 SMALLINT,
	AchievedLevel136 SMALLINT,
	Ok136 BIT,
	TrainingDate136 SMALLDATETIME NULL,
	
	ModelId137 VARCHAR(50) COLLATE database_default NULL,
	ModelName137 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel137 SMALLINT,
	AchievedLevel137 SMALLINT,
	Ok137 BIT,
	TrainingDate137 SMALLDATETIME NULL,
	
	ModelId138 VARCHAR(50) COLLATE database_default NULL,
	ModelName138 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel138 SMALLINT,
	AchievedLevel138 SMALLINT,
	Ok138 BIT,
	TrainingDate138 SMALLDATETIME NULL,
	
	ModelId139 VARCHAR(50) COLLATE database_default NULL,
	ModelName139 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel139 SMALLINT,
	AchievedLevel139 SMALLINT,
	Ok139 BIT,
	TrainingDate139 SMALLDATETIME NULL,
	
	ModelId140 VARCHAR(50) COLLATE database_default NULL,
	ModelName140 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel140 SMALLINT,
	AchievedLevel140 SMALLINT,
	Ok140 BIT,
	TrainingDate140 SMALLDATETIME NULL,

	ModelId141 VARCHAR(50) COLLATE database_default NULL,
	ModelName141 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel141 SMALLINT,
	AchievedLevel141 SMALLINT,
	Ok141 BIT,
	TrainingDate141 SMALLDATETIME NULL,
	
	ModelId142 VARCHAR(50) COLLATE database_default NULL,
	ModelName142 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel142 SMALLINT,
	AchievedLevel142 SMALLINT,
	Ok142 BIT,
	TrainingDate142 SMALLDATETIME NULL,
	
	ModelId143 VARCHAR(50) COLLATE database_default NULL,
	ModelName143 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel143 SMALLINT,
	AchievedLevel143 SMALLINT,
	Ok143 BIT,
	TrainingDate143 SMALLDATETIME NULL,
	
	ModelId144 VARCHAR(50) COLLATE database_default NULL,
	ModelName144 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel144 SMALLINT,
	AchievedLevel144 SMALLINT,
	Ok144 BIT,
	TrainingDate144 SMALLDATETIME NULL,
	
	ModelId145 VARCHAR(50) COLLATE database_default NULL,
	ModelName145 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel145 SMALLINT,
	AchievedLevel145 SMALLINT,
	Ok145 BIT,
	TrainingDate145 SMALLDATETIME NULL,
	
	ModelId146 VARCHAR(50) COLLATE database_default NULL,
	ModelName146 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel146 SMALLINT,
	AchievedLevel146 SMALLINT,
	Ok146 BIT,
	TrainingDate146 SMALLDATETIME NULL,
	
	ModelId147 VARCHAR(50) COLLATE database_default NULL,
	ModelName147 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel147 SMALLINT,
	AchievedLevel147 SMALLINT,
	Ok147 BIT,
	TrainingDate147 SMALLDATETIME NULL,
	
	ModelId148 VARCHAR(50) COLLATE database_default NULL,
	ModelName148 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel148 SMALLINT,
	AchievedLevel148 SMALLINT,
	Ok148 BIT,
	TrainingDate148 SMALLDATETIME NULL,
	
	ModelId149 VARCHAR(50) COLLATE database_default NULL,
	ModelName149 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel149 SMALLINT,
	AchievedLevel149 SMALLINT,
	Ok149 BIT,
	TrainingDate149 SMALLDATETIME NULL,
	
	ModelId150 VARCHAR(50) COLLATE database_default NULL,
	ModelName150 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel150 SMALLINT,
	AchievedLevel150 SMALLINT,
	Ok150 BIT,
	TrainingDate150 SMALLDATETIME NULL,

	ModelId151 VARCHAR(50) COLLATE database_default NULL,
	ModelName151 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel151 SMALLINT,
	AchievedLevel151 SMALLINT,
	Ok151 BIT,	
	TrainingDate151 SMALLDATETIME NULL,
	
	ModelId152 VARCHAR(50) COLLATE database_default NULL,
	ModelName152 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel152 SMALLINT,
	AchievedLevel152 SMALLINT,
	Ok152 BIT,
	TrainingDate152 SMALLDATETIME NULL,
	
	ModelId153 VARCHAR(50) COLLATE database_default NULL,
	ModelName153 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel153 SMALLINT,
	AchievedLevel153 SMALLINT,
	Ok153 BIT,
	TrainingDate153 SMALLDATETIME NULL,
	
	ModelId154 VARCHAR(50) COLLATE database_default NULL,
	ModelName154 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel154 SMALLINT,
	AchievedLevel154 SMALLINT,
	Ok154 BIT,
	TrainingDate154 SMALLDATETIME NULL,
	
	ModelId155 VARCHAR(50) COLLATE database_default NULL,
	ModelName155 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel155 SMALLINT,
	AchievedLevel155 SMALLINT,
	Ok155 BIT,
	TrainingDate155 SMALLDATETIME NULL,
	
	ModelId156 VARCHAR(50) COLLATE database_default NULL,
	ModelName156 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel156 SMALLINT,
	AchievedLevel156 SMALLINT,
	Ok156 BIT,
	TrainingDate156 SMALLDATETIME NULL,
	
	ModelId157 VARCHAR(50) COLLATE database_default NULL,
	ModelName157 VARCHAR(255) NULL,
	RequiredLevel157 SMALLINT,
	AchievedLevel157 SMALLINT,
	Ok157 BIT,
	TrainingDate157 SMALLDATETIME NULL,
	
	ModelId158 VARCHAR(50) COLLATE database_default NULL,
	ModelName158 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel158 SMALLINT,
	AchievedLevel158 SMALLINT,
	Ok158 BIT,
	TrainingDate158 SMALLDATETIME NULL,
	
	ModelId159 VARCHAR(50) COLLATE database_default NULL,
	ModelName159 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel159 SMALLINT,
	AchievedLevel159 SMALLINT,
	Ok159 BIT,
	TrainingDate159 SMALLDATETIME NULL,

	ModelId160 VARCHAR(50) COLLATE database_default NULL,
	ModelName160 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel160 SMALLINT,
	AchievedLevel160 SMALLINT,
	Ok160 BIT,
	TrainingDate160 SMALLDATETIME NULL,

	ModelId161 VARCHAR(50) COLLATE database_default NULL,
	ModelName161 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel161 SMALLINT,
	AchievedLevel161 SMALLINT,
	Ok161 BIT,
	TrainingDate161 SMALLDATETIME NULL,
	
	ModelId162 VARCHAR(50) COLLATE database_default NULL,
	ModelName162 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel162 SMALLINT,
	AchievedLevel162 SMALLINT,
	Ok162 BIT,
	TrainingDate162 SMALLDATETIME NULL,
	
	ModelId163 VARCHAR(50) COLLATE database_default NULL,
	ModelName163 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel163 SMALLINT,
	AchievedLevel163 SMALLINT,
	Ok163 BIT,
	TrainingDate163 SMALLDATETIME NULL,
	
	ModelId164 VARCHAR(50) COLLATE database_default NULL,
	ModelName164 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel164 SMALLINT,
	AchievedLevel164 SMALLINT,
	Ok164 BIT,
	TrainingDate164 SMALLDATETIME NULL,
	
	ModelId165 VARCHAR(50) COLLATE database_default NULL,
	ModelName165 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel165 SMALLINT,
	AchievedLevel165 SMALLINT,
	Ok165 BIT,
	TrainingDate165 SMALLDATETIME NULL,
	
	ModelId166 VARCHAR(50) COLLATE database_default NULL,
	ModelName166 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel166 SMALLINT,
	AchievedLevel166 SMALLINT,
	Ok166 BIT,
	TrainingDate166 SMALLDATETIME NULL,
	
	ModelId167 VARCHAR(50) COLLATE database_default NULL,
	ModelName167 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel167 SMALLINT,
	AchievedLevel167 SMALLINT,
	Ok167 BIT,
	TrainingDate167 SMALLDATETIME NULL,
	
	ModelId168 VARCHAR(50) COLLATE database_default NULL,
	ModelName168 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel168 SMALLINT,
	AchievedLevel168 SMALLINT,
	Ok168 BIT,
	TrainingDate168 SMALLDATETIME NULL,
	
	ModelId169 VARCHAR(50) COLLATE database_default NULL,
	ModelName169 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel169 SMALLINT,
	AchievedLevel169 SMALLINT,
	Ok169 BIT,
	TrainingDate169 SMALLDATETIME NULL,
	
	ModelId170 VARCHAR(50) COLLATE database_default NULL,
	ModelName170 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel170 SMALLINT,
	AchievedLevel170 SMALLINT,
	Ok170 BIT,
	TrainingDate170 SMALLDATETIME NULL,
/*
	ModelId171 VARCHAR(50) COLLATE database_default NULL,
	ModelName171 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel171 SMALLINT,
	AchievedLevel171 SMALLINT,
	Ok171 BIT,
	TrainingDate171 SMALLDATETIME NULL,
	
	ModelId172 VARCHAR(50) COLLATE database_default NULL,
	ModelName172 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel172 SMALLINT,
	AchievedLevel172 SMALLINT,
	Ok172 BIT,
	TrainingDate172 SMALLDATETIME NULL,
	
	ModelId173 VARCHAR(50) COLLATE database_default NULL,
	ModelName173 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel173 SMALLINT,
	AchievedLevel173 SMALLINT,
	Ok173 BIT,
	TrainingDate173 SMALLDATETIME NULL,
	
	ModelId174 VARCHAR(50) COLLATE database_default NULL,
	ModelName174 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel174 SMALLINT,
	AchievedLevel174 SMALLINT,
	Ok174 BIT,
	TrainingDate174 SMALLDATETIME NULL,
	
	ModelId175 VARCHAR(50) COLLATE database_default NULL,
	ModelName175 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel175 SMALLINT,
	AchievedLevel175 SMALLINT,
	Ok175 BIT,
	TrainingDate175 SMALLDATETIME NULL,
	
	ModelId176 VARCHAR(50) COLLATE database_default NULL,
	ModelName176 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel176 SMALLINT,
	AchievedLevel176 SMALLINT,
	Ok176 BIT,
	TrainingDate176 SMALLDATETIME NULL,
	
	ModelId177 VARCHAR(50) COLLATE database_default NULL,
	ModelName177 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel177 SMALLINT,
	AchievedLevel177 SMALLINT,
	Ok177 BIT,
	TrainingDate177 SMALLDATETIME NULL,
	
	ModelId178 VARCHAR(50) COLLATE database_default NULL,
	ModelName178 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel178 SMALLINT,
	AchievedLevel178 SMALLINT,
	Ok178 BIT,
	TrainingDate178 SMALLDATETIME NULL,
	
	ModelId179 VARCHAR(50) COLLATE database_default NULL,
	ModelName179 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel179 SMALLINT,
	AchievedLevel179 SMALLINT,
	Ok179 BIT,
	TrainingDate179 SMALLDATETIME NULL,

	ModelId180 VARCHAR(50) COLLATE database_default NULL,
	ModelName180 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel180 SMALLINT,
	AchievedLevel180 SMALLINT,
	Ok180 BIT,
	TrainingDate180 SMALLDATETIME NULL,

	ModelId181 VARCHAR(50) COLLATE database_default NULL,
	ModelName181 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel181 SMALLINT,
	AchievedLevel181 SMALLINT,
	Ok181 BIT,
	TrainingDate181 SMALLDATETIME NULL,
	
	ModelId182 VARCHAR(50) COLLATE database_default NULL,
	ModelName182 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel182 SMALLINT,
	AchievedLevel182 SMALLINT,
	Ok182 BIT,
	TrainingDate182 SMALLDATETIME NULL,
	
	ModelId183 VARCHAR(50) COLLATE database_default NULL,
	ModelName183 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel183 SMALLINT,
	AchievedLevel183 SMALLINT,
	Ok183 BIT,
	TrainingDate183 SMALLDATETIME NULL,
	
	ModelId184 VARCHAR(50) COLLATE database_default NULL,
	ModelName184 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel184 SMALLINT,
	AchievedLevel184 SMALLINT,
	Ok184 BIT,
	TrainingDate184 SMALLDATETIME NULL,

	ModelId185 VARCHAR(50) COLLATE database_default NULL,
	ModelName185 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel185 SMALLINT,
	AchievedLevel185 SMALLINT,
	Ok185 BIT,
	TrainingDate185 SMALLDATETIME NULL,
	
	ModelId186 VARCHAR(50) COLLATE database_default NULL,
	ModelName186 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel186 SMALLINT,
	AchievedLevel186 SMALLINT,
	Ok186 BIT,
	TrainingDate186 SMALLDATETIME NULL,
	
	ModelId187 VARCHAR(50) COLLATE database_default NULL,
	ModelName187 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel187 SMALLINT,
	AchievedLevel187 SMALLINT,
	Ok187 BIT,
	TrainingDate187 SMALLDATETIME NULL,
	
	ModelId188 VARCHAR(50) COLLATE database_default NULL,
	ModelName188 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel188 SMALLINT,
	AchievedLevel188 SMALLINT,
	Ok188 BIT,
	TrainingDate188 SMALLDATETIME NULL,
	
	ModelId189 VARCHAR(50) COLLATE database_default NULL,
	ModelName189 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel189 SMALLINT,
	AchievedLevel189 SMALLINT,
	Ok189 BIT,
	TrainingDate189 SMALLDATETIME NULL,	

	ModelId190 VARCHAR(50) COLLATE database_default NULL,
	ModelName190 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel190 SMALLINT,
	AchievedLevel190 SMALLINT,
	Ok190 BIT,
	TrainingDate190 SMALLDATETIME NULL,

	ModelId191 VARCHAR(50) COLLATE database_default NULL,
	ModelName191 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel191 SMALLINT,
	AchievedLevel191 SMALLINT,
	Ok191 BIT,
	TrainingDate191 SMALLDATETIME NULL,
	
	ModelId192 VARCHAR(50) COLLATE database_default NULL,
	ModelName192 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel192 SMALLINT,
	AchievedLevel192 SMALLINT,
	Ok192 BIT,
	TrainingDate192 SMALLDATETIME NULL,
	
	ModelId193 VARCHAR(50) COLLATE database_default NULL,
	ModelName193 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel193 SMALLINT,
	AchievedLevel193 SMALLINT,
	Ok193 BIT,
	TrainingDate193 SMALLDATETIME NULL,
	
	ModelId194 VARCHAR(50) COLLATE database_default NULL,
	ModelName194 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel194 SMALLINT,
	AchievedLevel194 SMALLINT,
	Ok194 BIT,
	TrainingDate194 SMALLDATETIME NULL,
	
	ModelId195 VARCHAR(50) COLLATE database_default NULL,
	ModelName195 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel195 SMALLINT,
	AchievedLevel195 SMALLINT,
	Ok195 BIT,
	TrainingDate195 SMALLDATETIME NULL,

	ModelId196 VARCHAR(50) COLLATE database_default NULL,
	ModelName196 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel196 SMALLINT,
	AchievedLevel196 SMALLINT,
	Ok196 BIT,
	TrainingDate196 SMALLDATETIME NULL,
	
	ModelId197 VARCHAR(50) COLLATE database_default NULL,
	ModelName197 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel197 SMALLINT,
	AchievedLevel197 SMALLINT,
	Ok197 BIT,
	TrainingDate197 SMALLDATETIME NULL,
	
	ModelId198 VARCHAR(50) COLLATE database_default NULL,
	ModelName198 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel198 SMALLINT,
	AchievedLevel198 SMALLINT,
	Ok198 BIT,
	TrainingDate198 SMALLDATETIME NULL,
	
	ModelId199 VARCHAR(50) COLLATE database_default NULL,
	ModelName199 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel199 SMALLINT,
	AchievedLevel199 SMALLINT,
	Ok199 BIT,
	TrainingDate199 SMALLDATETIME NULL,
	
	ModelId200 VARCHAR(50) COLLATE database_default NULL,
	ModelName200 VARCHAR(155) COLLATE database_default NULL,
	RequiredLevel200 SMALLINT,
	AchievedLevel200 SMALLINT,
	Ok200 BIT,
	TrainingDate200 SMALLDATETIME NULL,
*/
	RequiredCount SMALLINT,
	AchievedCount SMALLINT)
	
	
	CREATE UNIQUE INDEX TmpPersonnelIdx
	ON #RetVal (PersonnelId)

	DECLARE @Sql NVARCHAR(MAX)		
		
	--
	-- Remove option to show children if parent is not specified
	IF ISNULL(@LocationId, '') = ''
		SET @IncludeLocationChildren = 0

	IF ISNULL(@BranchId, '') = ''
		SET @IncludeBranchChildren = 0

---------------------------------------------------------------------------------------------------------
--	1. GET A LIST OF MODELS
---------------------------------------------------------------------------------------------------------
	DECLARE @CsrModel CURSOR
	
	IF ISNULL(@IncludeLocationChildren, 0) = 0 AND ISNULL(@IncludeBranchChildren, 0) = 0
	BEGIN
		--
		-- NEITHER branch NOR location children are to be included
		SET @CsrModel = CURSOR SCROLL READ_ONLY FOR
		SELECT DISTINCT TOP 170 Model.ModelId, ModelShortName, CategoryShortName,
			ISNULL(RL2.RiskLevelShortName, ISNULL(RL1.RiskLevelShortName, '')) AS RiskLevel,
			CASE 
				WHEN RL2.RiskLevelClassId = 'HIGH'
					THEN 0
				WHEN RL2.RiskLevelClassId = 'MEDIUM'
					THEN 1
				WHEN RL2.RiskLevelClassId = 'LOW'
					THEN 2
				WHEN RL2.RiskLevelClassId IS NULL AND RL1.RiskLevelClassId = 'HIGH'
					THEN 0
				WHEN RL2.RiskLevelClassId IS NULL AND RL1.RiskLevelClassId = 'MEDIUM'
					THEN 1
				WHEN RL2.RiskLevelClassId IS NULL AND RL1.RiskLevelClassId = 'LOW'
					THEN 2
				ELSE 3
			END AS RiskLevelVal
		FROM PersonnelCompetence AS PC
			INNER JOIN Personnel AS P1
				ON PC.PersonnelId = P1.PersonnelId
			INNER JOIN Model
				ON PC.ModelId = Model.ModelId
			LEFT JOIN RiskLevel AS RL1
				ON Model.RiskLevelId = RL1.RiskLevelId
			LEFT JOIN RiskLevel AS RL2
				ON Model.TrainingRiskId = RL2.RiskLevelId
			LEFT JOIN Category
				ON Model.CategoryId = Category.CategoryId
			INNER JOIN CompetenceType AS CT
				ON PC.RequiredCompetenceTypeId = CT.CompetenceTypeID
			INNER JOIN CompetenceGroupModel CGM -- Added INNER JOIN and additonal where conditions to model select to account for competence group model (#14521)
				ON CGM.ModelId = Model.ModelId
		WHERE ISNULL(PC.Inactive, 0) != 1 AND
			ISNULL(P1.Inactive, 0) != 1 AND
			ISNULL(Model.Inactive, 0) != 1 AND
			ISNULL(LongTermLeave, 0) = 0 AND
			ISNULL(MaternityLeave, 0) = 0 AND
			P1.LeavingDate IS NULL AND
			CAST(CT.CompetenceTypeClassId AS INT) > 0 AND
			dbo.CompareWithNullableVariable(P1.OrganisationId, @OrganisationId) = ISNULL(@OrganisationId, '###_MATCH_ALL_###') AND
			dbo.CompareWithNullableVariable(P1.BranchId, @BranchId) = ISNULL(@BranchId, '###_MATCH_ALL_###') AND
			dbo.CompareWithNullableVariable(P1.LocationId, @LocationId) = ISNULL(@LocationId, '###_MATCH_ALL_###') AND
			dbo.CompareWithNullableVariable(P1.SiteId, @SiteId) = ISNULL(@SiteId, '###_MATCH_ALL_###') AND
			dbo.CompareWithNullableVariable(P1.PersonnelId, @PersonId) = ISNULL(@PersonId, '###_MATCH_ALL_###') AND
			CompetenceGroupId IN (SELECT value FROM StringListToTable(@CompetenceGroupId)) AND -- Added INNER JOIN and additonal where conditions to model select to account for competence group model (#14521)  
			(
				@RiskLevelClassId IS NULL OR
				ISNULL(RL2.RiskLevelClassId, RL1.RiskLevelClassId) = @RiskLevelClassId
			)
		ORDER BY  RiskLevelVal, RiskLevel, ModelShortName
	END
	ELSE IF ISNULL(@IncludeLocationChildren, 0) = 1 AND ISNULL(@IncludeBranchChildren, 0) = 1
	BEGIN
		--
		-- BOTH branch AND location children are to be included
		SET @CsrModel = CURSOR SCROLL READ_ONLY FOR
		SELECT DISTINCT TOP 170 Model.ModelId, ModelShortName, CategoryShortName,
			ISNULL(RL2.RiskLevelShortName, ISNULL(RL1.RiskLevelShortName, '')) AS RiskLevel,
			CASE 
				WHEN RL2.RiskLevelClassId = 'HIGH'
					THEN 0
				WHEN RL2.RiskLevelClassId = 'MEDIUM'
					THEN 1
				WHEN RL2.RiskLevelClassId = 'LOW'
					THEN 2
				WHEN RL2.RiskLevelClassId IS NULL AND RL1.RiskLevelClassId = 'HIGH'
					THEN 0
				WHEN RL2.RiskLevelClassId IS NULL AND RL1.RiskLevelClassId = 'MEDIUM'
					THEN 1
				WHEN RL2.RiskLevelClassId IS NULL AND RL1.RiskLevelClassId = 'LOW'
					THEN 2
				ELSE 3
			END AS RiskLevelVal
		FROM PersonnelCompetence AS PC
			INNER JOIN Personnel AS P1
				ON PC.PersonnelId = P1.PersonnelId
			INNER JOIN Model
				ON PC.ModelId = Model.ModelId
			LEFT JOIN RiskLevel AS RL1
				ON Model.RiskLevelId = RL1.RiskLevelId
			LEFT JOIN RiskLevel AS RL2
				ON Model.TrainingRiskId = RL2.RiskLevelId
			LEFT JOIN Category
				ON Model.CategoryId = Category.CategoryId
			INNER JOIN CompetenceType AS CT
				ON PC.RequiredCompetenceTypeId = CT.CompetenceTypeID
			LEFT JOIN Branch
				ON P1.BranchId = Branch.BranchId
			LEFT JOIN Location
				ON P1.LocationId = Location.LocationId
			INNER JOIN CompetenceGroupModel CGM -- Added INNER JOIN and additonal where conditions to model select to account for competence group model (#14521)
				ON CGM.ModelId = Model.ModelId
		WHERE ISNULL(PC.Inactive, 0) != 1 AND
			ISNULL(P1.Inactive, 0) != 1 AND
			ISNULL(Model.Inactive, 0) != 1 AND
			ISNULL(LongTermLeave, 0) = 0 AND
			ISNULL(MaternityLeave, 0) = 0 AND
			P1.LeavingDate IS NULL AND
			CAST(CT.CompetenceTypeClassId AS INT) > 0 AND
			dbo.CompareWithNullableVariable(P1.OrganisationId, @OrganisationId) = ISNULL(@OrganisationId, '###_MATCH_ALL_###') AND
			Branch.[Path] LIKE '%/' + RTRIM(@BranchId) + '/%' AND
			Location.[Path] LIKE '%/' + RTRIM(@LocationId) + '/%' AND
			dbo.CompareWithNullableVariable(P1.SiteId, @SiteId) = ISNULL(@SiteId, '###_MATCH_ALL_###') AND
			dbo.CompareWithNullableVariable(P1.PersonnelId, @PersonId) = ISNULL(@PersonId, '###_MATCH_ALL_###') AND
			CompetenceGroupId IN (SELECT value FROM StringListToTable(@CompetenceGroupId)) AND -- Added INNER JOIN and additonal where conditions to model select to account for competence group model (#14521)  
			(
				@RiskLevelClassId IS NULL OR
				ISNULL(RL2.RiskLevelClassId, RL1.RiskLevelClassId) = @RiskLevelClassId
			)
		ORDER BY  RiskLevelVal, RiskLevel, ModelShortName
	END
	ELSE IF ISNULL(@IncludeBranchChildren, 0) = 1
	BEGIN
		--
		-- ONLY branch children are to be included
		SET @CsrModel = CURSOR SCROLL READ_ONLY FOR
		SELECT DISTINCT TOP 170 Model.ModelId, ModelShortName, CategoryShortName,
			ISNULL(RL2.RiskLevelShortName, ISNULL(RL1.RiskLevelShortName, '')) AS RiskLevel,
			CASE 
				WHEN RL2.RiskLevelClassId = 'HIGH'
					THEN 0
				WHEN RL2.RiskLevelClassId = 'MEDIUM'
					THEN 1
				WHEN RL2.RiskLevelClassId = 'LOW'
					THEN 2
				WHEN RL2.RiskLevelClassId IS NULL AND RL1.RiskLevelClassId = 'HIGH'
					THEN 0
				WHEN RL2.RiskLevelClassId IS NULL AND RL1.RiskLevelClassId = 'MEDIUM'
					THEN 1
				WHEN RL2.RiskLevelClassId IS NULL AND RL1.RiskLevelClassId = 'LOW'
					THEN 2
				ELSE 3
			END AS RiskLevelVal
		FROM PersonnelCompetence AS PC
			INNER JOIN Personnel AS P1
				ON PC.PersonnelId = P1.PersonnelId
			INNER JOIN Model
				ON PC.ModelId = Model.ModelId
			LEFT JOIN RiskLevel AS RL1
				ON Model.RiskLevelId = RL1.RiskLevelId
			LEFT JOIN RiskLevel AS RL2
				ON Model.TrainingRiskId = RL2.RiskLevelId
			LEFT JOIN Category
				ON Model.CategoryId = Category.CategoryId
			INNER JOIN CompetenceType AS CT
				ON PC.RequiredCompetenceTypeId = CT.CompetenceTypeID
			LEFT JOIN Branch
				ON P1.BranchId = Branch.BranchId
			INNER JOIN CompetenceGroupModel CGM -- Added INNER JOIN and additonal where conditions to model select to account for competence group model (#14521)
				ON CGM.ModelId = Model.ModelId
		WHERE ISNULL(PC.Inactive, 0) != 1 AND
			ISNULL(P1.Inactive, 0) != 1 AND
			ISNULL(Model.Inactive, 0) != 1 AND
			ISNULL(LongTermLeave, 0) = 0 AND
			ISNULL(MaternityLeave, 0) = 0 AND
			P1.LeavingDate IS NULL AND
			CAST(CT.CompetenceTypeClassId AS INT) > 0 AND
			dbo.CompareWithNullableVariable(P1.OrganisationId, @OrganisationId) = ISNULL(@OrganisationId, '###_MATCH_ALL_###') AND
			Branch.[Path] LIKE '%/' + RTRIM(@BranchId) + '/%' AND
			dbo.CompareWithNullableVariable(P1.LocationId, @LocationId) = ISNULL(@LocationId, '###_MATCH_ALL_###') AND
			dbo.CompareWithNullableVariable(P1.SiteId, @SiteId) = ISNULL(@SiteId, '###_MATCH_ALL_###') AND
			dbo.CompareWithNullableVariable(P1.PersonnelId, @PersonId) = ISNULL(@PersonId, '###_MATCH_ALL_###') AND
			CompetenceGroupId IN (SELECT value FROM StringListToTable(@CompetenceGroupId)) AND -- Added INNER JOIN and additonal where conditions to model select to account for competence group model (#14521)  
			(
				@RiskLevelClassId IS NULL OR
				ISNULL(RL2.RiskLevelClassId, RL1.RiskLevelClassId) = @RiskLevelClassId
			)
		ORDER BY  RiskLevelVal, RiskLevel, ModelShortName
	END
	ELSE
	BEGIN
		--
		-- ONLY location children are to be included
		SET @CsrModel = CURSOR SCROLL READ_ONLY FOR
		SELECT DISTINCT TOP 170 Model.ModelId, ModelShortName, CategoryShortName,
			ISNULL(RL2.RiskLevelShortName, ISNULL(RL1.RiskLevelShortName, '')) AS RiskLevel,
			CASE 
				WHEN RL2.RiskLevelClassId = 'HIGH'
					THEN 0
				WHEN RL2.RiskLevelClassId = 'MEDIUM'
					THEN 1
				WHEN RL2.RiskLevelClassId = 'LOW'
					THEN 2
				WHEN RL2.RiskLevelClassId IS NULL AND RL1.RiskLevelClassId = 'HIGH'
					THEN 0
				WHEN RL2.RiskLevelClassId IS NULL AND RL1.RiskLevelClassId = 'MEDIUM'
					THEN 1
				WHEN RL2.RiskLevelClassId IS NULL AND RL1.RiskLevelClassId = 'LOW'
					THEN 2
				ELSE 3
			END AS RiskLevelVal
		FROM PersonnelCompetence AS PC
			INNER JOIN Personnel AS P1
				ON PC.PersonnelId = P1.PersonnelId
			INNER JOIN Model
				ON PC.ModelId = Model.ModelId
			LEFT JOIN RiskLevel AS RL1
				ON Model.RiskLevelId = RL1.RiskLevelId
			LEFT JOIN RiskLevel AS RL2
				ON Model.TrainingRiskId = RL2.RiskLevelId
			LEFT JOIN Category
				ON Model.CategoryId = Category.CategoryId
			INNER JOIN CompetenceType AS CT
				ON PC.RequiredCompetenceTypeId = CT.CompetenceTypeID
			LEFT JOIN Location
				ON P1.LocationId = Location.LocationId
			INNER JOIN CompetenceGroupModel CGM -- Added INNER JOIN and additonal where conditions to model select to account for competence group model (#14521)
				ON CGM.ModelId = Model.ModelId
		WHERE ISNULL(PC.Inactive, 0) != 1 AND
			ISNULL(P1.Inactive, 0) != 1 AND
			ISNULL(Model.Inactive, 0) != 1 AND
			ISNULL(LongTermLeave, 0) = 0 AND
			ISNULL(MaternityLeave, 0) = 0 AND
			P1.LeavingDate IS NULL AND
			CAST(CT.CompetenceTypeClassId AS INT) > 0 AND
			dbo.CompareWithNullableVariable(P1.OrganisationId, @OrganisationId) = ISNULL(@OrganisationId, '###_MATCH_ALL_###') AND
			dbo.CompareWithNullableVariable(P1.BranchId, @BranchId) = ISNULL(@BranchId, '###_MATCH_ALL_###') AND
			Location.[Path] LIKE '%/' + RTRIM(@LocationId) + '/%' AND
			dbo.CompareWithNullableVariable(P1.SiteId, @SiteId) = ISNULL(@SiteId, '###_MATCH_ALL_###') AND
			dbo.CompareWithNullableVariable(P1.PersonnelId, @PersonId) = ISNULL(@PersonId, '###_MATCH_ALL_###') AND
			CompetenceGroupId IN (SELECT value FROM StringListToTable(@CompetenceGroupId)) AND -- Added INNER JOIN and additonal where conditions to model select to account for competence group model (#14521)  
			(
				@RiskLevelClassId IS NULL OR
				ISNULL(RL2.RiskLevelClassId, RL1.RiskLevelClassId) = @RiskLevelClassId
			)
		ORDER BY  RiskLevelVal, RiskLevel, ModelShortName
	END

	OPEN @CsrModel

---------------------------------------------------------------------------------------------------------
--	2. GET A LIST OF PEOPLE
---------------------------------------------------------------------------------------------------------

	--
	-- FOREACH Person in the report ...
	DECLARE @CsrPerson CURSOR
	
	IF ISNULL(@IncludeLocationChildren, 0) = 0 AND ISNULL(@IncludeBranchChildren, 0) = 0
	BEGIN
		--
		-- NEITHER branch NOR location children are to be included
		SET @CsrPerson = CURSOR READ_ONLY FOR
		SELECT DISTINCT PersonnelId, PersonnelShortName
		FROM vsCompetenceGroupTNA
			LEFT JOIN Branch
				ON vsCompetenceGroupTNA.BranchId = Branch.BranchId
			LEFT JOIN Organisation
				ON Branch.OrganisationId = Organisation.OrganisationId
			LEFT JOIN Location
				ON vsCompetenceGroupTNA.LocationId = Location.LocationId
			LEFT JOIN [Site]
				ON Location.SiteId = [Site].SiteId
		WHERE ISNULL(PersonnelShortName, '') != '' AND
			ISNULL(LongTermLeave, 0) = 0 AND
			ISNULL(MaternityLeave, 0) = 0 AND
			LeavingDate IS NULL AND
			dbo.CompareWithNullableVariable(Organisation.OrganisationId, @OrganisationId) = ISNULL(@OrganisationId, '###_MATCH_ALL_###') AND
			dbo.CompareWithNullableVariable(vsCompetenceGroupTNA.BranchId, @BranchId) = ISNULL(@BranchId, '###_MATCH_ALL_###') AND
			dbo.CompareWithNullableVariable(vsCompetenceGroupTNA.LocationId, @LocationId) = ISNULL(@LocationId, '###_MATCH_ALL_###') AND
			dbo.CompareWithNullableVariable([Site].SiteId, @SiteId) = ISNULL(@SiteId, '###_MATCH_ALL_###') AND
			CompetenceGroupId IN (SELECT value FROM StringListToTable(@CompetenceGroupId)) AND
			dbo.CompareWithNullableVariable(vsCompetenceGroupTNA.PersonnelId, @PersonId) = ISNULL(@PersonId, '###_MATCH_ALL_###') AND
			(
				@RiskLevelClassId IS NULL OR
				RiskLevelClassId = @RiskLevelClassId
			) AND
			ISNULL(vsCompetenceGroupTNA.Inactive, 0) != 1 
		ORDER BY PersonnelShortName
	END
	ELSE IF ISNULL(@IncludeLocationChildren, 0) = 1 AND ISNULL(@IncludeBranchChildren, 0) = 1
	BEGIN
		--
		-- BOTH branch AND location children are to be included
		SET @CsrPerson = CURSOR READ_ONLY FOR
		SELECT DISTINCT PersonnelId, PersonnelShortName
		FROM vsCompetenceGroupTNA
			LEFT JOIN Branch
				ON vsCompetenceGroupTNA.BranchId = Branch.BranchId
			LEFT JOIN Organisation
				ON Branch.OrganisationId = Organisation.OrganisationId
			LEFT JOIN Location
				ON vsCompetenceGroupTNA.LocationId = Location.LocationId
			LEFT JOIN [Site]
				ON Location.SiteId = [Site].SiteId
		WHERE ISNULL(PersonnelShortName, '') != '' AND
			ISNULL(LongTermLeave, 0) = 0 AND
			ISNULL(MaternityLeave, 0) = 0 AND
			LeavingDate IS NULL AND
			dbo.CompareWithNullableVariable(Organisation.OrganisationId, @OrganisationId) = ISNULL(@OrganisationId, '###_MATCH_ALL_###') AND
			Branch.[Path] LIKE '%/' + RTRIM(@BranchId) + '/%' AND
			Location.[Path] LIKE '%/' + RTRIM(@LocationId) + '/%' AND
			dbo.CompareWithNullableVariable([Site].SiteId, @SiteId) = ISNULL(@SiteId, '###_MATCH_ALL_###') AND
			CompetenceGroupId IN (SELECT value FROM StringListToTable(@CompetenceGroupId)) AND
			dbo.CompareWithNullableVariable(vsCompetenceGroupTNA.PersonnelId, @PersonId) = ISNULL(@PersonId, '###_MATCH_ALL_###') AND
			(
				@RiskLevelClassId IS NULL OR
				RiskLevelClassId = @RiskLevelClassId
			) AND
			ISNULL(vsCompetenceGroupTNA.Inactive, 0) != 1 
		ORDER BY PersonnelShortName
	END
	ELSE IF ISNULL(@IncludeBranchChildren, 0) = 1
	BEGIN
		--
		-- ONLY branch children are to be included
		SET @CsrPerson = CURSOR READ_ONLY FOR
		SELECT DISTINCT PersonnelId, PersonnelShortName
		FROM vsCompetenceGroupTNA
			LEFT JOIN Branch
				ON vsCompetenceGroupTNA.BranchId = Branch.BranchId
			LEFT JOIN Organisation
				ON Branch.OrganisationId = Organisation.OrganisationId
			LEFT JOIN Location
				ON vsCompetenceGroupTNA.LocationId = Location.LocationId
			LEFT JOIN [Site]
				ON Location.SiteId = [Site].SiteId
		WHERE ISNULL(PersonnelShortName, '') != '' AND
			ISNULL(LongTermLeave, 0) = 0 AND
			ISNULL(MaternityLeave, 0) = 0 AND
			LeavingDate IS NULL AND
			dbo.CompareWithNullableVariable(Organisation.OrganisationId, @OrganisationId) = ISNULL(@OrganisationId, '###_MATCH_ALL_###') AND
			Branch.[Path] LIKE '%/' + RTRIM(@BranchId) + '/%' AND
			dbo.CompareWithNullableVariable(vsCompetenceGroupTNA.LocationId, @LocationId) = ISNULL(@LocationId, '###_MATCH_ALL_###') AND
			dbo.CompareWithNullableVariable([Site].SiteId, @SiteId) = ISNULL(@SiteId, '###_MATCH_ALL_###') AND
			CompetenceGroupId IN (SELECT value FROM StringListToTable(@CompetenceGroupId)) AND
			dbo.CompareWithNullableVariable(vsCompetenceGroupTNA.PersonnelId, @PersonId) = ISNULL(@PersonId, '###_MATCH_ALL_###') AND
			(
				@RiskLevelClassId IS NULL OR
				RiskLevelClassId = @RiskLevelClassId
			) AND
			ISNULL(vsCompetenceGroupTNA.Inactive, 0) != 1 
		ORDER BY PersonnelShortName
	END
	ELSE 
	BEGIN
		--
		-- ONLY location children are to be included
		SET @CsrPerson = CURSOR READ_ONLY FOR
		SELECT DISTINCT PersonnelId, PersonnelShortName
		FROM vsCompetenceGroupTNA
			LEFT JOIN Branch
				ON vsCompetenceGroupTNA.BranchId = Branch.BranchId
			LEFT JOIN Organisation
				ON Branch.OrganisationId = Organisation.OrganisationId
			LEFT JOIN Location
				ON vsCompetenceGroupTNA.LocationId = Location.LocationId
			LEFT JOIN [Site]
				ON Location.SiteId = [Site].SiteId
		WHERE ISNULL(PersonnelShortName, '') != '' AND
			ISNULL(LongTermLeave, 0) = 0 AND
			ISNULL(MaternityLeave, 0) = 0 AND
			LeavingDate IS NULL AND
			dbo.CompareWithNullableVariable(Organisation.OrganisationId, @OrganisationId) = ISNULL(@OrganisationId, '###_MATCH_ALL_###') AND
			dbo.CompareWithNullableVariable(vsCompetenceGroupTNA.BranchId, @BranchId) = ISNULL(@BranchId, '###_MATCH_ALL_###') AND
			Location.[Path] LIKE '%/' + RTRIM(@LocationId) + '/%' AND
			dbo.CompareWithNullableVariable([Site].SiteId, @SiteId) = ISNULL(@SiteId, '###_MATCH_ALL_###') AND
			CompetenceGroupId IN (SELECT value FROM StringListToTable(@CompetenceGroupId)) AND
			dbo.CompareWithNullableVariable(vsCompetenceGroupTNA.PersonnelId, @PersonId) = ISNULL(@PersonId, '###_MATCH_ALL_###') AND
			(
				@RiskLevelClassId IS NULL OR
				RiskLevelClassId = @RiskLevelClassId
			) AND
			ISNULL(vsCompetenceGroupTNA.Inactive, 0) != 1 
		ORDER BY PersonnelShortName
	END

	OPEN @CsrPerson

	DECLARE @PersonnelId VARCHAR(50)
	DECLARE @PersonnelShortName VARCHAR(255)
	DECLARE @PersonReqdCount INT
	DECLARE @PersonAttndCount INT
	
	FETCH NEXT FROM @CsrPerson 
	INTO @PersonnelId, @PersonnelShortName

	--
	-- FOREACH Person ...
	DECLARE @PersonnelNo INT
	SET @PersonnelNo  = 1

	WHILE @@FETCH_STATUS = 0
	BEGIN
		--
		-- Add the person to the output table
		IF ISNULL(@CompetenceGroupId, '') != '' AND
				NOT EXISTS
					(
					SELECT *
					FROM CompetenceGroupPersonnel
					WHERE CompetenceGroupId IN (SELECT value FROM StringListToTable(@CompetenceGroupId)) AND
						PersonnelId = @PersonnelId
					)
			GOTO SkipPerson

		INSERT INTO #RetVal
			(PersonnelId) 
		VALUES
			(@PersonnelId)

		--
		-- Zero counters
		SET @PersonReqdCount = 0
		SET @PersonAttndCount = 0

		--
		-- Add each model for this person to the output table
		DECLARE @ModelId VARCHAR(50)
		DECLARE @ModelShortName VARCHAR(255)
		DECLARE @CategoryShortName VARCHAR(255)
		DECLARE @RiskLevelVal INT
		DECLARE @RiskLevel VARCHAR(255)

		FETCH FIRST FROM @CsrModel 
		INTO @ModelId, @ModelShortName, @CategoryShortName, @RiskLevel, @RiskLevelVal

		--
		-- FOREACH Model ..
		DECLARE @ModelNo INT
		SET @ModelNo = 1

		WHILE @@FETCH_STATUS = 0
		BEGIN
			IF ISNULL(@CompetenceGroupId, '') != '' AND NOT EXISTS
					(
					SELECT *
					FROM CompetenceGroupModel
					WHERE CompetenceGroupId IN (SELECT value FROM StringListToTable(@CompetenceGroupId)) AND
						ModelId  = @ModelId
					)
				GOTO SkipModel

			--
			-- Find requirements/achievements for this person/model
			DECLARE @Reqd VARCHAR(50)
			DECLARE @Attnd VARCHAR(50)
			DECLARE @iReqd INT
			DECLARE @iAttnd INT
			DECLARE @Ok BIT
			DECLARE @TrainingDate SMALLDATETIME
			DECLARE @ReviewDate SMALLDATETIME
	
			SET @Reqd = NULL
			SET @Attnd = NULL
			SET @TrainingDate = NULL
			SET @ReviewDate = NULL
			SET @Ok = 0

			SELECT @Reqd = CT1.CompetenceTypeClassId, @Attnd = CT2.CompetenceTypeClassId,
				@TrainingDate = TrainingDate 
			FROM PersonnelCompetence AS PC
				LEFT JOIN CompetenceType AS CT1
					ON PC.RequiredCompetenceTypeId = CT1.CompetenceTypeId
				LEFT JOIN CompetenceType AS CT2
					ON PC.AttainedCompetenceTypeId = CT2.CompetenceTypeId
			WHERE PersonnelId = @PersonnelId AND
				ModelId = @ModelId

			--
			-- Get requirements/achievements as INTs
			IF @Reqd IS NOT NULL
				SET @iReqd = CAST(@Reqd AS INT)
			ELSE
				SET @iReqd = 0

			IF @Attnd IS NOT NULL
				SET @iAttnd = CAST(@Attnd AS INT)
			ELSE
				SET @iAttnd = 0

			IF @iReqd > 0
			BEGIN
				--
				-- Some level of competence is required
				SET @PersonReqdCount = @PersonReqdCount + 1

				IF @iAttnd >= @iReqd
				BEGIN
					--
					-- Required competence has been achieved. Has it expired
					SELECT @ReviewDate = dbo.CalculateRefresherTrainingDue(@PersonnelId, @ModelId)
					
					IF @ReviewDate IS NOT NULL AND @ReviewDate >= GETDATE()
					BEGIN
						SET @Ok = 1
						SET @PersonAttndCount = @PersonAttndCount + 1
					END
				END
			END
			ELSE
			BEGIN
				SET @Ok = 1
			END

			SET @Sql = N'UPDATE #RetVal
				SET RequiredLevel' + LTRIM(RTRIM(CONVERT(VARCHAR(3), @ModelNo))) + ' = @iReqd,
					AchievedLevel' + LTRIM(RTRIM(CONVERT(VARCHAR(3), @ModelNo))) + ' = @iAttnd,
					TrainingDate' + LTRIM(RTRIM(CONVERT(VARCHAR(3), @ModelNo))) + ' = @TrainingDate,
					Ok' + LTRIM(RTRIM(CONVERT(VARCHAR(3), @ModelNo))) + ' = @Ok
				WHERE PersonnelId = @PersonnelId'

			EXEC SP_EXECUTESQL @Sql,
				N'@iReqd SMALLINT, @iAttnd SMALLINT,  @Ok BIT, @TrainingDate SMALLDATETIME, @PersonnelId VARCHAR(50)',
				@iReqd, @iAttnd, @Ok, @TrainingDate, @PersonnelId

			DECLARE @ModelDesc NVARCHAR(255)
			SET @ModelDesc = @ModelShortName +  ' ' + ISNULL(@CategoryShortName, '')
				
			IF @RiskLevelVal IS NOT NULL
				SET @ModelDesc = @ModelDesc + '[RiskLevel=' + CONVERT(CHAR(1), @RiskLevelVal) + ']'

			SET @Sql = N'UPDATE #RetVal
				SET ModelId' + LTRIM(RTRIM(CONVERT(VARCHAR(3), @ModelNo))) + ' = @ModelId,
					ModelName' + LTRIM(RTRIM(CONVERT(VARCHAR(3), @ModelNo))) + ' = @ModelName
				WHERE PersonnelId = @PersonnelId'

			EXEC SP_EXECUTESQL @Sql,
				N'@ModelId VARCHAR(50), @ModelName VARCHAR(255), @PersonnelId VARCHAR(50)',
				@ModelId, @ModelDesc, @PersonnelId

	SkipModel:	
			--
			-- Next model
			SET @ModelNo = @ModelNo + 1

			FETCH NEXT FROM @CsrModel 
			INTO @ModelId, @ModelShortName, @CategoryShortName, @RiskLevel, @RiskLevelVal
		END

		--
		-- Next Person
		IF ISNULL(@PersonReqdCount, 0) = 0 AND ISNULL(@PersonAttndCount, 0) = 0
		BEGIN
			UPDATE #RetVal
			SET RequiredCount = -99, AchievedCount = -99
			WHERE PersonnelId = @PersonnelId
		END
		ELSE
		BEGIN
			UPDATE #RetVal
			SET RequiredCount = ISNULL(@PersonReqdCount, 0), 
				AchievedCount = ISNULL(@PersonAttndCount, 0)
			WHERE PersonnelId = @PersonnelId
		END

SkipPerson:
		SET @PersonnelNo = @PersonnelNo + 1

		FETCH NEXT FROM @CsrPerson 
		INTO @PersonnelId, @PersonnelShortName
	END

	CLOSE @CsrPerson
	DEALLOCATE @CsrPerson

	CLOSE @CsrModel
	DEALLOCATE @CsrModel

	--
	-- Return the data
	SELECT LastName, FirstName,
		StaffGradeShortName AS [Grade],
		OrganisationShortName AS Provider,
		BranchShortName AS [Service],
		SiteShortName AS [Site],
		LocationShortName AS Location,
		RequiredCount, AchievedCount,	
		CASE ISNULL(RequiredCount, 0)
		WHEN -99 THEN -99
		WHEN 0 THEN 1
		ELSE CAST((ISNULL(AchievedCount, 0) / CAST(RequiredCount AS FLOAT)) AS DECIMAL(10,2))
		END AS PCCompliant,
		
		ModelName1,
		CASE WHEN RequiredLevel1 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel1,
		CASE WHEN RequiredLevel1 > 0 THEN
			CASE WHEN AchievedLevel1 >= RequiredLevel1 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel1 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel1,
		CASE 
			WHEN RequiredLevel1 > 0 AND Ok1 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel1 > 0 AND Ok1 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok1,
		TrainingDate1,
		ModelName2,
		CASE WHEN RequiredLevel2 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel2,
		CASE WHEN RequiredLevel2 > 0 THEN
			CASE WHEN AchievedLevel2 >= RequiredLevel2 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel2 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel2,
		CASE 
			WHEN RequiredLevel2 > 0 AND Ok2 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel2 > 0 AND Ok2 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok2,
		TrainingDate2,
		ModelName3,
		CASE WHEN RequiredLevel3 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel3,
		CASE WHEN RequiredLevel3 > 0 THEN
			CASE WHEN AchievedLevel3 >= RequiredLevel3 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel3 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel3,
		CASE 
			WHEN RequiredLevel3 > 0 AND Ok3 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel3 > 0 AND Ok3 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok3,
		TrainingDate3,
		ModelName4,
		CASE WHEN RequiredLevel4 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel4,
		CASE WHEN RequiredLevel4 > 0 THEN
			CASE WHEN AchievedLevel4 >= RequiredLevel4 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel4 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel4,
		CASE 
			WHEN RequiredLevel4 > 0 AND Ok4 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel4 > 0 AND Ok4 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok4,
		TrainingDate4,
		ModelName5,
		CASE WHEN RequiredLevel5 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel5,
		CASE WHEN RequiredLevel5 > 0 THEN
			CASE WHEN AchievedLevel5 >= RequiredLevel5 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel5 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel5,
		CASE 
			WHEN RequiredLevel5 > 0 AND Ok5 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel5 > 0 AND Ok5 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok5,
		TrainingDate5,
		ModelName6,
		CASE WHEN RequiredLevel6 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel6,
		CASE WHEN RequiredLevel6 > 0 THEN
			CASE WHEN AchievedLevel6 >= RequiredLevel6 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel6 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel6,
		CASE 
			WHEN RequiredLevel6 > 0 AND Ok6 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel6 > 0 AND Ok6 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok6,
		TrainingDate6,
		ModelName7,
		CASE WHEN RequiredLevel7 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel7,
		CASE WHEN RequiredLevel7 > 0 THEN
			CASE WHEN AchievedLevel7 >= RequiredLevel7 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel7 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel7,
		CASE 
			WHEN RequiredLevel7 > 0 AND Ok7 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel7 > 0 AND Ok7 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok7,
		TrainingDate7,
		ModelName8,
		CASE WHEN RequiredLevel8 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel8,
		CASE WHEN RequiredLevel8 > 0 THEN
			CASE WHEN AchievedLevel8 >= RequiredLevel8 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel8 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel8,
		CASE 
			WHEN RequiredLevel8 > 0 AND Ok8 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel8 > 0 AND Ok8 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok8,
		TrainingDate8,
		ModelName9,
		CASE WHEN RequiredLevel9 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel9,
		CASE WHEN RequiredLevel9 > 0 THEN
			CASE WHEN AchievedLevel9 >= RequiredLevel9 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel9 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel9,
		CASE 
			WHEN RequiredLevel9 > 0 AND Ok9 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel9 > 0 AND Ok9 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok9,
		TrainingDate9,
		ModelName10,
		CASE WHEN RequiredLevel10 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel10,
		CASE WHEN RequiredLevel10 > 0 THEN
			CASE WHEN AchievedLevel10 >= RequiredLevel10 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel10 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel10,
		CASE 
			WHEN RequiredLevel10 > 0 AND Ok10 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel10 > 0 AND Ok10 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok10,
		TrainingDate10,

		ModelName11,
		CASE WHEN RequiredLevel11 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel11,
		CASE WHEN RequiredLevel11 > 0 THEN
			CASE WHEN AchievedLevel11 >= RequiredLevel11 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel11 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel11,
		CASE 
			WHEN RequiredLevel11 > 0 AND Ok11 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel11 > 0 AND Ok11 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok11,
		TrainingDate11,
		ModelName12,		
		CASE WHEN RequiredLevel12 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel12,
		CASE WHEN RequiredLevel12 > 0 THEN
			CASE WHEN AchievedLevel12 >= RequiredLevel12 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel12 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel12,
		CASE 
			WHEN RequiredLevel12 > 0 AND Ok12 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel12 > 0 AND Ok12 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok12,
		TrainingDate12,
		ModelName13,
		CASE WHEN RequiredLevel13 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel13,
		CASE WHEN RequiredLevel13 > 0 THEN
			CASE WHEN AchievedLevel13 >= RequiredLevel13 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel13 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel13,
		CASE 
			WHEN RequiredLevel13 > 0 AND Ok13 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel13 > 0 AND Ok13 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok13,
		TrainingDate13,
		ModelName14,
		CASE WHEN RequiredLevel14 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel14,
		CASE WHEN RequiredLevel14 > 0 THEN
			CASE WHEN AchievedLevel14 >= RequiredLevel14 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel14 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel14,
		CASE 
			WHEN RequiredLevel14 > 0 AND Ok14 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel14 > 0 AND Ok14 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok14,
		TrainingDate14,
		ModelName15,
		CASE WHEN RequiredLevel15 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel15,
		CASE WHEN RequiredLevel15 > 0 THEN
			CASE WHEN AchievedLevel15 >= RequiredLevel15 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel15 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel15,
		CASE 
			WHEN RequiredLevel15 > 0 AND Ok15 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel15 > 0 AND Ok15 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok15,
		TrainingDate15,
		ModelName16,
		CASE WHEN RequiredLevel16 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel16,
		CASE WHEN RequiredLevel16 > 0 THEN
			CASE WHEN AchievedLevel16 >= RequiredLevel16 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel16 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel16,
		CASE 
			WHEN RequiredLevel16 > 0 AND Ok16 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel16 > 0 AND Ok16 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok16,
		TrainingDate16,
		ModelName17,
		CASE WHEN RequiredLevel17 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel17,
		CASE WHEN RequiredLevel17 > 0 THEN
			CASE WHEN AchievedLevel17 >= RequiredLevel17 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel17 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel17,
		CASE 
			WHEN RequiredLevel17 > 0 AND Ok17 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel17 > 0 AND Ok17 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok17,
		TrainingDate17,
		ModelName18,
		CASE WHEN RequiredLevel18 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel18,
		CASE WHEN RequiredLevel18 > 0 THEN
			CASE WHEN AchievedLevel18 >= RequiredLevel18 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel18 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel18,
		CASE 
			WHEN RequiredLevel18 > 0 AND Ok18 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel18 > 0 AND Ok18 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok18,
		TrainingDate18,
		ModelName19,
		CASE WHEN RequiredLevel19 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel19,
		CASE WHEN RequiredLevel19 > 0 THEN
			CASE WHEN AchievedLevel19 >= RequiredLevel19 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel19 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel19,
		CASE 
			WHEN RequiredLevel19 > 0 AND Ok19 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel19 > 0 AND Ok19 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok19,
		TrainingDate19,
		ModelName20,
		CASE WHEN RequiredLevel20 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel20,
		CASE WHEN RequiredLevel20 > 0 THEN
			CASE WHEN AchievedLevel20 >= RequiredLevel20 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel20 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel20,
		CASE 
			WHEN RequiredLevel20 > 0 AND Ok20 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel20 > 0 AND Ok20 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok20,
		TrainingDate20,

		ModelName21,
		CASE WHEN RequiredLevel21 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel21,
		CASE WHEN RequiredLevel21 > 0 THEN
			CASE WHEN AchievedLevel21 >= RequiredLevel21 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel21 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel21,
		CASE 
			WHEN RequiredLevel21 > 0 AND Ok21 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel21 > 0 AND Ok21 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok21,
		TrainingDate21,
		ModelName22,
		CASE WHEN RequiredLevel22 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel22,
		CASE WHEN RequiredLevel22 > 0 THEN
			CASE WHEN AchievedLevel22 >= RequiredLevel22 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel22 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel22,
		CASE 
			WHEN RequiredLevel22 > 0 AND Ok22 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel22 > 0 AND Ok22 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok22,
		TrainingDate22,
		ModelName23,
		CASE WHEN RequiredLevel23 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel23,
		CASE WHEN RequiredLevel23 > 0 THEN
			CASE WHEN AchievedLevel23 >= RequiredLevel23 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel23 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel23,
		CASE 
			WHEN RequiredLevel23 > 0 AND Ok23 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel23 > 0 AND Ok23 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok23,
		TrainingDate23,
		ModelName24,
		CASE WHEN RequiredLevel24 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel24,
		CASE WHEN RequiredLevel24 > 0 THEN
			CASE WHEN AchievedLevel24 >= RequiredLevel24 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel24 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel24,
		CASE 
			WHEN RequiredLevel24 > 0 AND Ok24 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel24 > 0 AND Ok24 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok24,
		TrainingDate24,
		ModelName25,
		CASE WHEN RequiredLevel25 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel25,
		CASE WHEN RequiredLevel25 > 0 THEN
			CASE WHEN AchievedLevel25 >= RequiredLevel25 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel25 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel25,
		CASE 
			WHEN RequiredLevel25 > 0 AND Ok25 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel25 > 0 AND Ok25 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok25,
		TrainingDate25,
		ModelName26,
		CASE WHEN RequiredLevel26 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel26,
		CASE WHEN RequiredLevel26 > 0 THEN
			CASE WHEN AchievedLevel26 >= RequiredLevel26 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel26 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel26,
		CASE 
			WHEN RequiredLevel26 > 0 AND Ok26 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel26 > 0 AND Ok26 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok26,
		TrainingDate26,
		ModelName27,
		CASE WHEN RequiredLevel27 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel27,
		CASE WHEN RequiredLevel27 > 0 THEN
			CASE WHEN AchievedLevel27 >= RequiredLevel27 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel27 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel27,
		CASE 
			WHEN RequiredLevel27 > 0 AND Ok27 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel27 > 0 AND Ok27 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok27,
		TrainingDate27,
		ModelName28,
		CASE WHEN RequiredLevel28 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel28,
		CASE WHEN RequiredLevel28 > 0 THEN
			CASE WHEN AchievedLevel28 >= RequiredLevel28 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel28 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel28,
		CASE 
			WHEN RequiredLevel28 > 0 AND Ok28 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel28 > 0 AND Ok28 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok28,
		TrainingDate28,
		ModelName29,
		CASE WHEN RequiredLevel29 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel29,
		CASE WHEN RequiredLevel29 > 0 THEN
			CASE WHEN AchievedLevel29 >= RequiredLevel29 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel29 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel29,
		CASE 
			WHEN RequiredLevel29 > 0 AND Ok29 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel29 > 0 AND Ok29 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok29,
		TrainingDate29,
		ModelName30,
		CASE WHEN RequiredLevel30 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel30,
		CASE WHEN RequiredLevel30 > 0 THEN
			CASE WHEN AchievedLevel30 >= RequiredLevel30 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel30 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel30,
		CASE 
			WHEN RequiredLevel30 > 0 AND Ok30 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel30 > 0 AND Ok30 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok30,
		TrainingDate30,

		ModelName31,
		CASE WHEN RequiredLevel31 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel31,
		CASE WHEN RequiredLevel31 > 0 THEN
			CASE WHEN AchievedLevel31 >= RequiredLevel31 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel31 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel31,
		CASE 
			WHEN RequiredLevel31 > 0 AND Ok31 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel31 > 0 AND Ok31 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok31,
		TrainingDate31,
		ModelName32,
		CASE WHEN RequiredLevel32 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel32,
		CASE WHEN RequiredLevel32 > 0 THEN
			CASE WHEN AchievedLevel32 >= RequiredLevel32 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel32 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel32,
		CASE 
			WHEN RequiredLevel32 > 0 AND Ok32 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel32 > 0 AND Ok32 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok32,
		TrainingDate32,
		ModelName33,
		CASE WHEN RequiredLevel33 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel33,
		CASE WHEN RequiredLevel33 > 0 THEN
			CASE WHEN AchievedLevel33 >= RequiredLevel33 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel33 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel33,
		CASE 
			WHEN RequiredLevel33 > 0 AND Ok33 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel33 > 0 AND Ok33 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok33,
		TrainingDate33,
		ModelName34,
		CASE WHEN RequiredLevel34 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel34,
		CASE WHEN RequiredLevel34 > 0 THEN
			CASE WHEN AchievedLevel34 >= RequiredLevel34 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel34 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel34,
		CASE 
			WHEN RequiredLevel34 > 0 AND Ok34 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel34 > 0 AND Ok34 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok34,
		TrainingDate34,
		ModelName35,
		CASE WHEN RequiredLevel35 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel35,
		CASE WHEN RequiredLevel35 > 0 THEN
			CASE WHEN AchievedLevel35 >= RequiredLevel35 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel35 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel35,
		CASE 
			WHEN RequiredLevel35 > 0 AND Ok35 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel35 > 0 AND Ok35 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok35,
		TrainingDate35,
		ModelName36,
		CASE WHEN RequiredLevel36 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel36,
		CASE WHEN RequiredLevel36 > 0 THEN
			CASE WHEN AchievedLevel36 >= RequiredLevel36 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel36 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel36,
		CASE 
			WHEN RequiredLevel36 > 0 AND Ok36 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel36 > 0 AND Ok36 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok36,
		TrainingDate36,
		ModelName37,
		CASE WHEN RequiredLevel37 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel37,
		CASE WHEN RequiredLevel37 > 0 THEN
			CASE WHEN AchievedLevel37 >= RequiredLevel37 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel37 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel37,
		CASE 
			WHEN RequiredLevel37 > 0 AND Ok37 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel37 > 0 AND Ok37 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok37,
		TrainingDate37,
		ModelName38,
		CASE WHEN RequiredLevel38 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel38,
		CASE WHEN RequiredLevel38 > 0 THEN
			CASE WHEN AchievedLevel38 >= RequiredLevel38 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel38 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel38,
		CASE 
			WHEN RequiredLevel38 > 0 AND Ok38 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel38 > 0 AND Ok38 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok38,
		TrainingDate38,
		ModelName39,
		CASE WHEN RequiredLevel39 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel39,
		CASE WHEN RequiredLevel39 > 0 THEN
			CASE WHEN AchievedLevel39 >= RequiredLevel39 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel39 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel39,
		CASE 
			WHEN RequiredLevel39 > 0 AND Ok39 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel39 > 0 AND Ok39 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok39,
		TrainingDate39,
		ModelName40,		
		CASE WHEN RequiredLevel40 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel40,
		CASE WHEN RequiredLevel40 > 0 THEN
			CASE WHEN AchievedLevel40 >= RequiredLevel40 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel40 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel40,
		CASE 
			WHEN RequiredLevel40 > 0 AND Ok40 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel40 > 0 AND Ok40 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok40,
		TrainingDate40,

		ModelName41,
		CASE WHEN RequiredLevel41 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel41,
		CASE WHEN RequiredLevel41 > 0 THEN
			CASE WHEN AchievedLevel41 >= RequiredLevel41 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel41 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel41,
		CASE 
			WHEN RequiredLevel41 > 0 AND Ok41 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel41 > 0 AND Ok41 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok41,
		TrainingDate41,
		ModelName42,
		CASE WHEN RequiredLevel42 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel42,
		CASE WHEN RequiredLevel42 > 0 THEN
			CASE WHEN AchievedLevel42 >= RequiredLevel42 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel42 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel42,
		CASE 
			WHEN RequiredLevel42 > 0 AND Ok42 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel42 > 0 AND Ok42 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok42,
		TrainingDate42,
		ModelName43,
		CASE WHEN RequiredLevel43 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel43,
		CASE WHEN RequiredLevel43 > 0 THEN
			CASE WHEN AchievedLevel43 >= RequiredLevel43 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel43 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel43,
		CASE 
			WHEN RequiredLevel43 > 0 AND Ok43 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel43 > 0 AND Ok43 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok43,
		TrainingDate43,
		ModelName44,
		CASE WHEN RequiredLevel44 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel44,
		CASE WHEN RequiredLevel44 > 0 THEN
			CASE WHEN AchievedLevel44 >= RequiredLevel44 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel44 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel44,
		CASE 
			WHEN RequiredLevel44 > 0 AND Ok44 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel44 > 0 AND Ok44 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok44,
		TrainingDate44,
		ModelName45,
		CASE WHEN RequiredLevel45 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel45,
		CASE WHEN RequiredLevel45 > 0 THEN
			CASE WHEN AchievedLevel45 >= RequiredLevel45 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel45 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel45,
		CASE 
			WHEN RequiredLevel45 > 0 AND Ok45 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel45 > 0 AND Ok45 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok45,
		TrainingDate45,
		ModelName46,
		CASE WHEN RequiredLevel46 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel46,
		CASE WHEN RequiredLevel46 > 0 THEN
			CASE WHEN AchievedLevel46 >= RequiredLevel46 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel46 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel46,
		CASE 
			WHEN RequiredLevel46 > 0 AND Ok46 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel46 > 0 AND Ok46 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok46,
		TrainingDate46,
		ModelName47,
		CASE WHEN RequiredLevel47 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel47,
		CASE WHEN RequiredLevel47 > 0 THEN
			CASE WHEN AchievedLevel47 >= RequiredLevel47 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel47 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel47,
		CASE 
			WHEN RequiredLevel47 > 0 AND Ok47 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel47 > 0 AND Ok47 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok47,
		TrainingDate47,
		ModelName48,
		CASE WHEN RequiredLevel48 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel48,
		CASE WHEN RequiredLevel48 > 0 THEN
			CASE WHEN AchievedLevel48 >= RequiredLevel48 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel48 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel48,
		CASE 
			WHEN RequiredLevel48 > 0 AND Ok48 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel48 > 0 AND Ok48 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok48,
		TrainingDate48,
		ModelName49,
		CASE WHEN RequiredLevel49 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel49,
		CASE WHEN RequiredLevel49 > 0 THEN
			CASE WHEN AchievedLevel49 >= RequiredLevel49 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel49 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel49,
		CASE 
			WHEN RequiredLevel49 > 0 AND Ok49 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel49 > 0 AND Ok49 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok49,
		TrainingDate49,
		ModelName50,		
		CASE WHEN RequiredLevel50 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel50,
		CASE WHEN RequiredLevel50 > 0 THEN
			CASE WHEN AchievedLevel50 >= RequiredLevel50 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel50 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel50,
		CASE 
			WHEN RequiredLevel50 > 0 AND Ok50 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel50 > 0 AND Ok50 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok50,
		TrainingDate50,

		ModelName51,
		CASE WHEN RequiredLevel51 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel51,
		CASE WHEN RequiredLevel51 > 0 THEN
			CASE WHEN AchievedLevel51 >= RequiredLevel51 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel51 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel51,
		CASE 
			WHEN RequiredLevel51 > 0 AND Ok51 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel51 > 0 AND Ok51 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok51,
		TrainingDate51,
		ModelName52,
		CASE WHEN RequiredLevel52 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel52,
		CASE WHEN RequiredLevel52 > 0 THEN
			CASE WHEN AchievedLevel52 >= RequiredLevel52 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel52 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel52,
		CASE 
			WHEN RequiredLevel52 > 0 AND Ok52 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel52 > 0 AND Ok52 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok52,
		TrainingDate52,
		ModelName53,
		CASE WHEN RequiredLevel53 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel53,
		CASE WHEN RequiredLevel53 > 0 THEN
			CASE WHEN AchievedLevel53 >= RequiredLevel53 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel53 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel53,
		CASE 
			WHEN RequiredLevel53 > 0 AND Ok53 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel53 > 0 AND Ok53 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok53,
		TrainingDate53,
		ModelName54,
		CASE WHEN RequiredLevel54 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel54,
		CASE WHEN RequiredLevel54 > 0 THEN
			CASE WHEN AchievedLevel54 >= RequiredLevel54 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel54 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel54,
		CASE 
			WHEN RequiredLevel54 > 0 AND Ok54 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel54 > 0 AND Ok54 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok54,
		TrainingDate54,
		ModelName55,
		CASE WHEN RequiredLevel55 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel55,
		CASE WHEN RequiredLevel55 > 0 THEN
			CASE WHEN AchievedLevel55 >= RequiredLevel55 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel55 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel55,
		CASE 
			WHEN RequiredLevel55 > 0 AND Ok55 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel55 > 0 AND Ok55 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok55,
		TrainingDate55,
		ModelName56,
		CASE WHEN RequiredLevel56 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel56,
		CASE WHEN RequiredLevel56 > 0 THEN
			CASE WHEN AchievedLevel56 >= RequiredLevel56 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel56 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel56,
		CASE 
			WHEN RequiredLevel56 > 0 AND Ok56 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel56 > 0 AND Ok56 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok56,
		TrainingDate56,
		ModelName57,
		CASE WHEN RequiredLevel57 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel57,
		CASE WHEN RequiredLevel57 > 0 THEN
			CASE WHEN AchievedLevel57 >= RequiredLevel57 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel57 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel57,
		CASE 
			WHEN RequiredLevel57 > 0 AND Ok57 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel57 > 0 AND Ok57 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok57,
		TrainingDate57,
		ModelName58,
		CASE WHEN RequiredLevel58 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel58,
		CASE WHEN RequiredLevel58 > 0 THEN
			CASE WHEN AchievedLevel58 >= RequiredLevel58 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel58 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel58,
		CASE 
			WHEN RequiredLevel58 > 0 AND Ok58 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel58 > 0 AND Ok58 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok58,
		TrainingDate58,
		ModelName59,
		CASE WHEN RequiredLevel59 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel59,
		CASE WHEN RequiredLevel59 > 0 THEN
			CASE WHEN AchievedLevel59 >= RequiredLevel59 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel59 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel59,
		CASE 
			WHEN RequiredLevel59 > 0 AND Ok59 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel59 > 0 AND Ok59 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok59,
		TrainingDate59,
		ModelName60,
		CASE WHEN RequiredLevel60 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel60,
		CASE WHEN RequiredLevel60 > 0 THEN
			CASE WHEN AchievedLevel60 >= RequiredLevel60 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel60 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel60,
		CASE 
			WHEN RequiredLevel60 > 0 AND Ok60 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel60 > 0 AND Ok60 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok60,
		TrainingDate60,
		
		ModelName61,
		CASE WHEN RequiredLevel61 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel61,
		CASE WHEN RequiredLevel61 > 0 THEN
			CASE WHEN AchievedLevel61 >= RequiredLevel61 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel61 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel61,
		CASE 
			WHEN RequiredLevel61 > 0 AND Ok61 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel61 > 0 AND Ok61 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok61,
		TrainingDate61,
		ModelName62,
		CASE WHEN RequiredLevel62 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel62,
		CASE WHEN RequiredLevel62 > 0 THEN
			CASE WHEN AchievedLevel62 >= RequiredLevel62 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel62 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel62,
		CASE 
			WHEN RequiredLevel62 > 0 AND Ok62 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel62 > 0 AND Ok62 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok62,
		TrainingDate62,
		ModelName63,
		CASE WHEN RequiredLevel63 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel63,
		CASE WHEN RequiredLevel63 > 0 THEN
			CASE WHEN AchievedLevel63 >= RequiredLevel63 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel63 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel63,
		CASE 
			WHEN RequiredLevel63 > 0 AND Ok63 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel63 > 0 AND Ok63 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok63,
		TrainingDate63,
		ModelName64,
		CASE WHEN RequiredLevel64 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel64,
		CASE WHEN RequiredLevel64 > 0 THEN
			CASE WHEN AchievedLevel64 >= RequiredLevel64 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel64 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel64,
		CASE 
			WHEN RequiredLevel64 > 0 AND Ok64 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel64 > 0 AND Ok64 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok64,
		TrainingDate64,
		ModelName65,
		CASE WHEN RequiredLevel65 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel65,
		CASE WHEN RequiredLevel65 > 0 THEN
			CASE WHEN AchievedLevel65 >= RequiredLevel65 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel65 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel65,
		CASE 
			WHEN RequiredLevel65 > 0 AND Ok65 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel65 > 0 AND Ok65 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok65,
		TrainingDate65,
		ModelName66,
		CASE WHEN RequiredLevel66 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel66,
		CASE WHEN RequiredLevel66 > 0 THEN
			CASE WHEN AchievedLevel66 >= RequiredLevel66 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel66 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel66,
		CASE 
			WHEN RequiredLevel66 > 0 AND Ok66 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel66 > 0 AND Ok66 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok66,
		TrainingDate66,
		ModelName67,
		CASE WHEN RequiredLevel67 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel67,
		CASE WHEN RequiredLevel67 > 0 THEN
			CASE WHEN AchievedLevel67 >= RequiredLevel67 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel67 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel67,
		CASE 
			WHEN RequiredLevel67 > 0 AND Ok67 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel67 > 0 AND Ok67 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok67,
		TrainingDate67,
		ModelName68,
		CASE WHEN RequiredLevel68 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel68,
		CASE WHEN RequiredLevel68 > 0 THEN
			CASE WHEN AchievedLevel68 >= RequiredLevel68 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel68 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel68,
		CASE 
			WHEN RequiredLevel68 > 0 AND Ok68 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel68 > 0 AND Ok68 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok68,
		TrainingDate68,
		ModelName69,
		CASE WHEN RequiredLevel69 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel69,
		CASE WHEN RequiredLevel69 > 0 THEN
			CASE WHEN AchievedLevel69 >= RequiredLevel69 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel69 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel69,
		CASE 
			WHEN RequiredLevel69 > 0 AND Ok69 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel69 > 0 AND Ok69 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok69,
		TrainingDate69,
		ModelName70,
		CASE WHEN RequiredLevel70 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel70,
		CASE WHEN RequiredLevel70 > 0 THEN
			CASE WHEN AchievedLevel70 >= RequiredLevel70 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel70 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel70,
		CASE 
			WHEN RequiredLevel70 > 0 AND Ok70 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel70 > 0 AND Ok70 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok70,
		TrainingDate70,
		
		ModelName71,
		CASE WHEN RequiredLevel71 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel71,
		CASE WHEN RequiredLevel71 > 0 THEN
			CASE WHEN AchievedLevel71 >= RequiredLevel71 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel71 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel71,
		CASE 
			WHEN RequiredLevel71 > 0 AND Ok71 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel71 > 0 AND Ok71 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok71,
		TrainingDate71,
		ModelName72,
		CASE WHEN RequiredLevel72 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel72,
		CASE WHEN RequiredLevel72 > 0 THEN
			CASE WHEN AchievedLevel72 >= RequiredLevel72 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel72 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel72,
		CASE 
			WHEN RequiredLevel72 > 0 AND Ok72 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel72 > 0 AND Ok72 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok72,
		TrainingDate72,
		ModelName73,
		CASE WHEN RequiredLevel73 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel73,
		CASE WHEN RequiredLevel73 > 0 THEN
			CASE WHEN AchievedLevel73 >= RequiredLevel73 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel73 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel73,
		CASE 
			WHEN RequiredLevel73 > 0 AND Ok73 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel73 > 0 AND Ok73 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok73,
		TrainingDate73,
		ModelName74,
		CASE WHEN RequiredLevel74 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel74,
		CASE WHEN RequiredLevel74 > 0 THEN
			CASE WHEN AchievedLevel74 >= RequiredLevel74 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel74 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel74,
		CASE 
			WHEN RequiredLevel74 > 0 AND Ok74 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel74 > 0 AND Ok74 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok74,
		TrainingDate74,
		ModelName75,
		CASE WHEN RequiredLevel75 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel75,
		CASE WHEN RequiredLevel75 > 0 THEN
			CASE WHEN AchievedLevel75 >= RequiredLevel75 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel75 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel75,
		CASE 
			WHEN RequiredLevel75 > 0 AND Ok75 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel75 > 0 AND Ok75 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok75,
		TrainingDate75,
		ModelName76,
		CASE WHEN RequiredLevel76 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel76,
		CASE WHEN RequiredLevel76 > 0 THEN
			CASE WHEN AchievedLevel76 >= RequiredLevel76 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel76 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel76,
		CASE 
			WHEN RequiredLevel76 > 0 AND Ok76 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel76 > 0 AND Ok76 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok76,
		TrainingDate76,
		ModelName77,
		CASE WHEN RequiredLevel77 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel77,
		CASE WHEN RequiredLevel77 > 0 THEN
			CASE WHEN AchievedLevel77 >= RequiredLevel77 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel77 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel77,
		CASE 
			WHEN RequiredLevel77 > 0 AND Ok77 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel77 > 0 AND Ok77 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok77,
		TrainingDate77,
		ModelName78,
		CASE WHEN RequiredLevel78 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel78,
		CASE WHEN RequiredLevel78 > 0 THEN
			CASE WHEN AchievedLevel78 >= RequiredLevel78 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel78 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel78,
		CASE 
			WHEN RequiredLevel78 > 0 AND Ok78 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel78 > 0 AND Ok78 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok78,
		TrainingDate78,
		ModelName79,
		CASE WHEN RequiredLevel79 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel79,
		CASE WHEN RequiredLevel79 > 0 THEN
			CASE WHEN AchievedLevel79 >= RequiredLevel79 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel79 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel79,
		CASE 
			WHEN RequiredLevel79 > 0 AND Ok79 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel79 > 0 AND Ok79 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok79,
		TrainingDate79,		
		ModelName80,
		CASE WHEN RequiredLevel80 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel80,
		CASE WHEN RequiredLevel80 > 0 THEN
			CASE WHEN AchievedLevel80 >= RequiredLevel80 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel80 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel80,
		CASE 
			WHEN RequiredLevel80 > 0 AND Ok80 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel80 > 0 AND Ok80 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok80,
		TrainingDate80,
		
		ModelName81,
		CASE WHEN RequiredLevel81 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel81,
		CASE WHEN RequiredLevel81 > 0 THEN
			CASE WHEN AchievedLevel81 >= RequiredLevel81 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel81 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel81,
		CASE 
			WHEN RequiredLevel81 > 0 AND Ok81 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel81 > 0 AND Ok81 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok81,
		TrainingDate81,
		ModelName82,
		CASE WHEN RequiredLevel82 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel82,
		CASE WHEN RequiredLevel82 > 0 THEN
			CASE WHEN AchievedLevel82 >= RequiredLevel82 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel82 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel82,
		CASE 
			WHEN RequiredLevel82 > 0 AND Ok82 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel82 > 0 AND Ok82 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok82,
		TrainingDate82,
		ModelName83,
		CASE WHEN RequiredLevel83 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel83,
		CASE WHEN RequiredLevel83 > 0 THEN
			CASE WHEN AchievedLevel83 >= RequiredLevel83 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel83 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel83,
		CASE 
			WHEN RequiredLevel83 > 0 AND Ok83 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel83 > 0 AND Ok83 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok83,
		TrainingDate83,
		ModelName84,
		CASE WHEN RequiredLevel84 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel84,
		CASE WHEN RequiredLevel84 > 0 THEN
			CASE WHEN AchievedLevel84 >= RequiredLevel84 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel84 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel84,
		CASE 
			WHEN RequiredLevel84 > 0 AND Ok84 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel84 > 0 AND Ok84 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok84,
		TrainingDate84,
		ModelName85,
		CASE WHEN RequiredLevel85 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel85,
		CASE WHEN RequiredLevel85 > 0 THEN
			CASE WHEN AchievedLevel85 >= RequiredLevel85 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel85 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel85,
		CASE 
			WHEN RequiredLevel85 > 0 AND Ok85 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel85 > 0 AND Ok85 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok85,
		TrainingDate85,
		ModelName86,
		CASE WHEN RequiredLevel86 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel86,
		CASE WHEN RequiredLevel86 > 0 THEN
			CASE WHEN AchievedLevel86 >= RequiredLevel86 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel86 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel86,
		CASE 
			WHEN RequiredLevel86 > 0 AND Ok86 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel86 > 0 AND Ok86 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok86,
		TrainingDate86,
		ModelName87,
		CASE WHEN RequiredLevel87 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel87,
		CASE WHEN RequiredLevel87 > 0 THEN
			CASE WHEN AchievedLevel87 >= RequiredLevel87 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel87 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel87,
		CASE 
			WHEN RequiredLevel87 > 0 AND Ok87 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel87 > 0 AND Ok87 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok87,
		TrainingDate87,
		ModelName88,
		CASE WHEN RequiredLevel88 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel88,
		CASE WHEN RequiredLevel88 > 0 THEN
			CASE WHEN AchievedLevel88 >= RequiredLevel88 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel88 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel88,
		CASE 
			WHEN RequiredLevel88 > 0 AND Ok88 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel88 > 0 AND Ok88 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok88,
		TrainingDate88,
		ModelName89,
		CASE WHEN RequiredLevel89 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel89,
		CASE WHEN RequiredLevel89 > 0 THEN
			CASE WHEN AchievedLevel89 >= RequiredLevel89 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel89 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel89,
		CASE 
			WHEN RequiredLevel89 > 0 AND Ok89 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel89 > 0 AND Ok89 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok89,
		TrainingDate89,
		ModelName90,
		CASE WHEN RequiredLevel90 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel90,
		CASE WHEN RequiredLevel90 > 0 THEN
			CASE WHEN AchievedLevel90 >= RequiredLevel90 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel90 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel90,
		CASE 
			WHEN RequiredLevel90 > 0 AND Ok90 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel90 > 0 AND Ok90 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok90,
		TrainingDate90,
		
		ModelName91,
		CASE WHEN RequiredLevel91 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel91,
		CASE WHEN RequiredLevel91 > 0 THEN
			CASE WHEN AchievedLevel91 >= RequiredLevel91 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel91 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel91,
		CASE 
			WHEN RequiredLevel91 > 0 AND Ok91 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel91 > 0 AND Ok91 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok91,
		TrainingDate91,
		ModelName92,
		CASE WHEN RequiredLevel92 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel92,
		CASE WHEN RequiredLevel92 > 0 THEN
			CASE WHEN AchievedLevel92 >= RequiredLevel92 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel92 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel92,
		CASE 
			WHEN RequiredLevel92 > 0 AND Ok92 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel92 > 0 AND Ok92 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok92,
		TrainingDate92,
		ModelName93,
		CASE WHEN RequiredLevel93 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel93,
		CASE WHEN RequiredLevel93 > 0 THEN
			CASE WHEN AchievedLevel93 >= RequiredLevel93 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel93 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel93,
		CASE 
			WHEN RequiredLevel93 > 0 AND Ok93 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel93 > 0 AND Ok93 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok93,
		TrainingDate93,
		ModelName94,
		CASE WHEN RequiredLevel94 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel94,
		CASE WHEN RequiredLevel94 > 0 THEN
			CASE WHEN AchievedLevel94 >= RequiredLevel94 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel94 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel94,
		CASE 
			WHEN RequiredLevel94 > 0 AND Ok94 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel94 > 0 AND Ok94 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok94,
		TrainingDate94,
		ModelName95,
		CASE WHEN RequiredLevel95 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel95,
		CASE WHEN RequiredLevel95 > 0 THEN
			CASE WHEN AchievedLevel95 >= RequiredLevel95 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel95 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel95,
		CASE 
			WHEN RequiredLevel95 > 0 AND Ok95 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel95 > 0 AND Ok95 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok95,
		TrainingDate95,
		ModelName96,
		CASE WHEN RequiredLevel96 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel96,
		CASE WHEN RequiredLevel96 > 0 THEN
			CASE WHEN AchievedLevel96 >= RequiredLevel96 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel96 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel96,
		CASE 
			WHEN RequiredLevel96 > 0 AND Ok96 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel96 > 0 AND Ok96 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok96,
		TrainingDate96,
		ModelName97,
		CASE WHEN RequiredLevel97 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel97,
		CASE WHEN RequiredLevel97 > 0 THEN
			CASE WHEN AchievedLevel97 >= RequiredLevel97 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel97 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel97,
		CASE 
			WHEN RequiredLevel97 > 0 AND Ok97 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel97 > 0 AND Ok97 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok97,
		TrainingDate97,
		ModelName98,
		CASE WHEN RequiredLevel98 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel98,
		CASE WHEN RequiredLevel98 > 0 THEN
			CASE WHEN AchievedLevel98 >= RequiredLevel98 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel98 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel98,
		CASE 
			WHEN RequiredLevel98 > 0 AND Ok98 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel98 > 0 AND Ok98 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok98,
		TrainingDate98,
		ModelName99,
		CASE WHEN RequiredLevel99 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel99,
		CASE WHEN RequiredLevel99 > 0 THEN
			CASE WHEN AchievedLevel99 >= RequiredLevel99 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel99 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel99,
		CASE 
			WHEN RequiredLevel99 > 0 AND Ok99 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel99 > 0 AND Ok99 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok99,
		TrainingDate99,
		ModelName100,
		CASE WHEN RequiredLevel100 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel100,
		CASE WHEN RequiredLevel100 > 0 THEN
			CASE WHEN AchievedLevel100 >= RequiredLevel100 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel100 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel100,
		CASE 
			WHEN RequiredLevel100 > 0 AND Ok100 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel100 > 0 AND Ok100 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok100,
		TrainingDate100,
		
		ModelName101,
		CASE WHEN RequiredLevel101 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel101,
		CASE WHEN RequiredLevel101 > 0 THEN
			CASE WHEN AchievedLevel101 >= RequiredLevel101 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel101 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel101,
		CASE 
			WHEN RequiredLevel101 > 0 AND Ok101 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel101 > 0 AND Ok101 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok101,
		TrainingDate101,
		ModelName102,
		CASE WHEN RequiredLevel102 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel102,
		CASE WHEN RequiredLevel102 > 0 THEN
			CASE WHEN AchievedLevel102 >= RequiredLevel102 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel102 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel102,
		CASE 
			WHEN RequiredLevel102 > 0 AND Ok102 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel102 > 0 AND Ok102 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok102,
		TrainingDate102,
		ModelName103,
		CASE WHEN RequiredLevel103 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel103,
		CASE WHEN RequiredLevel103 > 0 THEN
			CASE WHEN AchievedLevel103 >= RequiredLevel103 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel103 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel103,
		CASE 
			WHEN RequiredLevel103 > 0 AND Ok103 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel103 > 0 AND Ok103 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok103,
		TrainingDate103,
		ModelName104,
		CASE WHEN RequiredLevel104 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel104,
		CASE WHEN RequiredLevel104 > 0 THEN
			CASE WHEN AchievedLevel104 >= RequiredLevel104 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel104 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel104,
		CASE 
			WHEN RequiredLevel104 > 0 AND Ok104 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel104 > 0 AND Ok104 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok104,
		TrainingDate104,
		ModelName105,
		CASE WHEN RequiredLevel105 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel105,
		CASE WHEN RequiredLevel105 > 0 THEN
			CASE WHEN AchievedLevel105 >= RequiredLevel105 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel105 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel105,
		CASE 
			WHEN RequiredLevel105 > 0 AND Ok105 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel105 > 0 AND Ok105 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok105,
		TrainingDate105,
		ModelName106,
		CASE WHEN RequiredLevel106 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel106,
		CASE WHEN RequiredLevel106 > 0 THEN
			CASE WHEN AchievedLevel106 >= RequiredLevel106 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel106 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel106,
		CASE 
			WHEN RequiredLevel106 > 0 AND Ok106 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel106 > 0 AND Ok106 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok106,
		TrainingDate106,
		ModelName107,
		CASE WHEN RequiredLevel107 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel107,
		CASE WHEN RequiredLevel107 > 0 THEN
			CASE WHEN AchievedLevel107 >= RequiredLevel107 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel107 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel107,
		CASE 
			WHEN RequiredLevel107 > 0 AND Ok107 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel107 > 0 AND Ok107 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok107,
		TrainingDate107,
		ModelName108,
		CASE WHEN RequiredLevel108 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel108,
		CASE WHEN RequiredLevel108 > 0 THEN
			CASE WHEN AchievedLevel108 >= RequiredLevel108 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel108 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel108,
		CASE 
			WHEN RequiredLevel108 > 0 AND Ok108 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel108 > 0 AND Ok108 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok108,
		TrainingDate108,
		ModelName109,
		CASE WHEN RequiredLevel109 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel109,
		CASE WHEN RequiredLevel109 > 0 THEN
			CASE WHEN AchievedLevel109 >= RequiredLevel109 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel109 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel109,
		CASE 
			WHEN RequiredLevel109 > 0 AND Ok109 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel109 > 0 AND Ok109 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok109,
		TrainingDate109,
		ModelName110,
		CASE WHEN RequiredLevel110 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel110,
		CASE WHEN RequiredLevel110 > 0 THEN
			CASE WHEN AchievedLevel110 >= RequiredLevel110 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel110 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel110,
		CASE 
			WHEN RequiredLevel110 > 0 AND Ok110 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel110 > 0 AND Ok110 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok110,
		TrainingDate110,
		
		ModelName111,
		CASE WHEN RequiredLevel111 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel111,
		CASE WHEN RequiredLevel111 > 0 THEN
			CASE WHEN AchievedLevel111 >= RequiredLevel111 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel111 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel111,
		CASE 
			WHEN RequiredLevel111 > 0 AND Ok111 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel111 > 0 AND Ok111 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok111,
		TrainingDate111,
		ModelName112,
		CASE WHEN RequiredLevel112 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel112,
		CASE WHEN RequiredLevel112 > 0 THEN
			CASE WHEN AchievedLevel112 >= RequiredLevel112 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel112 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel112,
		CASE 
			WHEN RequiredLevel112 > 0 AND Ok112 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel112 > 0 AND Ok112 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok112,
		TrainingDate112,
		ModelName113,
		CASE WHEN RequiredLevel113 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel113,
		CASE WHEN RequiredLevel113 > 0 THEN
			CASE WHEN AchievedLevel113 >= RequiredLevel113 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel113 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel113,
		CASE 
			WHEN RequiredLevel113 > 0 AND Ok113 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel113 > 0 AND Ok113 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok113,
		TrainingDate113,
		ModelName114,
		CASE WHEN RequiredLevel114 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel114,
		CASE WHEN RequiredLevel114 > 0 THEN
			CASE WHEN AchievedLevel114 >= RequiredLevel114 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel114 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel114,
		CASE 
			WHEN RequiredLevel114 > 0 AND Ok114 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel114 > 0 AND Ok114 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok114,
		TrainingDate114,
		ModelName115,
		CASE WHEN RequiredLevel115 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel115,
		CASE WHEN RequiredLevel115 > 0 THEN
			CASE WHEN AchievedLevel115 >= RequiredLevel115 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel115 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel115,
		CASE 
			WHEN RequiredLevel115 > 0 AND Ok115 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel115 > 0 AND Ok115 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok115,
		TrainingDate115,
		ModelName116,
		CASE WHEN RequiredLevel116 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel116,
		CASE WHEN RequiredLevel116 > 0 THEN
			CASE WHEN AchievedLevel116 >= RequiredLevel116 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel116 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel116,
		CASE 
			WHEN RequiredLevel116 > 0 AND Ok116 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel116 > 0 AND Ok116 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok116,
		TrainingDate116,
		ModelName117,
		CASE WHEN RequiredLevel117 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel117,
		CASE WHEN RequiredLevel117 > 0 THEN
			CASE WHEN AchievedLevel117 >= RequiredLevel117 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel117 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel117,
		CASE 
			WHEN RequiredLevel117 > 0 AND Ok117 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel117 > 0 AND Ok117 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok117,
		TrainingDate117,
		ModelName118,
		CASE WHEN RequiredLevel118 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel118,
		CASE WHEN RequiredLevel118 > 0 THEN
			CASE WHEN AchievedLevel118 >= RequiredLevel118 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel118 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel118,
		CASE 
			WHEN RequiredLevel118 > 0 AND Ok118 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel118 > 0 AND Ok118 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok118,
		TrainingDate118,
		ModelName119,
		CASE WHEN RequiredLevel119 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel119,
		CASE WHEN RequiredLevel119 > 0 THEN
			CASE WHEN AchievedLevel119 >= RequiredLevel119 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel119 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel119,
		CASE 
			WHEN RequiredLevel119 > 0 AND Ok119 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel119 > 0 AND Ok119 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok119,
		TrainingDate119,
		ModelName120,
		CASE WHEN RequiredLevel120 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel120,
		CASE WHEN RequiredLevel120 > 0 THEN
			CASE WHEN AchievedLevel120 >= RequiredLevel120 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel120 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel120,
		CASE 
			WHEN RequiredLevel120 > 0 AND Ok120 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel120 > 0 AND Ok120 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok120,
		TrainingDate120,
		
		ModelName121,
		CASE WHEN RequiredLevel121 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel121,
		CASE WHEN RequiredLevel121 > 0 THEN
			CASE WHEN AchievedLevel121 >= RequiredLevel121 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel121 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel121,
		CASE 
			WHEN RequiredLevel121 > 0 AND Ok121 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel121 > 0 AND Ok121 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok121,
		TrainingDate121,
		ModelName122,
		CASE WHEN RequiredLevel122 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel122,
		CASE WHEN RequiredLevel122 > 0 THEN
			CASE WHEN AchievedLevel122 >= RequiredLevel122 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel122 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel122,
		CASE 
			WHEN RequiredLevel122 > 0 AND Ok122 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel122 > 0 AND Ok122 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok122,
		TrainingDate122,
		ModelName123,
		CASE WHEN RequiredLevel123 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel123,
		CASE WHEN RequiredLevel123 > 0 THEN
			CASE WHEN AchievedLevel123 >= RequiredLevel123 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel123 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel123,
		CASE 
			WHEN RequiredLevel123 > 0 AND Ok123 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel123 > 0 AND Ok123 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok123,
		TrainingDate123,
		ModelName124,
		CASE WHEN RequiredLevel124 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel124,
		CASE WHEN RequiredLevel124 > 0 THEN
			CASE WHEN AchievedLevel124 >= RequiredLevel124 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel124 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel124,
		CASE 
			WHEN RequiredLevel124 > 0 AND Ok124 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel124 > 0 AND Ok124 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok124,
		TrainingDate124,
		ModelName125,
		CASE WHEN RequiredLevel125 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel125,
		CASE WHEN RequiredLevel125 > 0 THEN
			CASE WHEN AchievedLevel125 >= RequiredLevel125 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel125 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel125,
		CASE 
			WHEN RequiredLevel125 > 0 AND Ok125 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel125 > 0 AND Ok125 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok125,
		TrainingDate125,
		ModelName126,
		CASE WHEN RequiredLevel126 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel126,
		CASE WHEN RequiredLevel126 > 0 THEN
			CASE WHEN AchievedLevel126 >= RequiredLevel126 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel126 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel126,
		CASE 
			WHEN RequiredLevel126 > 0 AND Ok126 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel126 > 0 AND Ok126 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok126,
		TrainingDate126,
		ModelName127,
		CASE WHEN RequiredLevel127 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel127,
		CASE WHEN RequiredLevel127 > 0 THEN
			CASE WHEN AchievedLevel127 >= RequiredLevel127 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel127 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel127,
		CASE 
			WHEN RequiredLevel127 > 0 AND Ok127 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel127 > 0 AND Ok127 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok127,
		TrainingDate127,
		ModelName128,
		CASE WHEN RequiredLevel128 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel128,
		CASE WHEN RequiredLevel128 > 0 THEN
			CASE WHEN AchievedLevel128 >= RequiredLevel128 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel128 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel128,
		CASE 
			WHEN RequiredLevel128 > 0 AND Ok128 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel128 > 0 AND Ok128 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok128,
		ModelName129,
		CASE WHEN RequiredLevel129 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel129,
		CASE WHEN RequiredLevel129 > 0 THEN
			CASE WHEN AchievedLevel129 >= RequiredLevel129 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel129 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel129,
		CASE 
			WHEN RequiredLevel129 > 0 AND Ok129 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel129 > 0 AND Ok129 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok129,
		TrainingDate129,
		ModelName130,
		CASE WHEN RequiredLevel130 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel130,
		CASE WHEN RequiredLevel130 > 0 THEN
			CASE WHEN AchievedLevel130 >= RequiredLevel130 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel130 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel130,
		CASE 
			WHEN RequiredLevel130 > 0 AND Ok130 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel130 > 0 AND Ok130 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok130,
		TrainingDate130,
		
		ModelName131,
		CASE WHEN RequiredLevel131 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel131,
		CASE WHEN RequiredLevel131 > 0 THEN
			CASE WHEN AchievedLevel131 >= RequiredLevel131 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel131 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel131,
		CASE 
			WHEN RequiredLevel131 > 0 AND Ok131 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel131 > 0 AND Ok131 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok131,
		TrainingDate131,
		ModelName132,
		CASE WHEN RequiredLevel132 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel132,
		CASE WHEN RequiredLevel132 > 0 THEN
			CASE WHEN AchievedLevel132 >= RequiredLevel132 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel132 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel132,
		CASE 
			WHEN RequiredLevel132 > 0 AND Ok132 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel132 > 0 AND Ok132 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok132,
		TrainingDate132,
		ModelName133,
		CASE WHEN RequiredLevel133 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel133,
		CASE WHEN RequiredLevel133 > 0 THEN
			CASE WHEN AchievedLevel133 >= RequiredLevel133 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel133 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel133,
		CASE 
			WHEN RequiredLevel133 > 0 AND Ok133 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel133 > 0 AND Ok133 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok133,
		TrainingDate133,
		ModelName134,
		CASE WHEN RequiredLevel134 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel134,
		CASE WHEN RequiredLevel134 > 0 THEN
			CASE WHEN AchievedLevel134 >= RequiredLevel134 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel134 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel134,
		CASE 
			WHEN RequiredLevel134 > 0 AND Ok134 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel134 > 0 AND Ok134 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok134,
		TrainingDate134,
		ModelName135,
		CASE WHEN RequiredLevel135 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel135,
		CASE WHEN RequiredLevel135 > 0 THEN
			CASE WHEN AchievedLevel135 >= RequiredLevel135 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel135 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel135,
		CASE 
			WHEN RequiredLevel135 > 0 AND Ok135 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel135 > 0 AND Ok135 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok135,
		TrainingDate135,
		ModelName136,
		CASE WHEN RequiredLevel136 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel136,
		CASE WHEN RequiredLevel136 > 0 THEN
			CASE WHEN AchievedLevel136 >= RequiredLevel136 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel136 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel136,
		CASE 
			WHEN RequiredLevel136 > 0 AND Ok136 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel136 > 0 AND Ok136 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok136,
		TrainingDate136,
		ModelName137,
		CASE WHEN RequiredLevel137 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel137,
		CASE WHEN RequiredLevel137 > 0 THEN
			CASE WHEN AchievedLevel137 >= RequiredLevel137 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel137 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel137,
		CASE 
			WHEN RequiredLevel137 > 0 AND Ok137 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel137 > 0 AND Ok137 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok137,
		TrainingDate137,
		ModelName138,
		CASE WHEN RequiredLevel138 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel138,
		CASE WHEN RequiredLevel138 > 0 THEN
			CASE WHEN AchievedLevel138 >= RequiredLevel138 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel138 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel138,
		CASE 
			WHEN RequiredLevel138 > 0 AND Ok138 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel138 > 0 AND Ok138 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok138,
		TrainingDate138,
		ModelName139,
		CASE WHEN RequiredLevel139 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel139,
		CASE WHEN RequiredLevel139 > 0 THEN
			CASE WHEN AchievedLevel139 >= RequiredLevel139 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel139 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel139,
		CASE 
			WHEN RequiredLevel139 > 0 AND Ok139 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel139 > 0 AND Ok139 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok139,
		TrainingDate139,
		ModelName140,
		CASE WHEN RequiredLevel140 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel140,
		CASE WHEN RequiredLevel140 > 0 THEN
			CASE WHEN AchievedLevel140 >= RequiredLevel140 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel140 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel140,
		CASE 
			WHEN RequiredLevel140 > 0 AND Ok140 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel140 > 0 AND Ok140 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok140,
		TrainingDate140,
		
		ModelName141,
		CASE WHEN RequiredLevel141 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel141,
		CASE WHEN RequiredLevel141 > 0 THEN
			CASE WHEN AchievedLevel141 >= RequiredLevel141 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel141 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel141,
		CASE 
			WHEN RequiredLevel141 > 0 AND Ok141 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel141 > 0 AND Ok141 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok141,
		TrainingDate141,
		ModelName142,
		CASE WHEN RequiredLevel142 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel142,
		CASE WHEN RequiredLevel142 > 0 THEN
			CASE WHEN AchievedLevel142 >= RequiredLevel142 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel142 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel142,
		CASE 
			WHEN RequiredLevel142 > 0 AND Ok142 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel142 > 0 AND Ok142 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok142,
		TrainingDate142,
		ModelName143,
		CASE WHEN RequiredLevel143 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel143,
		CASE WHEN RequiredLevel143 > 0 THEN
			CASE WHEN AchievedLevel143 >= RequiredLevel143 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel143 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel143,
		CASE 
			WHEN RequiredLevel143 > 0 AND Ok143 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel143 > 0 AND Ok143 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok143,
		TrainingDate143,
		ModelName144,
		CASE WHEN RequiredLevel144 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel144,
		CASE WHEN RequiredLevel144 > 0 THEN
			CASE WHEN AchievedLevel144 >= RequiredLevel144 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel144 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel144,
		CASE 
			WHEN RequiredLevel144 > 0 AND Ok144 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel144 > 0 AND Ok144 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok144,
		TrainingDate144,
		ModelName145,
		CASE WHEN RequiredLevel145 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel145,
		CASE WHEN RequiredLevel145 > 0 THEN
			CASE WHEN AchievedLevel145 >= RequiredLevel145 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel145 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel145,
		CASE 
			WHEN RequiredLevel145 > 0 AND Ok145 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel145 > 0 AND Ok145 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok145,
		TrainingDate145,
		ModelName146,
		CASE WHEN RequiredLevel146 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel146,
		CASE WHEN RequiredLevel146 > 0 THEN
			CASE WHEN AchievedLevel146 >= RequiredLevel146 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel146 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel146,
		CASE 
			WHEN RequiredLevel146 > 0 AND Ok146 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel146 > 0 AND Ok146 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok146,
		TrainingDate146,
		ModelName147,
		CASE WHEN RequiredLevel147 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel147,
		CASE WHEN RequiredLevel147 > 0 THEN
			CASE WHEN AchievedLevel147 >= RequiredLevel147 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel147 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel147,
		CASE 
			WHEN RequiredLevel147 > 0 AND Ok147 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel147 > 0 AND Ok147 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok147,
		TrainingDate147,
		ModelName148,
		CASE WHEN RequiredLevel148 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel148,
		CASE WHEN RequiredLevel148 > 0 THEN
			CASE WHEN AchievedLevel148 >= RequiredLevel148 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel148 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel148,
		CASE 
			WHEN RequiredLevel148 > 0 AND Ok148 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel148 > 0 AND Ok148 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok148,
		TrainingDate148,
		ModelName149,
		CASE WHEN RequiredLevel149 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel149,
		CASE WHEN RequiredLevel149 > 0 THEN
			CASE WHEN AchievedLevel149 >= RequiredLevel149 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel149 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel149,
		CASE 
			WHEN RequiredLevel149 > 0 AND Ok149 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel149 > 0 AND Ok149 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok149,
		TrainingDate149,
		ModelName150,
		CASE WHEN RequiredLevel150 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel150,
		CASE WHEN RequiredLevel150 > 0 THEN
			CASE WHEN AchievedLevel150 >= RequiredLevel150 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel150 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel150,
		CASE 
			WHEN RequiredLevel150 > 0 AND Ok150 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel150 > 0 AND Ok150 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok150,
		TrainingDate150,
		
		ModelName151,
		CASE WHEN RequiredLevel151 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel151,
		CASE WHEN RequiredLevel151 > 0 THEN
			CASE WHEN AchievedLevel151 >= RequiredLevel151 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel151 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel151,
		CASE 
			WHEN RequiredLevel151 > 0 AND Ok151 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel151 > 0 AND Ok151 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok151,
		TrainingDate151,
		ModelName152,
		CASE WHEN RequiredLevel152 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel152,
		CASE WHEN RequiredLevel152 > 0 THEN
			CASE WHEN AchievedLevel152 >= RequiredLevel152 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel152 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel152,
		CASE 
			WHEN RequiredLevel152 > 0 AND Ok152 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel152 > 0 AND Ok152 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok152,
		TrainingDate152,
		ModelName153,
		CASE WHEN RequiredLevel153 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel153,
		CASE WHEN RequiredLevel153 > 0 THEN
			CASE WHEN AchievedLevel153 >= RequiredLevel153 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel153 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel153,
		CASE 
			WHEN RequiredLevel153 > 0 AND Ok153 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel153 > 0 AND Ok153 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok153,
		TrainingDate153,
		ModelName154,
		CASE WHEN RequiredLevel154 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel154,
		CASE WHEN RequiredLevel154 > 0 THEN
			CASE WHEN AchievedLevel154 >= RequiredLevel154 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel154 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel154,
		CASE 
			WHEN RequiredLevel154 > 0 AND Ok154 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel154 > 0 AND Ok154 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok154,
		TrainingDate154,
		ModelName155,
		CASE WHEN RequiredLevel155 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel155,
		CASE WHEN RequiredLevel155 > 0 THEN
			CASE WHEN AchievedLevel155 >= RequiredLevel155 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel155 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel155,
		CASE 
			WHEN RequiredLevel155 > 0 AND Ok155 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel155 > 0 AND Ok155 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok155,
		TrainingDate155,
		ModelName156,
		CASE WHEN RequiredLevel156 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel156,
		CASE WHEN RequiredLevel156 > 0 THEN
			CASE WHEN AchievedLevel156 >= RequiredLevel156 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel156 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel156,
		CASE 
			WHEN RequiredLevel156 > 0 AND Ok156 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel156 > 0 AND Ok156 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok156,
		TrainingDate156,
		ModelName157,
		CASE WHEN RequiredLevel157 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel157,
		CASE WHEN RequiredLevel157 > 0 THEN
			CASE WHEN AchievedLevel157 >= RequiredLevel157 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel157 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel157,
		CASE 
			WHEN RequiredLevel157 > 0 AND Ok157 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel157 > 0 AND Ok157 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok157,
		TrainingDate157,
		ModelName158,
		CASE WHEN RequiredLevel158 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel158,
		CASE WHEN RequiredLevel158 > 0 THEN
			CASE WHEN AchievedLevel158 >= RequiredLevel158 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel158 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel158,
		CASE 
			WHEN RequiredLevel158 > 0 AND Ok158 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel158 > 0 AND Ok158 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok158,
		TrainingDate158,
		ModelName159,
		CASE WHEN RequiredLevel159 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel159,
		CASE WHEN RequiredLevel159 > 0 THEN
			CASE WHEN AchievedLevel159 >= RequiredLevel159 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel159 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel159,
		CASE 
			WHEN RequiredLevel159 > 0 AND Ok159 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel159 > 0 AND Ok159 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok159,
		TrainingDate159,
		ModelName160,
		CASE WHEN RequiredLevel160 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel160,
		CASE WHEN RequiredLevel160 > 0 THEN
			CASE WHEN AchievedLevel160 >= RequiredLevel160 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel160 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel160,
		CASE 
			WHEN RequiredLevel160 > 0 AND Ok160 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel160 > 0 AND Ok160 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok160,
		TrainingDate160,
		
		ModelName161,
		CASE WHEN RequiredLevel161 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel161,
		CASE WHEN RequiredLevel161 > 0 THEN
			CASE WHEN AchievedLevel161 >= RequiredLevel161 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel161 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel161,
		CASE 
			WHEN RequiredLevel161 > 0 AND Ok161 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel161 > 0 AND Ok161 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok161,
		TrainingDate161,
		ModelName162,
		CASE WHEN RequiredLevel162 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel162,
		CASE WHEN RequiredLevel162 > 0 THEN
			CASE WHEN AchievedLevel162 >= RequiredLevel162 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel162 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel162,
		CASE 
			WHEN RequiredLevel162 > 0 AND Ok162 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel162 > 0 AND Ok162 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok162,
		TrainingDate162,
		ModelName163,
		CASE WHEN RequiredLevel163 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel163,
		CASE WHEN RequiredLevel163 > 0 THEN
			CASE WHEN AchievedLevel163 >= RequiredLevel163 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel163 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel163,
		CASE 
			WHEN RequiredLevel163 > 0 AND Ok163 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel163 > 0 AND Ok163 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok163,
		TrainingDate163,
		ModelName164,
		CASE WHEN RequiredLevel164 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel164,
		CASE WHEN RequiredLevel164 > 0 THEN
			CASE WHEN AchievedLevel164 >= RequiredLevel164 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel164 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel164,
		CASE 
			WHEN RequiredLevel164 > 0 AND Ok164 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel164 > 0 AND Ok164 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok164,
		TrainingDate164,
		ModelName165,
		CASE WHEN RequiredLevel165 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel165,
		CASE WHEN RequiredLevel165 > 0 THEN
			CASE WHEN AchievedLevel165 >= RequiredLevel165 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel165 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel165,
		CASE 
			WHEN RequiredLevel165 > 0 AND Ok165 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel165 > 0 AND Ok165 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok165,
		TrainingDate165,
		ModelName166,
		CASE WHEN RequiredLevel166 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel166,
		CASE WHEN RequiredLevel166 > 0 THEN
			CASE WHEN AchievedLevel166 >= RequiredLevel166 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel166 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel166,
		CASE 
			WHEN RequiredLevel166 > 0 AND Ok166 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel166 > 0 AND Ok166 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok166,
		TrainingDate166,
		ModelName167,
		CASE WHEN RequiredLevel167 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel167,
		CASE WHEN RequiredLevel167 > 0 THEN
			CASE WHEN AchievedLevel167 >= RequiredLevel167 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel167 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel167,
		CASE 
			WHEN RequiredLevel167 > 0 AND Ok167 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel167 > 0 AND Ok167 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok167,
		TrainingDate167,
		ModelName168,
		CASE WHEN RequiredLevel168 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel168,
		CASE WHEN RequiredLevel168 > 0 THEN
			CASE WHEN AchievedLevel168 >= RequiredLevel168 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel168 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel168,
		CASE 
			WHEN RequiredLevel168 > 0 AND Ok168 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel168 > 0 AND Ok168 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok168,
		TrainingDate168,
		ModelName169,
		CASE WHEN RequiredLevel169 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel169,
		CASE WHEN RequiredLevel169 > 0 THEN
			CASE WHEN AchievedLevel169 >= RequiredLevel169 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel169 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel169,
		CASE 
			WHEN RequiredLevel169 > 0 AND Ok169 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel169 > 0 AND Ok169 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok169,
		TrainingDate169,
		ModelName170,
		CASE WHEN RequiredLevel170 > 0 THEN NCHAR(8730) ELSE '-' END AS RequiredLevel170,
		CASE WHEN RequiredLevel170 > 0 THEN
			CASE WHEN AchievedLevel170 >= RequiredLevel170 THEN NCHAR(8730) ELSE 'x' END
			ELSE CASE WHEN AchievedLevel170 > 0 THEN NCHAR(8730) ELSE '-' END
		END AS AchievedLevel170,
		CASE 
			WHEN RequiredLevel170 > 0 AND Ok170 = 1 THEN NCHAR(8730) 
			WHEN RequiredLevel170 > 0 AND Ok170 = 0 THEN 'x' 
			ELSE '-' 
		END AS Ok170,
		TrainingDate170		
	INTO #RetVal2
	FROM #RetVal
		INNER JOIN Personnel AS P1
			ON #RetVal.PersonnelId = P1.PersonnelId
		LEFT JOIN Organisation
			ON P1.OrganisationId = Organisation.OrganisationId
		LEFT JOIN Branch
			ON P1.BranchId = Branch.BranchId
		LEFT JOIN [Site]
			ON P1.SiteId = [Site].SiteId
		LEFT JOIN Location
			ON P1.LocationId = Location.LocationId
		LEFT JOIN StaffGrade
			ON P1.StaffGradeId = StaffGrade.StaffGradeId

	--
	-- Sort depending on parameters
	DECLARE @SortOrder NVARCHAR(500)
	SET @SortOrder = 'Location, LastName, FirstName'

	IF @PersonId IS NULL
	BEGIN
		IF @LocationId IS NULL
			SET @SortOrder = 'Location'

		IF @BranchId IS NULL
		BEGIN
			IF @SortOrder IS NULL			
				SET @SortOrder = 'Service'
			ELSE
				SET @SortOrder = @SortOrder + ', Service'
		END
	END

	IF @SortOrder IS NULL			
		SET @SortOrder = 'Location, LastName, FirstName'

	SET @SortOrder = 'Location, LastName, FirstName'

	SET @Sql = N'SELECT * FROM #RetVal2 ORDER BY ' + @SortOrder
	EXEC SP_EXECUTESQL @Sql

	SELECT ISNULL(Location, '<Unknown>') AS Location, SUM(ISNULL(NULLIF(RequiredCount, -99), 0)), SUM(ISNULL(NULLIF(AchievedCount, -99),0))
	FROM #RetVal2
	WHERE ISNULL(RequiredCount, 0) != -99 AND
		ISNULL(AchievedCount, 0) != -99
	GROUP BY Location
	ORDER BY Location

	SELECT ISNULL([Service], '<Unknown>') AS [Service], SUM(ISNULL(NULLIF(RequiredCount, -99), 0)), SUM(ISNULL(NULLIF(AchievedCount, -99),0))
	FROM #RetVal2
	WHERE ISNULL(RequiredCount, 0) != -99 AND
		ISNULL(AchievedCount, 0) != -99
	GROUP BY [Service]
	ORDER BY [Service]

	DROP TABLE #RetVal
END